-------------------------------------------------------------------------------
--
--		Knife Party - "Superstar"
--		Bubble Tea Invitational 2.5
--		
--		Author: 	Telperion
--		Date: 		2017-05-06
--		Target:		SM5.0.12+
--
-------------------------------------------------------------------------------
--
--		Oh my god.
--		What the fuck is this disco shit?
--		What happened to the dup step?
--
-------------------------------------------------------------------------------

local circumvention = false
if circumvention then
	return Def.ActorFrame {}
end

local sw = SCREEN_WIDTH
local sh = SCREEN_HEIGHT
local BPS = GAMESTATE:GetSongBPS()
local ofs = 0.009
local overtime = 0
local visualOffset = -0.01
local fgmsg = 0
local checked = false
local plr = {nil, nil}

local PI = math.pi
local LOG2 = math.log(2.0)
local DEG_TO_RAD = math.pi / 180.0



--
--	Texture constants
--
local ttw = math.pow(2, math.ceil(math.log(sw) / LOG2))
local tth = math.pow(2, math.ceil(math.log(sh) / LOG2))
local twscale = sw / ttw
local thscale = sh / tth

--
-- 	some funktion !
--
function SideSign(i) return (i == 2) and 1 or -1 end

function RangeScale(t, inLower, inUpper, outLower, outUpper)
	local ti = (t - inLower) / (inUpper - inLower)
	return outLower + ti * (outUpper - outLower)
end

function RangeClamp(t, outLower, outUpper)
	local ti = t
	ti = (ti < outLower) and outLower or ti
	ti = (ti > outUpper) and outUpper or ti
	return ti
end

function Whomst(act)
	return tonumber(string.match(act:GetName(), "P([0-9]+)"))
end

function Whichst(act)
	return tonumber(string.match(act:GetName(), "_([0-9]+)"))
end

function SortModsTable(mt)
	-- Insertion sort into the butt
	-- because wow I'm mostly lazy
	-- and can assume it's mostly sorted

	mtNew = {}

	for _,mr in pairs(mt) do
		local insertLocation = 1
		for i = #mtNew,1,-1 do
--			Trace("### SortModsTable: "..mtNew[i][1].." vs. "..mr[1])
			if mtNew[i][1] <= mr[1] then
				insertLocation = i+1
				break
			end
		end
--		Trace("### SortModsTable: "..mr[1].." ("..mr[2]..") -> "..insertLocation)
		table.insert(mtNew, insertLocation, mr)
	end

	return mtNew
end


-- I grabbed most of this out of ScreenTestInput underlay #codereuseboys
local function input(event)
	if not event.PlayerNumber or not event.button then
		return false
	end
	
	-- Only trigger an event when the button is first pressed.
	local state = "Released"
	if event.type == "InputEventType_FirstPress" then
		state = "Pressed"		
	end

	local pn = tonumber(string.match(event.PlayerNumber, "[0-9]"))

	-- D = 0, L = 1, U = 2, R = 3
	local bn = 0
	if 		event.button == "Left" 	then bn = 1
	elseif 	event.button == "Right"	then bn = 3
	elseif 	event.button == "Up" 	then bn = 2
	end
		
	MESSAGEMAN:Broadcast("Input"..state, {pn, bn})
	return false
end


local _DZ_ = Def.ActorFrame {}
local _FG_ = Def.ActorFrame {
	InitCommand = function(self)
		self:fov(45)
			:vanishpoint(sw/2, sh/4)			
			:SetDrawByZPosition(true)
	end,
	OnCommand = function(self)
		plr[1] = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
		plr[2] = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
		SCREENMAN:GetTopScreen():SetDrawByZPosition(true)


		local hamburger = SCREENMAN:GetTopScreen()
		if hamburger:GetScreenType() == "ScreenType_Gameplay" then
			hamburger:GetChild("Overlay" ):decelerate(4.0 / BPS):diffusealpha(0.0)
			hamburger:GetChild("Underlay"):decelerate(4.0 / BPS):diffusealpha(0.0)
		end

		-- To enable the Superstar Drawing Game
		hamburger:AddInputCallback(input)
				
		local playersFound = 0
		for pn = 1,2 do
			pv = plr[pn]
			if pv then
				pv:GetChild("Combo"):hibernate(1573)
			end
			
			pops = GAMESTATE:GetPlayerState("PlayerNumber_P"..pn):GetPlayerOptions("ModsLevel_Song")
			pops:FailSetting('FailType_Off')
		end

		self:sleep(1573)
	end
};





-------------------------------------------------------------------------------
--
--	The discotheque
--

--
--		Instead of projecting the ghost to a rectangular Sprite, we're gonna
--		try slapping it on a distorted ActorMultiVertex instead.
--		Setting up the vertex coordinates for that takes a little bit of work.
--
--		This is a physical vertex shifter.
--		For the textural vertex shifter (gradient), used in Spectrum's ghosting,
--		go consult that file's FG change! 
--
local stretchyRows = 35					-- assuming 16:9
local stretchyCols = 63					-- assuming 16:9
local stretchyDX = sw/stretchyCols
local stretchyDY = sh/stretchyRows
local texturalDX = twscale/stretchyCols
local texturalDY = thscale/stretchyRows
local qq = math.sqrt(sw * sh) * 0.05	-- I don't think we'll use this but w/e

local nDiscoProxies 	= 2
local Discothextures 	= {}
local DiscoProxies 	 	= {{}, {}}
local DiscoMirrors		= {}

local mirrorRows 		= 10			-- assuming pi:2
local mirrorCols 		= 16			-- assuming pi:2
local mirrorDX 			= sw/(mirrorCols-1)
local mirrorDY 			= sh/mirrorRows
local mirrorWidth		= mirrorCols/(mirrorCols-1)
local mirrorShining	 	= {}
local mirrorShinePrime	= 163			-- wew lad
local mirrorShineSeed	= 5
local mirrorShinyMin	= 0.05
local mirrorShinyMax	= 0.65

local discoBallSize 	= 0.7			-- in proportion of screen height
local discoStartTime	= 1573			-- in beats
local discoTweenTime	= 0				-- in beats
local discoProxyPeriod 	= 16			-- in beats

function CalculateRowBaseVertices(rowIndex)
	verts = {}
	
	--
	-- 1--3--5--7-...
	-- |  |  |  |
	-- 2--4--6--8-...
	--
	for tateIndex = 0, stretchyCols do
		verts[#verts+1] = {
			{tateIndex * stretchyDX - sw/2, (rowIndex-1) * stretchyDY - sh/2, 0},
			Color.White,
			{tateIndex * texturalDX, (rowIndex-1) * texturalDY}
		}
		verts[#verts+1] = {
			{tateIndex * stretchyDX - sw/2,  rowIndex    * stretchyDY - sh/2, 0},
			Color.White,
			{tateIndex * texturalDX,  rowIndex    * texturalDY}
		}
	end
	
	return verts
end

function Stretcher_NullShift(x, y, z, a)
	return 0, 0, 0
end

function CalculateStretchedTextures(verts, stretcher, soul)
	stretcher = stretcher or Stretcher_NullShift
	soul = soul or 0
	
	-- Coordinate the texture all at once.
	for vertIndex = 1,#verts do
		local x = verts[vertIndex][1][1] / sw
		local y = verts[vertIndex][1][2] / sh
		local z = verts[vertIndex][1][3] / qq
		
		-- The stretching function operates on [-1, 1] × [-1, 1].
		-- The magnitude of the stretcher is expected to be scaled to that same space.
		-- The third parameter is used to parameterize the shape of the stretcher.
		xn, yn, zn = stretcher(2*x, 2*y, 2*z, soul)
		
		-- Apply the stretcher onto the vertices after scaling to texture space.
		-- Note that this is a replacement operation, so don't compound this function.
		verts[vertIndex][1][1] = xn * 0.5 * sw
		verts[vertIndex][1][2] = yn * 0.5 * sh
		verts[vertIndex][1][3] = zn * 0.5 * qq
	end

	return verts	
end


function Stretcher_DiscoWall(x, y, z, a)
	local xn = x * (1 + a - a*y*y)
	local yn = y * (1 +     a*x*x)
	local zn =      		a*x*x*y*y
	return xn, yn, zn
end


function Stretcher_DiscoBall(x, y, z, a)
	local vn = math.sqrt(1 - y*y*a*a)
	local xn = vn * math.sin(PI/2 * x)
	local yn = y*a
	local zn = vn * math.cos(PI/2 * x)
	return xn, yn, zn
end


function CalculateSilver(i, t, a)
	local pp = mirrorShining[i] * a
	local tt = math.fmod(t * pp, 1)
	tt = (tt < 0.5) and 2*tt or 2*(1 - tt)
	local tsq = tt*tt
	return tsq*tsq
end


DiscoWallAMV = nil
DiscoBallAMV = nil

DiscoWallPrefetch = nil
DiscoBallPrefetch = nil

function substrateAMV(stratagem)
	local stretchyAMV = 
		Def.ActorFrame {
			Name = stratagem
		}

	for rowIndex = 1,stretchyRows do
		stretchyAMV[#stretchyAMV + 1] =	Def.ActorMultiVertex {
				Name = "StretchyAMVStrip_"..rowIndex,
				InitCommand = function(self)
					local verts = CalculateRowBaseVertices(rowIndex)
					self:aux(rowIndex)
					self:xy(0, 0)
						:SetVertices(verts)
						:SetDrawState{First = 1,
									  Num = (stretchyCols + 1) * 2,
									  Mode = "DrawMode_QuadStrip"}
				end,
			}
	end

	return stretchyAMV
end

DiscoWallProto = substrateAMV("DiscoWallAMV")
DiscoWallProto["InitCommand"] = function(self)
	self:xy(sw/2, sh/2)
	DiscoWallAMV = self
end
_FG_[#_FG_ + 1] = DiscoWallProto

DiscoBallProto = substrateAMV("DiscoBallAMV")
DiscoBallProto["InitCommand"] = function(self)
	self:xy(sw/2, -sh*discoBallSize/2)
		:zoomx(discoBallSize * sh/sw)
		:zoomy(discoBallSize)
	DiscoBallAMV = self
end
_FG_[#_FG_ + 1] = DiscoBallProto


DiscoBallPrefetch = {}
for rowIndex = 1,stretchyRows do
	local verts = CalculateRowBaseVertices(rowIndex)
	verts = CalculateStretchedTextures(verts, Stretcher_DiscoBall, 0.98)
	DiscoBallPrefetch[#DiscoBallPrefetch + 1] = verts
end

DiscoWallPrefetch = {}
for rowIndex = 1,stretchyRows do
	local verts = CalculateRowBaseVertices(rowIndex)
	verts = CalculateStretchedTextures(verts, Stretcher_DiscoWall, 0.3)
	DiscoWallPrefetch[#DiscoWallPrefetch + 1] = verts
end


-- Textures of interest
for i = 1,2 do	
	local DiscoProjection = Def.ActorFrameTexture {
		Name = "Discothexture_" .. i,
		InitCommand = function(self)
			self:SetTextureName( self:GetName() )
				:SetWidth( sw )
				:SetHeight( sh )
				:EnableAlphaBuffer( true )
				:Create()

			DiscoScreen = nil
			if i == 1 then
				DiscoScreen = DiscoBallAMV
			else
				DiscoScreen = DiscoWallAMV
			end

			for rowIndex=1,stretchyRows do
				DiscoScreen:GetChild("StretchyAMVStrip_"..rowIndex)
						   :SetTexture( self:GetTexture() )
			end
		end,
	}

	if i == 1 then
		for rowIndex = 1,mirrorRows do
			for colIndex = 1,mirrorCols do
				DiscoProjection[#DiscoProjection + 1] = Def.Quad {
					InitCommand = function(self)
						self:xy(mirrorDX * (colIndex - 0.5), mirrorDY * (rowIndex - 0.5))
							:z(-1)
							:SetWidth(mirrorDX)
							:SetHeight(mirrorDY)
							:diffuse(rowIndex / mirrorRows, colIndex / mirrorCols, 0.5, 0.99)
						DiscoMirrors[(rowIndex-1) * mirrorCols + colIndex] = self
					end,
				}
			end
		end
	end

	for pn = 1,2 do
		for proxyIndex = 1,nDiscoProxies do
			DiscoProjection[#DiscoProjection + 1] = Def.ActorFrame {
				Name = "ProxyP"..pn.."Outer_"..proxyIndex,
				Def.ActorFrame {	
					Name = "ProxyP"..pn.."Inner_"..proxyIndex,
					Def.ActorProxy {					
						Name = "ProxyP"..pn,
						InitCommand = function(self)
							self:aux( Whomst(self) )
						end,
						BeginCommand=function(self)
							local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
							if McCoy then self:SetTarget(McCoy) else self:hibernate(1573) end
						end,
						OnCommand=function(self)
							local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
							if McCoy then 
								self:xy(-McCoy:GetX(), -McCoy:GetY())
								self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
							end
						end,
						RecenterProxyMessageCommand=function(self)					
							local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
							if McCoy then 
								self:xy(-McCoy:GetX(), -McCoy:GetY())
								self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
							end
						end
					},
					InitCommand = function(self)
		--				self:aux( Whichst(self) )
						DiscoProxies[i][(Whichst(self) - 1) * 2 + Whomst(self)] = self
					end,
					OnCommand = function(self)
						if Whichst(self) ~= 1 then
							self:visible(false)
						end
					end,
					DiscoEngageMessageCommand = function(self)
						self:visible(true)
					end,
					RotateFieldMessageCommand = function(self, args)
						local tweenTime = args[4] and args[4] or 1
						self:decelerate(tweenTime / BPS)
							:rotationx(args[1])
							:rotationy(args[2] * SideSign(Whomst(self)))
							:rotationz(args[3] * SideSign(Whomst(self)))
					end,
					WayWayBeginMessageCommand = function(self, args)
						local magnitude = args[1] and args[1] or 96
						local tweenTime = args[2] and args[2] or 1
						self:bounce()
							:effectclock('beat')
							:effectperiod(tweenTime)
							:effectmagnitude(0, magnitude, 0)
					end,
					WayWayEndMessageCommand = function(self)
						self:stopeffect()
					end,
				},
				InitCommand = function(self)
		--			self:aux( Whichst(self) )
				end,
				OnCommand = function(self)
					self:xy(0, 0)
						:z(1)
				end,
			}
		end
	end


	_FG_[#_FG_ + 1] = DiscoProjection
end


--
--	The discotheque
--
-------------------------------------------------------------------------------




-------------------------------------------------------------------------------
--
--	You get a gold star! 
--	*You* get a gold star!
--	**Everybody** gets a gold star!!
--

-- P1, P2, PTutorial
local knifeStartTime		= 69420

local knifeArrowZoomMax		= 0.8
local knifeArrowZoomMin		= 0.4
local knifeArrowZoomAvg		= 0.75
local knifeStarPointMax		= 10
local knifeArrowPathWidth	= 8

local knifeOuterRadius		= 160 - 32 * knifeArrowZoomMax 		-- Outer ring
local knifeInnerRadius		= 100 - 32 * knifeArrowZoomMax 		-- Inner ring


local knifeScore 			= {0, 0, 0}
local knifePatternActive 	= {{}, {}, {}}
local knifeArrowActive 		= {1, 1, 1}

local knifeTraceAMV			= {nil, nil, nil}
local knifeCurrentAMV		= {nil, nil, nil}
local knifeCurrentColors	= {{1, 0, 0, 1}, {0, 0, 1, 1}, {0, 1, 0, 1}}
local knifeArrowActors		= {{}, {}, {}}
local knifeArrowCenters		= {{}, {}, {}}
local knifeArrowTexCoords	= {{0.625, 0.000}, {0.875, 0.125}, {0.375, 0.250}}		-- 32nd -> 4th; 64th -> 8th; 16th -> 12tb
local knifeRingActors		= {nil, nil, nil}
local knifeRingContainers	= {nil, nil, nil}

local knifeWrongPenalty		= 1.0								-- 8eats
local knifeAllowInput		= {false, false, true}
local knifePenaltyBox		= {0, 0, 0}


local knifeScoreSprites		= {{nil, nil}, {nil, nil}, {nil, nil}}
local knifeScoreContainers	= {nil, nil, nil}

local knifePatternsOrig		= {
	-- Lengths: 5, 6, 4, 7, 5, 8, 6, 5, 9, 4, 7, 10, 6, 9
	-- 
	-- D = 0, L = 1, U = 2, R = 3

	{1,0,1,3,0,3,1,2,1,3},						-- LDLRDRLULR
	{3,0,2,1,2,0,3,1,0,2,0,1},					-- RDULUDRLDUDL
	{1,0,2,3,0,2,1,3},							-- LDURDULR
	{1,0,1,0,2,3,2,3,1,2,0,3,0,2},				-- LDLDURURLUDRDU
	{3,3,1,0,0,2,3,1,1,2},						-- RRLDDURLLU
	{1,0,2,0,1,0,2,0,1,3,0,2,0,3,0,2},			-- LDUDLDUDLRDUDRDU
	{3,0,1,0,3,0,1,0,3,2,0,1},					-- RDLDRDLDRUDL
	{1,0,3,1,2,3,1,0,2,3},						-- LDRLURLDUR
	{3,0,3,1,0,2,3,1,2,1,3,2,0,1,3,0,2,1},		-- RDRLDURLULRUDLRDUL
	{3,0,1,2,3,0,1,2},							-- RDLURDLU
	{1,3,2,1,3,0,1,3,0,1,3,2,1,3},				-- LRULRDLRDLRULR
	{1,3,0,2,0,3,1,0,2,3,2,0,1,2,0,3,0,2,1,0},	-- LRDUDRLDURUDLUDRDULD
	{3,0,1,3,2,0,1,0,3,1,2,0},					-- RDLRUDLDRLUD
	{1,0,2,3,1,2,0,3,1,0,2,3,1,2,0,2,1,3},		-- LDURLUDRLDURLUDULR
	{1,2,0,1,3,2,1,0,3,1},						-- LUDLRULDRL
	{3,0,2,0,1,0,2,0,3,2,0,2,1,3},				-- RDUDLDUDRUDULR
	{3,0,1,2,1,0,3,2,3,0,1,2,0,3,1,2},			-- RDLULDRURDLUDRLD
	{3,3,3,2,2,1,1,1,0,0,3,1},					-- RRRUULLLDDRL
	{1,0,1,3,0,3,1,0,2,3,0,2,1,2,1,3,2,3,1,2},	-- LDLRDRLDURDULULRURLU
	{1,1,1,1,2,1,1,1},							-- LLLLULLL
	{3,3,2,3,1,1,2,1,0,0,2,0,1,3},				-- RRURLLULDDUDLR
	{1,0,2,0,1,3,1,0,2,0,1,3,0,2,0,3,1,3},		-- LDUDLRLDUDLRDUDRLR
	{3,2,3,2,0,2,0,2,1,2,1,2,0,1,3,0},			-- RURUDUDULULUDLRD
	{3,3,1,2,1,2,0,3,2,3,2,0,1,2,0,2,1,3,2,3},	-- RRLULUDRURUDLUDULRUR
	{2,2,0,0,1,3,1,3,0,2},						-- UUDDLRLRDU [tutorial 1]
	{1,2,1,2,0,3,0,3,1,0,1,0,2,3},				-- LULUDRDRLDLDUR [tutorial 2]
}
knifeScore[3] = #knifePatternsOrig-2

-- Randomize the order of stars (new since tourney version!)
-- And randomly swap L/R and U/D!!
local nPat = #knifePatternsOrig-2
local knifePatterns = {}
for i = 1,nPat do
	local insIndex = math.random(nPat)
	local insCheck = 0
	while knifePatterns[insIndex] and insCheck < nPat do
		insIndex = insIndex % nPat + 1
	end
	knifePatterns[insIndex] = knifePatternsOrig[i]
	local swapper = math.random(4)
	for j = 1,#knifePatterns[insIndex] do
		local vvv = knifePatterns[insIndex][j]
		if swapper % 2 == 1 then
			-- L/R swap
			knifePatterns[insIndex][j] = (vvv == 3 or vvv == 1) and (4-vvv) or vvv
		end
		if swapper >= 2 then
			-- U/D swap
			knifePatterns[insIndex][j] = (vvv == 2 or vvv == 0) and (2-vvv) or vvv
		end
	end
	-- SCREENMAN:SystemMessage("Inserting pattern "..i.." at "..insIndex)
end
knifePatterns[nPat+1] = knifePatternsOrig[nPat+1]
knifePatterns[nPat+2] = knifePatternsOrig[nPat+2]

local circleTicks = 21
local circleAngleTick = 2*PI / circleTicks

function CalculateCircleBaseVertices(innerRadius, outerRadius, innerAlpha, outerAlpha)
	verts = {}
	
	--
	-- 1--3--5--7-...
	-- |  |  |  |
	-- 2--4--6--8-...

	for tateIndex = 0, circleTicks do
		local thetaL = tateIndex * circleAngleTick
		local cosL = math.cos(thetaL)
		local sinL = math.sin(thetaL)

		verts[#verts+1] = {
			{cosL * innerRadius, 	sinL * innerRadius, 	0},
			{1, 1, 1, innerAlpha},
			{cosL * 0.5 + 0.5, 		sinL * 0.5 + 0.5}
		}
		verts[#verts+1] = {
			{cosL * outerRadius, 	sinL * outerRadius, 	0},
			{1, 1, 1, outerAlpha},
			{cosL * 0.5 + 0.5, 		sinL * 0.5 + 0.5}
		}
	end
	
	return verts
end


function UpConvertVertexList(vertexList, baseColor)
	verts = {}

	-- As a line (obv)
	for i,v in ipairs(vertexList) do
		verts[#verts+1] = {
			{v[1], v[2], 0},
			{baseColor[1], baseColor[2], baseColor[3], 1.0},
			{0, 0}
		}
	end

	-- Join finish to start
	verts[#verts+1] = {
		{vertexList[1][1], vertexList[1][2], 0},
		{baseColor[1], baseColor[2], baseColor[3], 1.0},
		{0, 0}
	}
	
	return verts
end



_FG_[#_FG_ + 1] = Def.ActorFrame {
	Name = "InputHandler",
	InitCommand = function(self)
	end,

	
}


for ai = 1,knifeStarPointMax do
	local cosL = math.cos(2*PI * (ai - 1.0) / knifeStarPointMax) * knifeOuterRadius
	local sinL = math.sin(2*PI * (ai - 1.0) / knifeStarPointMax) * knifeOuterRadius
	local cosR = math.cos(2*PI * (ai - 0.5) / knifeStarPointMax) * knifeInnerRadius
	local sinR = math.sin(2*PI * (ai - 0.5) / knifeStarPointMax) * knifeInnerRadius

	for pn = 1,3 do
		knifeArrowCenters[pn][2*ai - 1] = {cosL, sinL}
		knifeArrowCenters[pn][2*ai    ] = {cosR, sinR}
	end
end


for pn = 1,3 do
	_FG_[#_FG_ + 1] = Def.ActorFrame {
		Name = "KnifeScoreGroupP"..pn,
		InitCommand = function(self)
			knifeScoreContainers[pn] = self

			xc = (pn == 1) and 0.25 or (pn == 2) and 0.75 or 0.5
			self:visible(false)
				:xy(sw * xc, sh - 48)
				:zoom(2.0)
		end,


		GameStartCommand = function(self)
			self:visible(true)
				:diffusealpha(0)
				:decelerate(2.0 / BPS)
				:diffusealpha(1)
		end,

		GameOverCommand = function(self)
			self:decelerate(2.0 / BPS)
				:y(sh * 0.5)
				:zoom(4.0)
				:wag()
				:effectclock("beat")
				:effectperiod(4)
				:effectmagnitude(0, 0, 10)
		end,

		GameKillCommand = function(self)
			self:visible(false)
		end,

		Def.Sprite {
			Name = "StarGuyP"..pn,
			Texture = "starguy.png",
			InitCommand = function(self)
				self:xy(-24, 0)
					:SetWidth(16)
					:SetHeight(16)
			end,
		},
		Def.Sprite {
			Name = "StarXP"..pn,
			Texture = "starx.png",
			InitCommand = function(self)
				self:xy( -8, 0)
					:SetWidth(16)
					:SetHeight(16)
			end,
		},
		Def.Sprite {
			Name = "StarCountTensP"..pn,
			Texture = "starcount 10x1.png",
			InitCommand = function(self)
				knifeScoreSprites[pn][1] = self
				self:xy(  8, 0)
					:SetWidth(16)
					:SetHeight(16)
					:setstate(9)
					:animate(false)
			end,
		},
		Def.Sprite {
			Name = "StarCountOnesP"..pn,
			Texture = "starcount 10x1.png",
			InitCommand = function(self)
				knifeScoreSprites[pn][2] = self
				self:xy( 24, 0)
					:SetWidth(16)
					:SetHeight(16)
					:setstate(9)
					:animate(false)
			end,
		},
	}


end

for pn = 1,3 do
	local knifeRing = Def.ActorFrame {
		Name = "KnifeRingP"..pn,
		InitCommand = function(self)
			knifeRingActors[pn] = self

			xc = (pn == 1) and 0.25 or (pn == 2) and 0.75 or 0.5
			self:visible(false)
				:xy(sw * xc, sh * -0.5)
		end,

		GameStartCommand = function(self)
			self:visible(true)
				:queuecommand("NewStarE")
		end,

		GameOverCommand = function(self)
			self:decelerate(2.0 / BPS)
				:y(sh * 0.25)
				:diffusealpha(0)
		end,

		GameKillCommand = function(self)
			self:visible(false)
		end,

		TriggerNewStarCommand = function(self)
			self:finishtweening()
				:queuecommand("NewStarA")
		end,

		NewStarACommand = function(self)
			self:linear(0.25 / BPS)
				:zoom(0.8)
				:queuecommand("NewStarB")
		end,
		NewStarBCommand = function(self)
			self:linear(0.25 / BPS)
				:zoom(1.0)
				:queuecommand("NewStarC")
		end,
		NewStarCCommand = function(self)
			knifeScore[pn] = knifeScore[pn] + 1

			local knifeOnes = knifeScore[pn] % 10
			local knifeTens = (knifeScore[pn] - knifeOnes) / 10

			knifeScoreSprites[pn][1]:setstate( (knifeTens == 0) and 9 or (knifeTens - 1) )
			knifeScoreSprites[pn][2]:setstate( (knifeOnes == 0) and 9 or (knifeOnes - 1) )


			self:accelerate(1.0 / BPS)
				:y(sh * 1.5)
				:queuecommand("NewStarD")
		end,
		NewStarDCommand = function(self)
			local pn = Whomst(self)
			KnifePatternLoader(pn, knifeScore[pn] + 1)

			self:y(sh * -0.5)
				:queuecommand("NewStarE")
		end,
		NewStarECommand = function(self)
			self:decelerate(1.0 / BPS)
				:y(sh * 0.375)
		end,

	}

	local knifeRinglet = Def.ActorFrame {
		Name = "KnifeRingletP"..pn,
		InitCommand = function(self)
			knifeRingContainers[pn] = self

			self:xy(0, 0)
				:zoom(0.96)
		end,
	}

	knifeRinglet[#knifeRinglet + 1] = Def.ActorMultiVertex {
		Name = "KnifeTraceAMVP"..pn,
		InitCommand = function(self)
			local verts = UpConvertVertexList(knifeArrowCenters[pn], knifeCurrentColors[pn])

			knifeTraceAMV[pn] = self
			self:visible(false)
				:SetVertices(verts)
				:SetLineWidth(knifeArrowPathWidth)
				:SetDrawState{First = 1,
							  Num = #verts,
							  Mode = "DrawMode_LineStrip"}
				:xy(0, 0)
				:z(-0.1)
				:diffusealpha(0.3)

		end,
	}

	for ai = 1,knifeStarPointMax do
		local vertexL = knifeArrowCenters[pn][2*ai - 1]
		local vertexR = knifeArrowCenters[pn][2*ai]
		
		knifeRinglet[#knifeRinglet + 1] = NOTESKIN:LoadActorForNoteSkin("Down", "Tap Note", "cyber") .. {
			Name = "KnifeArrowActorsP"..pn.."_"..(2*ai - 1),
			InitCommand = function(self)
				knifeArrowActors[pn][2*ai - 1] = self
				self:visible(false)
					:aux(knifeOuterRadius)
					:xy(vertexL[1], vertexL[2])
					:zoom(knifeArrowZoomAvg)
					:texturetranslate(knifeArrowTexCoords[pn][1], 0)
--				Trace("Created the source note "..quantIndex.."!")
			end,
		}
		knifeRinglet[#knifeRinglet + 1] = NOTESKIN:LoadActorForNoteSkin("Down", "Tap Note", "cyber") .. {
			Name = "KnifeArrowActorsP"..pn.."_"..(2*ai),
			InitCommand = function(self)
				knifeArrowActors[pn][2*ai] = self
				self:visible(false)
					:aux(knifeInnerRadius)
					:xy(vertexR[1], vertexR[2])
					:zoom(knifeArrowZoomAvg)
					:texturetranslate(knifeArrowTexCoords[pn][1], 0)
--				Trace("Created the source note "..quantIndex.."!")
			end,
		}
	end

	knifeRinglet[#knifeRinglet + 1] = Def.ActorMultiVertex {
		Name = "KnifeCurrentAMVP"..pn,
		InitCommand = function(self)
			local verts = CalculateCircleBaseVertices(16, 32, 0.1, 1.0)
			local knifeCurrentDiffuse = {
				knifeCurrentColors[pn][1], 
				knifeCurrentColors[pn][2], 
				knifeCurrentColors[pn][3], 
				knifeCurrentColors[pn][4] * 0.2
			}

			knifeCurrentAMV[pn] = self
			self:visible(false)
				:SetVertices(verts)
				:SetDrawState{First = 1,
							  Num = (circleTicks + 1) * 2,
							  Mode = "DrawMode_QuadStrip"}
				:zoom(knifeArrowZoomMax)
				:xy(knifeArrowCenters[pn][1][1], knifeArrowCenters[pn][1][2])
				:z(0.1)
				:diffuseshift()
				:effectcolor1(knifeCurrentColors[pn])
				:effectcolor2(knifeCurrentDiffuse)
				:effectclock("beat")
				:effectperiod(2)
		end,
	}

	knifeRing[#knifeRing + 1] = knifeRinglet
	_FG_[#_FG_ + 1] = knifeRing
end


function KnifePatternLoader(pn, patternIndex)
	knifePatternActive[pn] 	= knifePatterns[patternIndex]
	knifeArrowActive[pn] 	= 1

	local patternLength = #knifePatternActive[pn]

	for ai = 1,patternLength do
		local cosL = math.cos(2*PI * (ai - 1.0) / patternLength)
		local sinL = math.sin(2*PI * (ai - 1.0) / patternLength)
		local thisRadius = (ai % 2 == 1) and knifeOuterRadius or knifeInnerRadius
		
		knifeArrowCenters[pn][ai] = {cosL * thisRadius, sinL * thisRadius}

		knifeArrowActors[pn][ai]
			:visible(true)
			:xy(cosL * thisRadius, sinL * thisRadius)
			:baserotationz(90 * knifePatternActive[pn][ai])
			:zoom(knifeArrowZoomAvg)
			:texturetranslate(knifeArrowTexCoords[pn][1], 0)
	end

	for ai = patternLength+1,2*knifeStarPointMax do
		knifeArrowActors[pn][ai]:visible(false)
		knifeArrowCenters[pn][ai] = nil
	end
			
	local verts = UpConvertVertexList(knifeArrowCenters[pn], knifeCurrentColors[pn])
	knifeTraceAMV[pn]
		:visible(true)
		:SetVertices(verts)
		:SetLineWidth(knifeArrowPathWidth)
		:SetDrawState{First = 1,
					  Num = 2,
					  Mode = "DrawMode_LineStrip"}

	knifeCurrentAMV[pn]
		:visible(true)
		:xy(knifeArrowCenters[pn][1][1], knifeArrowCenters[pn][1][2])
end


function KnifeMoveToDot(pn, dotIndex)
	local patternLength = #knifePatternActive[pn]

	-- If there are still arrows to handle, get that shit set up.
	if dotIndex <= patternLength then
		knifeTraceAMV[pn]
			:SetDrawState{Num = (dotIndex + 1)}


		knifeCurrentAMV[pn]:finishtweening()
		if knifeArrowActive[pn] < dotIndex then			
			knifeCurrentAMV[pn]
				:decelerate(0.5 * knifeWrongPenalty / BPS)
		else
			knifeCurrentAMV[pn]
				:accelerate(      knifeWrongPenalty / BPS)
		end
		knifeCurrentAMV[pn]
			:xy(knifeArrowCenters[pn][dotIndex][1], knifeArrowCenters[pn][dotIndex][2])

		knifeArrowActive[pn] = dotIndex
	end

	-- But set the state of all arrows (done or undone).
	for ai = 1,#knifePatternActive[pn] do
		if ai >= dotIndex then
			knifeArrowActors[pn][ai]
				:zoom(knifeArrowZoomAvg)
				:texturetranslate(knifeArrowTexCoords[pn][1], 0)
		else
			knifeArrowActors[pn][ai]
				:zoom(knifeArrowZoomMin)
				:texturetranslate(knifeArrowTexCoords[pn][2], 0)
		end
	end
end


function KnifeRotation(t)
	local theta = -90
	local tt = t*t
	for fi = 5,9,2 do
		local a = 30*tt / (fi*fi + tt)
		theta = theta + a*math.sin(0.5*PI*t / fi)
	end
	return theta
end


--	Instructions
knifeHelpTextActive = 1
KnifeHelpTextActors = {nil, nil}
for htIndex = 1,2 do
	_FG_[#_FG_ + 1] = Def.BitmapText {
		Name="HelpText"..htIndex,
		Font="_cocogoose 36px.ini",
		InitCommand = function(self)
			KnifeHelpTextActors[htIndex] = self

			self:settext("")

			self:xy(sw/2, 0)
				:zoom(1)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end
	}
end

--
--	You get a gold star! 
--	*You* get a gold star!
--	**Everybody** gets a gold star!!
--
-------------------------------------------------------------------------------




-------------------------------------------------------------------------------
--
-- 		Proxies (as usual)
--

--
--	Player proxies (one apiece)
--
for pn = 1,2 do
	i = 1
	_FG_[#_FG_ + 1] = Def.ActorFrame {	
		Name = "ProxyP"..pn.."Outer",
		Def.ActorFrame {	
			Name = "ProxyP"..pn.."Inner",
			Def.ActorProxy {					
				Name = "ProxyP"..pn,
				InitCommand = function(self)
					self:aux( Whomst(self) )
				end,
				BeginCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then self:SetTarget(McCoy) else self:hibernate(1573) end
				end,
				OnCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end,
				RecenterProxyMessageCommand=function(self)					
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end
			},
			InitCommand = function(self)
--				self:aux( Whichst(self) )
			end,
			OnCommand = function(self)
			end,
		},
		InitCommand = function(self)
--			self:aux( Whichst(self) )
			self:visible(false)
		end,
		OnCommand = function(self)
			self:xy(0, 0)
				:z(1)
		end,
	}
end


--
--	Judgment proxies
--
for pn = 1,2 do
	_FG_[#_FG_ + 1] = Def.ActorProxy {
		Name = "JudgeP"..pn.."Proxy",
		InitCommand = function(self)
			self:aux( Whomst(self) )
		end,
		BeginCommand = function(self)
			local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
			if McCoy then 
				local McJudge = McCoy:GetChild('Judgment')
				self:SetTarget(McJudge)
				McJudge:visible(false)
			else 
				self:hibernate(1573)
			end
		end,
		OnCommand = function(self)
			local p = self:GetParent()
						  :GetChild('ProxyP'..self:getaux().."Outer")
						  :GetChild('ProxyP'..self:getaux().."Inner")
			
			self:xy(p:GetX(), sh/2)
		end,
	}
end

--
-- 		Proxies (as usual)
--
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
--
-- 		This is where the shit will be happening.
--

local messageList = {
	{  4.00, "RecenterProxy"},

	{ 104.000,	"WayWayBegin",		{}},
	{ 112.000,	"WayWayEnd",		{}},
	{ 217.000,	"WayWayBegin",		{32}},
	{ 223.000,	"WayWayEnd",		{}},

	{176.00, "DiscoEngage", 		{14}},
	{191.00, "DiscoTime", 			{1, 16}},

	{288.00, "DiscoDisengage", 		{8}},

--	{ 16.00, "DisplayTextToPlayer", {sh * 0.3, 1.0, "Test 1"}},
--	{ 24.00, "DisplayTextToPlayer", {sh * 0.7, 2.0, "Test 2"}},
--	{ 32.00, "DisplayTextToPlayer", {sh * 0.5, 3.0, ""}},
--	{ 36.00, "DisplayTextToPlayer", {sh * 0.3, 1.5, "Test 3"}},
--	{ 40.00, "DisplayTextToPlayer", {sh * 0.7, 3.0, "Test 4"}},
--	{ 48.00, "DisplayTextToPlayer", {sh * 0.5, 3.0, ""}},

	{300.00, "DisplayTextToPlayer", {sh * 0.5, 3.0, "Hold up!"}},
	{303.00, "DisplayTextToPlayer", {sh * 0.5, 2.0, "This song's not over!"}},
	{306.00, "DisplayTextToPlayer", {sh * 0.5, 1.8, "The disco sound calls to you!"}},
	{310.00, "DisplayTextToPlayer", {sh * 0.5, 1.5, "Show the club just how much of\na superstar you really are!"}},

	{320.00, "KnifeBegin",			{3, #knifePatterns-1}},
	{320.00, "DisplayTextToPlayer", {sh * 0.8, 1.2, "Draw stars with your steps to gain points."}},
	{328.00, "DisplayTextToPlayer", {sh * 0.8, 1.5, "Hit the highlighted arrows."}},
	{336.00, "DisplayTextToPlayer", {sh * 0.8, 1.5, "Rhythm is not important."}},
	{344.00, "DisplayTextToPlayer", {sh * 0.8, 1.5, "Complete stars to gain points!"}},

	{336.00, "InputPressed",		{3, 2}},	-- tutorial 1 begin
	{337.00, "InputPressed",		{3, 2}},
	{338.50, "InputPressed",		{3, 0}},
	{339.00, "InputPressed",		{3, 0}},
	{339.50, "InputPressed",		{3, 1}},
	{340.00, "InputPressed",		{3, 3}},
	{342.00, "InputPressed",		{3, 1}},
	{344.00, "InputPressed",		{3, 3}},
	{344.25, "InputPressed",		{3, 0}},
	{344.50, "InputPressed",		{3, 2}},	-- tutorial 1 end
	{349.00, "InputPressed",		{3, 1}},	-- tutorial 2 begin
	{350.33, "InputPressed",		{3, 2}},
	{350.50, "InputPressed",		{3, 1}},
	{351.00, "InputPressed",		{3, 2}},

	{352.00, "DisplayTextToPlayer", {sh * 0.8, 1.2, "If you do nothing but set a foot wrong,"}},
	{358.00, "DisplayTextToPlayer", {sh * 0.8, 1.5, "you will erase your progress."}},
	{368.00, "DisplayTextToPlayer", {sh * 0.8, 1.5, ""}},

	{354.00, "InputPressed",		{3, 3}},
	{356.00, "InputPressed",		{3, 3}},
	{358.00, "InputPressed",		{3, 3}},
	{360.00, "InputPressed",		{3, 3}},
	{362.00, "InputPressed",		{3, 3}},

	{368.00, "KnifeEnd",			{3}},
	{372.00, "DisplayTextToPlayer", {sh * 0.8, 1.0, "I will manually add these points to your score.\nOne star = 1/2 percent."}},
	{384.00, "KnifeKill",			{3}},

	{384.00, "DisplayTextToPlayer", {sh * 0.5, 1.0, "You have one minute."}},
	{398.00, "DisplayTextToPlayer", {sh * 0.7, 2.0, "Ready?"}},
	{400.00, "DisplayTextToPlayer", {sh * 0.8, 3.0, "Go!"}},
	{402.00, "DisplayTextToPlayer", {sh * 0.5, 3.0, ""}},
	{400.00, "KnifeBegin",			{1}},
	{400.00, "KnifeBegin",			{2}},

	{528.00, "KnifeEnd",			{1}},
	{528.00, "KnifeEnd",			{2}},
};

function MsgAddShineRotations(startBeat, xyMag, zMag)
	messageList[#messageList + 1] = {startBeat +   0.000,	"RotateField",		{-xyMag, -xyMag,	 -zMag}}
	messageList[#messageList + 1] = {startBeat +   3.520,	"RotateField",		{-xyMag,  xyMag,	  zMag}}
	messageList[#messageList + 1] = {startBeat +   8.000,	"RotateField",		{ xyMag,  xyMag*0.5,  zMag}}
	messageList[#messageList + 1] = {startBeat +   9.520,	"RotateField",		{-xyMag,   0,   	  0}}
	messageList[#messageList + 1] = {startBeat +  12.000,	"RotateField",		{ xyMag, -xyMag*0.5, -zMag}}
	messageList[#messageList + 1] = {startBeat +  13.520,	"RotateField",		{-xyMag,   0,		  0}}
	messageList[#messageList + 1] = {startBeat +  16.000,	"RotateField",		{-xyMag, -xyMag,	 -zMag}}
	messageList[#messageList + 1] = {startBeat +  19.520,	"RotateField",		{-xyMag,  xyMag,	  zMag}}
	messageList[#messageList + 1] = {startBeat +  24.000,	"RotateField",		{ xyMag, -xyMag*0.5, -zMag}}
	messageList[#messageList + 1] = {startBeat +  26.000,	"RotateField",		{-xyMag,   0,		  0}}
	messageList[#messageList + 1] = {startBeat +  27.520,	"RotateField",		{ xyMag,  xyMag*0.5,  zMag}}
	messageList[#messageList + 1] = {startBeat +  30.000,	"RotateField",		{  0,   0,   0, 2.0}}
end

MsgAddShineRotations( 48.0,  30,  0)
MsgAddShineRotations(112.0,  30,  5)
MsgAddShineRotations(144.0, -30, 15)

MsgAddShineRotations(224.0,  15,  0)
MsgAddShineRotations(256.0, -15,  0)

messageList = SortModsTable(messageList)

gfxUpdateFunction = function()
	-- Most things are determined by beat, believe it or not.		
	overtime = GAMESTATE:GetSongBeat() - visualOffset
	
	-- TODO: this assumes the effect applies over a constant BPM section!!
	BPS = GAMESTATE:GetSongBPS()
	
	-- Initializations
	if overtime >=   0.0 and not checked then
		for i,v in ipairs(plr) do
			if v then
				v:visible(false):decelerate(4.0 / BPS)
--				 :x(sw/2)
				 :y(sh/2 - 30)
				 :z(0)
			end
		end
		
		local mirrorShine = mirrorShineSeed
		for rowIndex = 1,mirrorRows do
			for colIndex = 1,mirrorCols do
				mirrorShining[#mirrorShining + 1] = mirrorShine / (mirrorShinePrime - 1)
				mirrorShine = (mirrorShine * mirrorShineSeed) % mirrorShinePrime
			end
		end

		checked = true
	end
			
	-- Broadcast messages on their own terms.
	while true do
		if fgmsg < #messageList then
			messageBeat, messageName, messageArgs = unpack(messageList[fgmsg+1])
			if overtime >= messageBeat then			
				if messageArgs then
					MESSAGEMAN:Broadcast( messageName, messageArgs )
				else
					MESSAGEMAN:Broadcast( messageName )
				end
				
				fgmsg = fgmsg + 1
			else
				break
			end
		else
			break
		end
	end


	-- Disco feeling
	local discoClock = overtime - discoStartTime
	local discoParameter = 0
	if discoClock > discoTweenTime then
		discoParameter = (discoClock - discoTweenTime * 0.5) / discoProxyPeriod
	elseif discoClock > 0 then
		discoParameter = 0.5 * discoClock * discoClock / discoTweenTime / discoProxyPeriod
	end


	for i = 1,2 do
		for proxyIndex = 1,#DiscoProxies[i] do
			local theirTime = math.fmod(discoParameter + (proxyIndex + 0.5) / #DiscoProxies[i], 1)
			DiscoProxies[i][proxyIndex]:x(sw * (SideSign(i) * 2.0 * (theirTime - 0.5) + 0.5))
									   :diffusealpha((theirTime < 0.05 or theirTime > 0.95) and 0.0 or 1.0)		-- to suppress The Man Crossing The Disco At Very Hihg Speed
		end
	end

	for i = 1,#DiscoMirrors do
		local shiny = RangeScale(CalculateSilver(i, discoParameter + 1, 4), 0, 1, mirrorShinyMin, mirrorShinyMax)
		local colIndex = i % mirrorCols
		local theirTime = math.fmod(discoParameter + colIndex / mirrorCols, 1)
		DiscoMirrors[i]:x(sw * (-mirrorWidth * (theirTime - 0.5) + 0.5))
					   :diffuse(shiny, shiny, shiny, 1.0)
	end


	-- Superstar feeling
	local knifeClock = overtime - knifeStartTime
	local rotationNow = -90
	if knifeClock > 0 then
		rotationNow = KnifeRotation(knifeClock)
	end

	for pn = 1,3 do
--		local rotationNowPN = ((pn == 1) and -1 or ((pn == 2) and 1 or 0)) * rotationNow
		local rotationNowPN = (pn == 3) and -90 or rotationNow

		if knifeRingContainers[pn] then
			knifeRingContainers[pn]:rotationz(-rotationNowPN)
			for ai = 1,#knifeArrowActors[pn] do
				knifeArrowActors[pn][ai]:rotationz(rotationNowPN)
			end
		end
	end


--	Trace('Update @ ' .. GAMESTATE:GetSongBeat() .. " (" .. GAMESTATE:GetCurMusicSeconds() .. " sec.)")
end


-------------------------------------------------------------------------------
--
-- Messaging controller
--

_FG_[#_FG_ + 1] = Def.ActorFrame {
	DiscoEngageMessageCommand = function(self, args)
		if DiscoWallAMV then
			for rowIndex = 1,stretchyRows do
				rowActor = DiscoWallAMV:GetChild("StretchyAMVStrip_" .. rowIndex)
				if rowActor then
					rowActor:finishtweening()
							:decelerate(args[1] / BPS)
							:SetVertices(DiscoWallPrefetch[rowIndex])
				end
			end
			DiscoWallAMV:decelerate(args[1] / BPS)
						:diffuse(0.7, 0.7, 0.7, 1.0)
		end

		if DiscoBallAMV then
			for rowIndex = 1,stretchyRows do
				rowActor = DiscoBallAMV:GetChild("StretchyAMVStrip_" .. rowIndex)
				if rowActor then
					rowActor:finishtweening()
--							:decelerate(args[1] / BPS)
							:SetVertices(DiscoBallPrefetch[rowIndex])
				end
			end
			DiscoBallAMV:decelerate(args[1] / BPS)
						:y(sh * (0.2 + discoBallSize * 0.3))
		end
	end,

	DiscoTimeMessageCommand = function(self, args)
		discoStartTime = overtime
		if #args >= 1 then
			discoTweenTime = args[1]
		end
		if #args >= 2 then
			discoProxyPeriod = args[2]
		end
	end,

	DiscoDisengageMessageCommand = function(self, args)
		if DiscoWallAMV then
			DiscoWallAMV:finishtweening()
						:accelerate(args[1] / BPS)
						:diffuse(0.0, 0.0, 0.0, 1.0)
		end

		if DiscoBallAMV then
			DiscoBallAMV:accelerate(args[1] / BPS)
						:y(-sh*discoBallSize/2)
		end
	end,

	KnifePatternLoadMessageCommand = function(self, args)
		pn = args[1]

		if args[2] then
			KnifePatternLoader(pn, args[2])
		else
			KnifePatternLoader(pn, knifeScore[pn] + 1)
		end
	end,


	KnifeBeginMessageCommand = function(self, args)
		pn = args[1]

		knifeAllowInput[pn] = true

		if args[2] then
			KnifePatternLoader(pn, args[2])
		else
			KnifePatternLoader(pn, 1)
		end		
		knifeRingActors[pn]
			:finishtweening()
			:queuecommand("GameStart")
		knifeScoreContainers[pn]
			:finishtweening()
			:queuecommand("GameStart")

		knifeStartTime = overtime
	end,


	KnifeEndMessageCommand = function(self, args)
		pn = args[1]

		knifeAllowInput[pn] = false

		knifeRingActors[pn]
			:finishtweening()
			:queuecommand("GameOver")
		knifeScoreContainers[pn]
			:finishtweening()
			:queuecommand("GameOver")
	end,


	KnifeKillMessageCommand = function(self, args)
		pn = args[1]

		knifeAllowInput[pn] = false 		-- I mean, obvs.

		knifeRingActors[pn]
			:finishtweening()
			:queuecommand("GameKill")
		knifeScoreContainers[pn]
			:finishtweening()
			:queuecommand("GameKill")
	end,


	DisplayTextToPlayerMessageCommand = function(self, args)
		local textYPos 	= args[1] and args[1] or sh/2
		local textScale	= args[2] and args[2] or 1.0 
		local text 		= args[3] and args[3] or ""

		KnifeHelpTextActors[3 - knifeHelpTextActive]
			:settext(text)
			:y(textYPos)
			:zoom(textScale * 0.5)
			:decelerate(0.5 / BPS)
			:diffusealpha(1.0)

		KnifeHelpTextActors[    knifeHelpTextActive]
			:decelerate(0.5 / BPS)
			:diffusealpha(0.0)
		
		knifeHelpTextActive = 3 - knifeHelpTextActive
	end,


	InputPressedMessageCommand = function(self, args)
		pn = args[1]
		bn = args[2]

		Trace("### InputPressed: "..pn..", "..bn)

		if knifeAllowInput[pn] and overtime > knifePenaltyBox[pn] then
			ci = knifeArrowActive[pn]

			if bn == knifePatternActive[pn][ci] then
				Trace("### Input accepted! "..pn..", "..bn..": "..ci)
				KnifeMoveToDot(args[1], ci + 1)

				if ci == #knifePatternActive[pn] then
					knifeRingActors[pn]:queuecommand("TriggerNewStar")
				end
			else
				Trace("### Input denied! "..pn..", "..bn..": "..ci)
				if knifeArrowActive[pn] == 1 then

				else
					KnifeMoveToDot(args[1], ci - 1)
					knifePenaltyBox[pn] = overtime + knifeWrongPenalty
				end
			end
		else
			Trace("### Input disallowed: "..pn..", "..bn)
		end
	end,
}


-- Perframe controller
_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		self:SetUpdateFunction(gfxUpdateFunction)
	end,

	Def.ActorFrame {
		InitCommand = function(self)
			self:sleep(69420)
		end
	}
}


-- Load the mods table parser into this script.
niceSpeed = (420) / 128			-- This song is 128 BPM.
slowSpeed = 0.8 * niceSpeed
modsTable = {
	-- [1]: beat start
	-- [2]: mod type
	-- [3]: mod strength (out of unity),
	-- [4]: mod approach (in beats to complete)
	-- [5]: player application (1 = P1, 2 = P2, 3 = both, 0 = neither)
		
		{   0.000,	"ScrollSpeed",	slowSpeed,    0.0,	3}, 
		{   0.000,	"Dark",				  0.2,    0.0,	3}, 
		{   7.900,	"Wave",				  2.0,    0.0,	3}, 
		{   7.900,	"Tipsy",			  1.0,    0.1,	1},
		{   7.900,	"Tipsy",			 -1.0,    0.1,	2},
		{   7.900,	"Mini",				  0.7,    0.1,	3},
		{   7.900,	"Tornado",			 -1.0,    0.1,	3},
		{   7.900,	"Xmode",			  0.1,    0.1,	3},
		{   7.900,	"Bumpy",		     10.0,    0.1,	3},
		{   8.000,	"Wave",				  0.0,    0.0,	3}, 
		{   8.000,	"Tipsy",			  0.0,    7.0,	3},
		{   8.000,	"Mini",				  0.0,    7.0,	3},
		{   8.000,	"Tornado",			  0.0,    7.0,	3},
		{   8.000,	"Bumpy",		      0.0,    7.0,	3},
		{   8.000,	"Xmode",			  0.0,    7.0,	3},
		{   8.000,	"ScrollSpeed",	niceSpeed,    7.0,	3}, 
		{  16.000,	"Beat",				  0.5,    0.0,	1}, 
		{  16.000,	"Beat",				 -0.5,    0.0,	2}, 

		-- WHAAA
		{  21.500,	"Tiny",				  0.2,	  0.4,	3},
		{  21.500,	"Flip",				 -0.1,	  0.4,	3},
		{  21.900,	"Tiny",				 -0.5,	  0.0,	3},
		{  21.900,	"Flip",				  0.1,	  0.0,	3},
		{  22.000,	"Tiny",				  0.0,	  4.0,	3},
		{  22.000,	"Flip",				  0.0,	  4.0,	3},
		{  29.000,	"Tiny",				  0.2,	  0.4,	3},
		{  29.000,	"Flip",				 -0.1,	  0.4,	3},
		{  29.400,	"Tiny",				 -0.5,	  0.0,	3},
		{  29.400,	"Flip",				  0.1,	  0.0,	3},
		{  29.500,	"Tiny",				  0.0,	  4.0,	3},
		{  29.500,	"Flip",				  0.0,	  4.0,	3},
		{  37.500,	"Tiny",				  0.2,	  0.4,	3},
		{  37.500,	"Flip",				 -0.1,	  0.4,	3},
		{  37.900,	"Tiny",				 -0.5,	  0.0,	3},
		{  37.900,	"Flip",				  0.1,	  0.0,	3},
		{  38.000,	"Tiny",				  0.0,	  4.0,	3},
		{  38.000,	"Flip",				  0.0,	  4.0,	3},
		{  45.000,	"Tiny",				  0.2,	  0.4,	3},
		{  45.000,	"Flip",				 -0.1,	  0.4,	3},
		{  45.400,	"Tiny",				 -0.5,	  0.0,	3},
		{  45.400,	"Flip",				  0.1,	  0.0,	3},
		{  45.500,	"Tiny",				  0.0,	  4.0,	3},
		{  45.500,	"Flip",				  0.0,	  4.0,	3},
		{ 110.000,	"Tiny",				  0.2,	  0.4,	3},
		{ 110.000,	"Flip",				 -0.1,	  0.4,	3},
		{ 110.400,	"Tiny",				 -0.5,	  0.0,	3},
		{ 110.400,	"Flip",				  0.1,	  0.0,	3},
		{ 110.500,	"Tiny",				  0.0,	  4.0,	3},
		{ 110.500,	"Flip",				  0.0,	  4.0,	3},
		{ 133.500,	"Tiny",				  0.2,	  0.4,	3},
		{ 133.500,	"Flip",				 -0.1,	  0.4,	3},
		{ 133.900,	"Tiny",				 -0.5,	  0.0,	3},
		{ 133.900,	"Flip",				  0.1,	  0.0,	3},
		{ 134.000,	"Tiny",				  0.0,	  4.0,	3},
		{ 134.000,	"Flip",				  0.0,	  4.0,	3},
		{ 222.500,	"Tiny",				  0.2,	  0.4,	3},
		{ 222.500,	"Flip",				 -0.1,	  0.4,	3},
		{ 222.900,	"Tiny",				 -0.5,	  0.0,	3},
		{ 222.900,	"Flip",				  0.1,	  0.0,	3},
		{ 223.000,	"Tiny",				  0.0,	  4.0,	3},
		{ 223.000,	"Flip",				  0.0,	  4.0,	3},
		{ 245.500,	"Tiny",				  0.2,	  0.4,	3},
		{ 245.500,	"Flip",				 -0.1,	  0.4,	3},
		{ 245.900,	"Tiny",				 -0.5,	  0.0,	3},
		{ 245.900,	"Flip",				  0.1,	  0.0,	3},
		{ 246.000,	"Tiny",				  0.0,	  4.0,	3},
		{ 246.000,	"Flip",				  0.0,	  4.0,	3},

		-- clap clap
		{  62.400,	"Invert",			  0.5,	  0.1,	3},
		{  62.900,	"Invert",			  0.0,	  0.1,	3},
		{  78.400,	"Invert",			  0.5,	  0.1,	3},
		{  78.900,	"Invert",			  0.0,	  0.1,	3},
		{  94.400,	"Invert",			  0.5,	  0.1,	3},
		{  94.900,	"Invert",			  0.0,	  0.1,	3},
		{ 110.400,	"Invert",			  0.5,	  0.1,	3},
		{ 110.900,	"Invert",			  0.0,	  0.1,	3},
		{ 126.400,	"Invert",			  0.5,	  0.1,	3},
		{ 126.900,	"Invert",			  0.0,	  0.1,	3},
		{ 158.400,	"Invert",			  0.5,	  0.1,	3},
		{ 158.900,	"Invert",			  0.0,	  0.1,	3},
		{ 174.400,	"Invert",			  0.5,	  0.1,	3},
		{ 174.900,	"Invert",			  0.0,	  0.1,	3},
		{ 206.400,	"Invert",			  0.5,	  0.1,	3},
		{ 206.900,	"Invert",			  0.0,	  0.1,	3},
		{ 222.400,	"Invert",			  0.5,	  0.1,	3},
		{ 222.900,	"Invert",			  0.0,	  0.1,	3},
		{ 238.400,	"Invert",			  0.5,	  0.1,	3},
		{ 238.900,	"Invert",			  0.0,	  0.1,	3},
		{ 254.400,	"Invert",			  0.5,	  0.1,	3},
		{ 254.900,	"Invert",			  0.0,	  0.1,	3},
		{ 270.400,	"Invert",			  0.5,	  0.1,	3},
		{ 270.900,	"Invert",			  0.0,	  0.1,	3},
		{ 286.400,	"Invert",			  0.5,	  0.1,	3},
		{ 286.900,	"Invert",			  0.0,	  0.1,	3},

		-- Supershine
		{  89.400,	"Stealth",			  0.5,	  0.1,	3},
		{  89.400,	"Mini",				 -2.0,	  0.1,	3},
		{  89.500,	"Stealth",			  0.0,	  2.5,	3},
		{  89.500,	"Mini",				  0.0,	  2.5,	3},
		{ 201.400,	"Stealth",			  0.5,	  0.1,	3},
		{ 201.400,	"Mini",				 -2.0,	  0.1,	3},
		{ 201.500,	"Stealth",			  0.0,	  2.5,	3},
		{ 201.500,	"Mini",				  0.0,	  2.5,	3},

		-- da-da-da da 		
		{ 142.450,	"Drunk",			  0.2,	  0.05,	1},
		{ 142.450,	"Drunk",			 -0.2,	  0.05,	2},
		{ 142.700,	"Drunk",			 -0.3,	  0.05,	1},
		{ 142.700,	"Drunk",			  0.3,	  0.05,	2},
		{ 142.950,	"Drunk",			  0.4,	  0.05,	1},
		{ 142.950,	"Drunk",			 -0.4,	  0.05,	2},
		{ 143.450,	"Drunk",			 -0.4,	  0.05,	1},
		{ 143.450,	"Drunk",			  0.4,	  0.05,	2},
		{ 143.950,	"Drunk",			  0.0,	  0.05,	3},
		{ 254.450,	"Drunk",			  0.2,	  0.05,	1},
		{ 254.450,	"Drunk",			 -0.2,	  0.05,	2},
		{ 254.700,	"Drunk",			 -0.3,	  0.05,	1},
		{ 254.700,	"Drunk",			  0.3,	  0.05,	2},
		{ 254.950,	"Drunk",			  0.4,	  0.05,	1},
		{ 254.950,	"Drunk",			 -0.4,	  0.05,	2},
		{ 255.450,	"Drunk",			 -0.4,	  0.05,	1},
		{ 255.450,	"Drunk",			  0.4,	  0.05,	2},
		{ 255.950,	"Drunk",			  0.0,	  0.05,	3},

		-- *whispers* super star...
		{ 159.900,	"Dizzy",			 10.0,	  0.1,	3},
		{ 160.000,	"Dizzy",			  0.0,	  0.9,	3},
		{ 160.900,	"Dizzy",			 -5.0,	  0.1,	3},
		{ 161.000,	"Dizzy",			  0.0,	  1.5,	3},
		{ 271.900,	"Dizzy",			 10.0,	  0.1,	3},
		{ 272.000,	"Dizzy",			  0.0,	  0.5,	3},
		{ 272.900,	"Dizzy",			 -5.0,	  0.1,	3},
		{ 273.000,	"Dizzy",			  0.0,	  1.5,	3},

		-- oh my god, what the fr**k		
		{ 175.750,	"Beat",				  0.0,    0.05,	3}, 
		{ 175.900,	"ScrollSpeed",	slowSpeed,   16.0,	3}, 
		{ 191.500,	"Beat",				  0.2,    1.0,	3}, 

}

modsTable = SortModsTable(modsTable)
_FG_[#_FG_ + 1] = LoadActor("./modsHQ.lua", {modsTable, 0})



return _FG_
