-------------------------------------------------------------------------------
--
--		Yooh - "Dual Emotion"
--		Bubble Tea Invitational 2.5
--		
--		Author: 	Telperion
--		Date: 		2017-06-07
--		Target:		SM5.0.12+
--
-------------------------------------------------------------------------------
--
--		So I got bored with all my friends and snuck into this pool party...
--		Everybody seems to be enjoying themselves, but, damn. 
--		Club music just isn't what it used to be.
--
-------------------------------------------------------------------------------

local circumvention = false
if circumvention then
	return Def.ActorFrame {}
end

local niceSpeed = (420) / 140			-- This song is 140 BPM.
local slowSpeed = 0.7 * niceSpeed		-- This song is 140 BPM.
local sw = SCREEN_WIDTH
local sh = SCREEN_HEIGHT
local BPS = GAMESTATE:GetSongBPS()
local ofs = 0.009
local overtime = 0
local visualOffset = -0.01
local fgmsg = 0
local checked = false
local plr = {nil, nil}

local PI = math.pi
local LOG2 = math.log(2.0)
local DEG_TO_RAD = math.pi / 180.0

local playerProxies 		= {nil, nil}
local playerJudgeProxies 	= {nil, nil}
local playerJudgeDudes 		= {nil, nil}

--
--	Texture constants
--
local ttw = math.pow(2, math.ceil(math.log(sw) / LOG2))
local tth = math.pow(2, math.ceil(math.log(sh) / LOG2))
local twscale = sw / ttw
local thscale = sh / tth

--
-- 	some funktion !
--
function SideSign(i) return (i == 2) and 1 or -1 end

function RangeScale(t, inLower, inUpper, outLower, outUpper)
	local ti = (t - inLower) / (inUpper - inLower)
	return outLower + ti * (outUpper - outLower)
end

function RangeClamp(t, outLower, outUpper)
	local ti = t
	ti = (ti < outLower) and outLower or ti
	ti = (ti > outUpper) and outUpper or ti
	return ti
end

function Whomst(act)
	return tonumber(string.match(act:GetName(), "P([0-9]+)"))
end

function Whichst(act)
	return tonumber(string.match(act:GetName(), "_([0-9]+)"))
end


function SortModsTable(mt)
	-- Insertion sort into the butt
	-- because wow I'm mostly lazy
	-- and can assume it's mostly sorted

	mtNew = {}

	for _,mr in pairs(mt) do
		local insertLocation = 1
		for i = #mtNew,1,-1 do
--			Trace("### SortModsTable: "..mtNew[i][1].." vs. "..mr[1])
			if mtNew[i][1] <= mr[1] then
				insertLocation = i+1
				break
			end
		end
--		Trace("### SortModsTable: "..mr[1].." ("..mr[2]..") -> "..insertLocation)
		table.insert(mtNew, insertLocation, mr)
	end

	return mtNew
end



local _DZ_ = Def.ActorFrame {}
local _FG_ = Def.ActorFrame {
	InitCommand = function(self)
	end,
	OnCommand = function(self)
		self:fov(45)
			:vanishpoint(sw/2, sh/4)			
			:SetDrawByZPosition(true)

		plr[1] = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
		plr[2] = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
		SCREENMAN:GetTopScreen():SetDrawByZPosition(true)


		-- Ensure P1 on Hard and P2 on Expert.
		local d1, d2, s1, s2
		s1 = GAMESTATE:GetCurrentSong():GetOneSteps( "StepsType_Dance_Single", "Difficulty_Hard" );
		s2 = GAMESTATE:GetCurrentSong():GetOneSteps( "StepsType_Dance_Single", "Difficulty_Challenge" );

		d1 = GAMESTATE:GetCurrentSteps(0):GetDifficulty();
		d2 = GAMESTATE:GetCurrentSteps(1):GetDifficulty();

		if (d1 ~= "Difficulty_Hard" or d2 ~= "Difficulty_Challenge") then
			GAMESTATE:SetCurrentSteps(0, s1)
			GAMESTATE:SetCurrentSteps(1, s2)
			SCREENMAN:SetNewScreen("ScreenGameplay")
		end


		local hamburger = SCREENMAN:GetTopScreen()
		if hamburger:GetScreenType() == "ScreenType_Gameplay" then
			hamburger:GetChild("Overlay" ):decelerate(4.0 / BPS):diffusealpha(0.0)
			hamburger:GetChild("Underlay"):decelerate(4.0 / BPS):diffusealpha(0.0)
		end
				
		local playersFound = 0
		for pn = 1,2 do
			pv = plr[pn]
			if pv then
				pv:GetChild("Combo"):hibernate(1573)
			end
			
			pops = GAMESTATE:GetPlayerState("PlayerNumber_P"..pn):GetPlayerOptions("ModsLevel_Song")
			pops:FailSetting('FailType_Off')
		end

		self:sleep(1573)
	end
};



-------------------------------------------------------------------------------
--
--
--	Don't Mess With My Emotions !!
--
--

local baserotationzByLane = {
	90,		-- Left
	0,		-- Down
	180,	-- Up
	270		-- Right
}
local texArrows = {}		-- Texture coordinate shifts
texArrows[4] 	= 0.000		-- 4th
texArrows[8] 	= 0.125		-- 8th
texArrows[16] 	= 0.375		-- 16th
texArrows[12] 	= 0.250		-- 12th
texArrows[24] 	= 0.500		-- 24th
texArrows[32] 	= 0.625		-- 32nd
texArrows[48] 	= 0.750		-- 48th
texArrows[64] 	= 0.875		-- 64th

local dualPoolSize		= 60		-- Analytically derived.
local dualWhichPhase	= 1
local dualPhaseBegin	= 132
local dualPhaseEnd		= 196
local dualPhasingPeriod	= 4
local dualNextNote		= 1

local dualTargetAligner = nil
local dualMoveStrengthAuxActor = nil
local dualPlayerOrigin	= {{sw/2, sh/2}, {sw/2, sh/2}}
local dualJudgeOrigin	= {{sw/2, sh/2}, {sw/2, sh/2}}
local dualPool = {}
local dualPoolActive = {}


dualEngageTimes = {
-- [1]: finish engage
-- [2]: length of engage

	{132, 4},
	{164, 1},

	{460, 4},
	{492, 1},
	{526, 0},
	{556, 1},
}

dualDisengageTimes = {
-- [1]: start disengage
-- [2]: length of disengage

	{160, 2},
	{188, 2},
	
	{484, 7},
	{516, 8},
	{548, 7},
	{580, 8},
}



local path = GAMESTATE:GetCurrentSong():GetSongDir()
--loadfile(path.."lua/chartData.lua")
dualSource = {
	-- Generated using Chart2Lua.py
	-- Only one copy is needed because the arrows are charted such that
	-- P1 reads them one direction and P2 reads them the other.

	-- [1]: beat number, zero at start
	-- [2]: lane number, one-indexed
	-- [3]: note type: Tap, Hold, Roll, End, or Mine
	-- [4]: quantization reciprocal
	
	{ 132.000, 4, "T",   4},
	{ 133.000, 1, "T",   4},
	{ 134.000, 1, "T",   4},
	{ 135.000, 4, "T",   4},
	{ 136.000, 3, "T",   4},
	{ 137.000, 2, "T",   4},
	{ 138.000, 2, "T",   4},
	{ 139.000, 3, "T",   4},
	{ 140.000, 4, "T",   4},
	{ 141.000, 1, "T",   4},
	{ 142.000, 4, "T",   4},
	{ 143.000, 4, "T",   4},
	{ 144.000, 2, "T",   4},
	{ 145.000, 2, "T",   4},
	{ 146.000, 3, "T",   4},
	{ 147.000, 2, "T",   4},
	{ 148.000, 4, "T",   4},
	{ 149.000, 1, "T",   4},
	{ 149.500, 2, "T",   8},
	{ 150.000, 3, "T",   4},
	{ 151.000, 4, "T",   4},
	{ 152.000, 2, "T",   4},
	{ 153.000, 3, "T",   4},
	{ 153.500, 1, "T",   8},
	{ 154.000, 4, "T",   4},
	{ 155.000, 3, "T",   4},
	{ 156.000, 2, "T",   4},
	{ 157.000, 3, "T",   4},
	{ 157.500, 4, "T",   8},
	{ 158.000, 1, "T",   4},
	{ 159.000, 3, "T",   4},

	{ 160.000, 1, "T",   4},
	{ 160.333, 2, "T",  12},
	{ 160.667, 1, "T",  12},
	{ 161.000, 4, "T",   4},
	{ 161.333, 2, "T",  12},
	{ 161.667, 2, "T",  12},	-- !!
	{ 162.000, 4, "T",   4},	-- !!
	{ 162.333, 1, "T",  12},	-- !!
	{ 162.667, 2, "T",  12},	-- !!
	{ 163.000, 1, "T",   4},	-- !!
--	{ 161.667, 4, "T",  12},
--	{ 162.000, 3, "T",   4},
--	{ 162.500, 2, "T",   8},
--	{ 163.000, 1, "T",   4},

	{ 164.000, 4, "T",   4},
	{ 164.500, 2, "T",   8},
	{ 165.000, 3, "T",   4},
	{ 166.000, 2, "T",   4},
	{ 166.500, 4, "T",   8},
	{ 167.000, 1, "T",   4},
	{ 168.000, 4, "T",   4},
	{ 168.500, 3, "T",   8},
	{ 169.000, 2, "T",   4},
	{ 170.000, 3, "T",   4},
	{ 170.500, 4, "T",   8},
	{ 171.000, 1, "T",   4},
	{ 172.000, 4, "T",   4},
	{ 172.500, 2, "T",   8},
	{ 173.000, 4, "T",   4},
	{ 174.000, 3, "T",   4},
	{ 174.500, 2, "T",   8},
	{ 175.000, 1, "T",   4},
	{ 176.000, 1, "T",   4},
	{ 176.500, 3, "T",   8},
	{ 177.000, 2, "T",   4},
	{ 177.500, 4, "T",   8},
	{ 178.000, 3, "T",   4},
	{ 178.500, 4, "T",   8},
	{ 179.000, 1, "T",   4},
	{ 180.000, 2, "T",   4},
	{ 180.500, 3, "T",   8},
	{ 181.000, 2, "T",   4},
	{ 181.500, 1, "T",   8},
	{ 182.000, 4, "T",   4},
	{ 182.500, 2, "T",   8},
	{ 183.000, 3, "T",   4},
	{ 184.000, 1, "T",   4},
	{ 184.500, 4, "T",   8},
	{ 185.000, 3, "T",   4},
	{ 185.500, 4, "T",   8},
	{ 186.000, 2, "T",   4},
	{ 186.500, 3, "T",   8},
	{ 187.000, 1, "T",   4},

	{ 188.000, 3, "T",   4},
	{ 188.500, 2, "T",   8},
	{ 189.000, 4, "T",   4},
	{ 189.500, 1, "T",   8},
	{ 190.000, 4, "T",   4},	-- !!
	{ 190.500, 2, "T",   8},	-- !!
	{ 191.000, 3, "T",   4},	-- !!
--	{ 190.000, 2, "T",   4},
--	{ 190.500, 2, "T",   8},
--	{ 191.000, 1, "T",   4},
--	{ 191.250, 4, "T",  16},
--	{ 191.500, 1, "T",   8},
--	{ 192.000, 3, "T",   4},
--	{ 192.500, 2, "T",   8},
--	{ 193.000, 4, "T",   4},
--	{ 193.500, 1, "T",   8},
--	{ 193.667, 2, "T",  12},
--	{ 193.833, 1, "T",  24},
--	{ 194.000, 4, "T",   4},
--	{ 195.000, 2, "T",   4},
--	{ 196.000, 3, "T",   4},


	{ 460.000, 3, "T",   4},
	{ 461.000, 4, "T",   4},
	{ 461.500, 1, "T",   8},
	{ 462.000, 3, "T",   4},
	{ 463.000, 1, "T",   4},
	{ 463.500, 4, "T",   8},
	{ 464.000, 3, "T",   4},
	{ 465.000, 2, "T",   4},
	{ 465.500, 1, "T",   8},
	{ 466.000, 4, "T",   4},
	{ 467.000, 3, "T",   4},
	{ 468.000, 2, "T",   4},
	{ 469.000, 1, "T",   4},
	{ 469.500, 4, "T",   8},
	{ 470.000, 2, "T",   4},
	{ 471.000, 3, "T",   4},
	{ 471.500, 1, "T",   8},
	{ 472.000, 4, "T",   4},
	{ 473.000, 3, "T",   4},
	{ 473.500, 4, "T",   8},
	{ 474.000, 1, "T",   4},
	{ 475.000, 2, "T",   4},
	{ 476.000, 1, "T",   4},
	{ 476.500, 4, "T",   8},
	{ 477.000, 3, "T",   4},
	{ 478.000, 2, "T",   4},
	{ 478.500, 1, "T",   8},
	{ 479.000, 2, "T",   4},
	{ 479.500, 3, "T",   8},
	{ 480.000, 4, "T",   4},
	{ 480.500, 1, "T",   8},
	{ 481.000, 3, "T",   4},
	{ 482.000, 2, "T",   4},
	{ 482.500, 3, "T",   8},
	{ 483.000, 1, "T",   4},

	{ 484.000, 4, "T",   4},
	{ 484.500, 2, "T",   8},
	{ 485.000, 3, "T",   4},
	{ 485.250, 1, "T",  16},
	{ 485.750, 3, "T",  16},
	{ 486.000, 2, "T",   4},
	{ 486.500, 4, "T",   8},
	{ 487.000, 1, "T",   4},
	{ 487.250, 2, "T",  16},
	{ 487.750, 2, "T",  16},	-- !!
	{ 488.000, 1, "T",   4},	-- !!
	{ 488.500, 4, "T",   8},	-- !!
	{ 489.000, 2, "T",   4},	-- !!
	{ 489.250, 3, "T",  16},	-- !!
	{ 489.750, 1, "T",  16},	-- !!
	{ 490.000, 3, "T",   4},	-- !!
	{ 490.500, 2, "T",   8},	-- !!
	{ 491.000, 4, "T",   4},	-- !!
--	{ 487.750, 1, "T",  16},
--	{ 488.000, 4, "T",   4},
--	{ 488.500, 3, "T",   8},
--	{ 489.000, 2, "T",   4},
--	{ 489.500, 1, "T",   8},
--	{ 490.000, 4, "T",   4},
--	{ 490.500, 2, "T",   8},
--	{ 490.667, 3, "T",  12},
--	{ 490.833, 2, "T",  24},
--	{ 491.000, 4, "T",   4},


	{ 492.000, 1, "T",   4},
	{ 492.500, 3, "T",   8},
	{ 493.000, 2, "T",   4},
	{ 493.500, 3, "T",   8},
	{ 494.000, 1, "T",   4},
	{ 495.000, 4, "T",   4},
	{ 495.500, 3, "T",   8},
	{ 496.000, 2, "T",   4},
	{ 497.000, 1, "T",   4},
	{ 497.500, 2, "T",   8},
	{ 498.000, 3, "T",   4},
	{ 498.500, 4, "T",   8},
	{ 499.000, 1, "T",   4},
	{ 500.000, 4, "T",   4},
	{ 500.500, 2, "T",   8},
	{ 501.000, 3, "T",   4},
	{ 501.500, 1, "T",   8},
	{ 502.000, 4, "T",   4},
	{ 503.000, 3, "T",   4},
	{ 503.500, 2, "T",   8},
	{ 504.000, 1, "T",   4},
	{ 505.000, 2, "T",   4},
	{ 505.500, 3, "T",   8},
	{ 506.000, 2, "T",   4},
	{ 506.500, 1, "T",   8},
	{ 507.000, 4, "T",   4},
	{ 508.000, 1, "T",   4},
	{ 508.500, 3, "T",   8},
	{ 509.000, 2, "T",   4},
	{ 509.500, 3, "T",   8},
	{ 510.000, 1, "T",   4},
	{ 510.500, 4, "T",   8},
	{ 511.000, 3, "T",   4},
	{ 511.500, 2, "T",   8},
	{ 512.000, 1, "T",   4},
	{ 512.500, 4, "T",   8},
	{ 513.000, 2, "T",   4},
	{ 513.500, 3, "T",   8},
	{ 514.000, 2, "T",   4},
	{ 514.500, 4, "T",   8},
	{ 515.000, 1, "T",   4},

	{ 516.000, 4, "T",   4},
	{ 516.500, 3, "T",   8},
	{ 517.000, 2, "T",   4},
	{ 517.500, 2, "T",   8},
	{ 518.000, 2, "T",   4},
	{ 518.500, 1, "T",   8},
	{ 519.000, 4, "T",   4},
	{ 520.000, 4, "T",   4},	-- !!
	{ 520.500, 1, "T",   8},	-- !!
	{ 521.000, 2, "T",   4},	-- !!
	{ 521.500, 2, "T",   8},	-- !!
	{ 522.000, 2, "T",   4},	-- !!
	{ 522.500, 3, "T",   8},	-- !!
	{ 523.000, 4, "T",   4},	-- !!
--	{ 520.000, 2, "T",   4},
--	{ 520.500, 3, "T",   8},
--	{ 521.000, 2, "T",   4},
--	{ 521.500, 4, "T",   8},
--	{ 521.667, 2, "T",  12},
--	{ 521.833, 4, "T",  24},
--	{ 522.000, 1, "T",   4},

--	{ 524.000, 2, "T",   4},
--	{ 524.000, 3, "T",   4},
--	{ 525.000, 1, "T",   4},
--	{ 525.000, 4, "T",   4},
	{ 524.000, 3, "T",   4},	-- !!
	{ 524.500, 2, "T",   8},	-- !!
	{ 525.000, 4, "T",   4},	-- !!
	{ 526.000, 1, "T",   4},
	{ 527.000, 4, "T",   4},
	{ 527.500, 2, "T",   8},
	{ 528.000, 4, "T",   4},
	{ 529.000, 1, "T",   4},
	{ 530.000, 4, "T",   4},
	{ 530.500, 2, "T",   8},
	{ 531.000, 3, "T",   4},
	{ 532.000, 1, "T",   4},
	{ 533.000, 4, "T",   4},
	{ 533.250, 2, "T",  16},
	{ 533.750, 4, "T",  16},
	{ 534.000, 2, "T",   4},
	{ 535.000, 3, "T",   4},
	{ 535.500, 1, "T",   8},
	{ 536.000, 4, "T",   4},
	{ 537.000, 3, "T",   4},
	{ 537.250, 2, "T",  16},
	{ 537.750, 3, "T",  16},
	{ 538.000, 2, "T",   4},
	{ 539.000, 1, "T",   4},
	{ 540.000, 4, "T",   4},
	{ 541.000, 3, "T",   4},
	{ 541.250, 2, "T",  16},
	{ 541.750, 3, "T",  16},
	{ 542.000, 2, "T",   4},
	{ 543.000, 1, "T",   4},
	{ 543.250, 3, "T",  16},
	{ 543.750, 1, "T",  16},
	{ 544.000, 3, "T",   4},
	{ 545.000, 2, "T",   4},
	{ 545.250, 4, "T",  16},
	{ 545.750, 2, "T",  16},
	{ 546.000, 4, "T",   4},
	{ 547.000, 1, "T",   4},

	{ 548.000, 1, "T",   4},
	{ 548.500, 2, "T",   8},
	{ 549.000, 3, "T",   4},
	{ 549.250, 4, "T",  16},
	{ 549.750, 3, "T",  16},
	{ 550.000, 2, "T",   4},
	{ 550.500, 1, "T",   8},
	{ 551.000, 4, "T",   4},
	{ 551.250, 2, "T",  16},
	{ 551.750, 2, "T",  16},	-- !!
	{ 552.000, 4, "T",   4},	-- !!
	{ 552.500, 1, "T",   8},	-- !!
	{ 553.000, 2, "T",   4},	-- !!
	{ 553.250, 3, "T",  16},	-- !!
	{ 553.750, 4, "T",  16},	-- !!
	{ 554.000, 3, "T",   4},	-- !!
	{ 554.500, 2, "T",   8},	-- !!
	{ 555.000, 1, "T",   4},	-- !!
--	{ 551.750, 4, "T",  16},
--	{ 552.000, 1, "T",   4},
--	{ 552.333, 2, "T",  12},
--	{ 552.667, 3, "T",  12},
--	{ 553.000, 4, "T",   4},
--	{ 553.333, 3, "T",  12},
--	{ 553.667, 2, "T",  12},
--	{ 554.000, 1, "T",   4},
--	{ 554.500, 4, "T",   8},
--	{ 554.667, 1, "T",  12},
--	{ 554.833, 2, "T",  24},
--	{ 555.000, 3, "T",   4},

	{ 556.000, 4, "T",   4},
	{ 556.500, 3, "T",   8},
	{ 557.000, 2, "T",   4},
	{ 557.250, 1, "T",  16},
	{ 557.750, 2, "T",  16},
	{ 558.000, 1, "T",   4},
	{ 558.500, 3, "T",   8},
	{ 559.000, 2, "T",   4},
	{ 559.250, 4, "T",  16},
	{ 559.750, 2, "T",  16},
	{ 560.000, 4, "T",   4},
	{ 560.500, 1, "T",   8},
	{ 561.000, 2, "T",   4},
	{ 561.250, 3, "T",  16},
	{ 561.750, 2, "T",  16},
	{ 562.000, 3, "T",   4},
	{ 562.500, 4, "T",   8},
	{ 563.000, 4, "T",   4},
	{ 564.000, 1, "T",   4},
	{ 564.500, 1, "T",   8},
	{ 565.000, 3, "T",   4},
	{ 565.250, 2, "T",  16},
	{ 565.750, 3, "T",  16},
	{ 566.000, 2, "T",   4},
	{ 566.500, 4, "T",   8},
	{ 567.000, 1, "T",   4},
	{ 567.250, 2, "T",  16},
	{ 567.750, 1, "T",  16},
	{ 568.000, 2, "T",   4},
	{ 568.500, 3, "T",   8},
	{ 569.000, 4, "T",   4},
	{ 569.250, 2, "T",  16},
	{ 569.750, 4, "T",  16},
	{ 570.000, 2, "T",   4},
	{ 570.500, 3, "T",   8},
	{ 571.000, 1, "T",   4},
	{ 572.000, 4, "T",   4},
	{ 572.500, 1, "T",   8},
	{ 573.000, 2, "T",   4},
	{ 573.250, 3, "T",  16},
	{ 573.750, 3, "T",  16},
	{ 574.000, 4, "T",   4},
	{ 574.500, 2, "T",   8},
	{ 575.000, 3, "T",   4},
	{ 575.250, 1, "T",  16},
	{ 575.750, 1, "T",  16},
	{ 576.000, 4, "T",   4},
	{ 576.500, 3, "T",   8},
	{ 577.000, 2, "T",   4},
	{ 577.250, 1, "T",  16},
	{ 577.750, 1, "T",  16},
	{ 578.000, 3, "T",   4},
	{ 578.500, 2, "T",   8},
	{ 579.000, 4, "T",   4},

	{ 580.000, 1, "T",   4},
	{ 580.500, 2, "T",   8},
	{ 581.000, 1, "T",   4},
	{ 581.250, 2, "T",  16},
	{ 581.750, 1, "T",  16},
	{ 582.000, 4, "T",   4},
	{ 582.500, 2, "T",   8},
	{ 583.000, 4, "T",   4},
	{ 583.250, 2, "T",  16},
	{ 583.750, 2, "T",  16},	-- !!
	{ 584.000, 4, "T",   4},	-- !!
	{ 584.500, 2, "T",   8},	-- !!
	{ 585.000, 4, "T",   4},	-- !!
	{ 585.250, 1, "T",  16},	-- !!
	{ 585.750, 2, "T",  16},	-- !!
	{ 586.000, 1, "T",   4},	-- !!
	{ 586.500, 2, "T",   8},	-- !!
	{ 587.000, 1, "T",   4},	-- !!
--	{ 583.750, 2, "T",  16},
--	{ 584.000, 3, "T",   4},
--	{ 584.500, 1, "T",   8},
--	{ 585.000, 3, "T",   4},
--	{ 585.500, 2, "T",   8},
--	{ 586.000, 4, "T",   4},
--	{ 586.500, 1, "T",   8},
--	{ 586.667, 2, "T",  12},
--	{ 586.833, 1, "T",  24},
--	{ 587.000, 4, "T",   4},
--	{ 588.000, 3, "T",   4},
}

local dualActive = {}


local DualAlignTargets_1 = function(t)
	local moveStrength = dualMoveStrengthAuxActor:getaux()

	local xc = math.fmod(t - dualPhaseBegin + 0.5, dualPhasingPeriod * 2)
	local yc = math.fmod(t - dualPhaseBegin      , dualPhasingPeriod)
	local xp = 0
	local yp = 0

	if xc > dualPhasingPeriod then
		xp = (2*dualPhasingPeriod - xc - 0.5) / (dualPhasingPeriod - 1)
	else
		xp = 					   (xc - 0.5)  / (dualPhasingPeriod - 1)
	end
	if yc > dualPhasingPeriod - 1 then
		yp = RangeScale(yc, dualPhasingPeriod - 1, dualPhasingPeriod,     0.75, 0)
	else
		yp = RangeScale(yc,                     0, dualPhasingPeriod - 1,    0, 0.75)
	end

	local xpp = RangeClamp(xp, 0, 1)

	if playerProxies[1] then
		playerProxies[1]:xy(
			moveStrength * sw * (0.1 + 0.8 * xpp)   + (1 - moveStrength) * dualPlayerOrigin[1][1],
			moveStrength * sh * (0.625 - 0.25 * yp) + (1 - moveStrength) * dualPlayerOrigin[1][2]
			)
		playerJudgeProxies[1]:xy(
			moveStrength * sw * (0.1 + 0.8 * xpp)   + (1 - moveStrength) * dualJudgeOrigin[1][1],
			moveStrength * sh * (0.625 - 0.25 * yp) + (1 - moveStrength) * dualJudgeOrigin[1][2]
			)
		playerJudgeDudes[1]:diffuse(1.0, 1.0 - 0.4 * moveStrength, 1.0 - 0.6 * moveStrength, 1.0)
	end
	if playerProxies[2] then
		playerProxies[2]:xy(
			moveStrength * sw * (0.9 - 0.8 * xpp)   + (1 - moveStrength) * dualPlayerOrigin[2][1],
			moveStrength * sh * (0.625 - 0.25 * yp) + (1 - moveStrength) * dualPlayerOrigin[2][2]
			)
		playerJudgeProxies[2]:xy(
			moveStrength * sw * (0.9 - 0.8 * xpp)   + (1 - moveStrength) * dualJudgeOrigin[2][1],
			moveStrength * sh * (0.625 - 0.25 * yp) + (1 - moveStrength) * dualJudgeOrigin[2][2]
			)
		playerJudgeDudes[2]:diffuse(1.0 - 0.6 * moveStrength, 1.0 - 0.2 * moveStrength, 1.0, 1.0)
	end
end
dualTargetAligner = DualAlignTargets_1


local DualStateNull = function(notary, t) end

local DualAlignArrow_1 = function(notary, t)
	local xc = math.fmod(notary[1] - dualPhaseBegin + 0.5, dualPhasingPeriod * 2)
	local xp = 0
	if xc > dualPhasingPeriod then
		xp = (2*dualPhasingPeriod - xc - 0.5) / (dualPhasingPeriod - 1)
	else
		xp = 					   (xc - 0.5) / (dualPhasingPeriod - 1)
	end

	dualPool[notary[6]]:xy(sw * (0.1 + 0.8 * (xp)), -sh)
end

local DualShowArrow_1 = function(notary, t)
	dualPool[notary[6]]:diffusealpha(     t  * dualMoveStrengthAuxActor:getaux())
					   :y(sh * (0.875 - 0.25 * t))
end
local DualKeepArrow_1 = function(notary, t)
	dualPool[notary[6]]:diffusealpha(          dualMoveStrengthAuxActor:getaux())
					   :y(sh * (0.625 - 0.25 * t))
end
local DualHideArrow_1 = function(notary, t)
	dualPool[notary[6]]:diffusealpha((1 - t) * dualMoveStrengthAuxActor:getaux())
					   :y(sh * (0.375 - 0.25 * t))
end


-- you: these are juicy!
-- me, an intellectual: Lissajous, see?

--
-- unfortunately I built this so it really only works with horizontal symmetry
-- whatecer.
--
-- Safe: plot (-cos(pi*t), cos(4*pi*t)), t = [0, 2]
-- Easy: plot (-cos(pi*t), cos(2*pi*t)), t = [0, 2]
-- Nose: plot (-2/3*cos(pi*t) - 1/3*cos(5*pi*t), cos(2*pi*t)), t = [0, 2]
-- Nope: plot (-cos(3*pi*t), cos(2*pi*t)), t = [0, 2]
function LissajuchieSurviver(t)
	local tx = 2*t - 1
	local tt = (tx*tx*tx * 0.1 + tx * 0.4) + 0.5
	return sw * 0.4 * -math.cos(PI*tt), sh * 0.3 * -math.sin(3*PI*tt)
end


local DualAlignTargets_2 = function(t)
	local moveStrength = dualMoveStrengthAuxActor:getaux()


	local xc = math.fmod(t - dualPhaseBegin + 0.5, dualPhasingPeriod * 2)
	local yc = math.fmod(t - dualPhaseBegin      , dualPhasingPeriod)
	local xp = 0
	local yp = 0
	local ya = 0

	local tclamp = 0
	if xc > dualPhasingPeriod then
		tclamp = (2*dualPhasingPeriod - xc - 0.5) / (dualPhasingPeriod - 1)
	else
		tclamp =                       (xc - 0.5) / (dualPhasingPeriod - 1)
	end
	if yc > dualPhasingPeriod - 1 then
		ya = RangeScale(yc, dualPhasingPeriod - 1, dualPhasingPeriod,     0.75, 0)
	else
		ya = RangeScale(yc,                     0, dualPhasingPeriod - 1,    0, 0.75)
	end
	tclamp = RangeClamp(tclamp, 0, 1)
	xp, yp = LissajuchieSurviver(tclamp)

	if playerProxies[1] then
		playerProxies[1]:xy(
			moveStrength * (sw *  0.5                + xp) + (1 - moveStrength) * dualPlayerOrigin[1][1],
			moveStrength * (sh * (0.375 + 0.25 * ya) - yp) + (1 - moveStrength) * dualPlayerOrigin[1][2]
			)
		playerJudgeProxies[1]:xy(
			moveStrength * (sw *  0.5                + xp) + (1 - moveStrength) * dualJudgeOrigin[1][1],
			moveStrength * (sh * (0.375 + 0.25 * ya) - yp) + (1 - moveStrength) * dualJudgeOrigin[1][2]
			)
		playerJudgeDudes[1]:diffuse(1.0, 1.0 - 0.4 * moveStrength, 1.0 - 0.6 * moveStrength, 1.0)
	end
	if playerProxies[2] then
		playerProxies[2]:xy(
			moveStrength * (sw *  0.5                - xp) + (1 - moveStrength) * dualPlayerOrigin[2][1],
			moveStrength * (sh * (0.375 + 0.25 * ya) - yp) + (1 - moveStrength) * dualPlayerOrigin[2][2]
			)
		playerJudgeProxies[2]:xy(
			moveStrength * (sw *  0.5                - xp) + (1 - moveStrength) * dualJudgeOrigin[2][1],
			moveStrength * (sh * (0.375 + 0.25 * ya) - yp) + (1 - moveStrength) * dualJudgeOrigin[2][2]
			)
		playerJudgeDudes[2]:diffuse(1.0 - 0.6 * moveStrength, 1.0 - 0.2 * moveStrength, 1.0, 1.0)
	end
end

local DualAlignArrow_2 = function(notary, t)
	local xc = math.fmod(notary[1] - dualPhaseBegin + 0.5, dualPhasingPeriod * 2)
	local xp = 0
	local yp = 0
	if xc > dualPhasingPeriod then
		xp, yp = LissajuchieSurviver( (2*dualPhasingPeriod - xc - 0.5) / (dualPhasingPeriod - 1) )
	else
		xp, yp = LissajuchieSurviver(                       (xc - 0.5) / (dualPhasingPeriod - 1) )
	end

	notary[9] = yp
	dualPool[notary[6]]:xy(sw * 0.5 + xp, -sh)
end

local DualShowArrow_2 = function(notary, t)
	dualPool[notary[6]]:diffusealpha(     t  * dualMoveStrengthAuxActor:getaux())
					   :y(sh * (0.125 + 0.25 * t) - notary[9])
end
local DualKeepArrow_2 = function(notary, t)
	dualPool[notary[6]]:diffusealpha(     	   dualMoveStrengthAuxActor:getaux())
					   :y(sh * (0.375 + 0.25 * t) - notary[9])
end
local DualHideArrow_2 = function(notary, t)
	dualPool[notary[6]]:diffusealpha((1 - t) * dualMoveStrengthAuxActor:getaux())
					   :y(sh * (0.625 + 0.25 * t) - notary[9])
end


local dualStateRules = {
	-- Functions that determine how long the arrow state is and what it should be doing.
	-- [1]: state length
	-- [2]: state function, operating on [0, 1) time basis

	{0, DualAlignArrow},	-- setup
	{2, DualShowArrow},		-- appearing
	{4, DualKeepArrow},		-- active/approaching
	{2, DualHideArrow},		-- disappearing
	{0, DualStateNull}		-- takedown	
}

local dualAdvanceNotice = 
	dualStateRules[1][1] + 
	dualStateRules[2][1]



-- YOU MAY NOT ACTIVATE NOTES OUT OF ORDER.
-- WHY BOTHER, YOU ASS
--
-- DO NOT BOTHER MY ASS
-- GO BOTHER YOUR OWN ASS

function DualActivateWhen(t)
	-- What time should I actually activate this note?
	if t >= dualPhaseBegin and t <= dualPhaseEnd then
		return dualPhaseBegin + math.floor((t - dualPhaseBegin) / dualPhasingPeriod) * dualPhasingPeriod - dualAdvanceNotice
	else
		return t - dualAdvanceNotice
	end
end

function DualArrowActivate(note)
	local poolIndexChosen = 0
	for poolIndex = 1,#dualPool do
		if dualPoolActive[poolIndex] == 0 then
			dualPoolActive[poolIndex] = #dualActive + 1
			poolIndexChosen = poolIndex
			break
		end
	end

	if poolIndexChosen == 0 then
		Trace("### No pool arrows available to activate!!")
		return
	end

	dualActive[#dualActive+1] = {
		-- copied over from source list:
		-- [1]: beat number, zero at start
		-- [2]: lane number, one-indexed
		-- [3]: note type (Tap, Hold, End, Roll, or Mine)
		-- [4]: quantization reciprocal
		-- [5]: extra data, e.g. in this file the value determines
		--		[1]:	whether the note is part of an emotion row (true)
		--				or acts on its own (false)
		--		[2]:	the beat offset of the note in its row
		-- 
		-- added parameters on activation:
		-- [6]:	pool actor index
		-- [7]: arrow state
		--		1:	setup
		--		2:	appearing
		--		3:	active/moving
		--		4:	disappearing
		--		5:	takedown
		-- [8]:	state start beat
		-- [9]: y offset
		note[1],
		note[2],
		note[3],
		note[4],
		{true, 0},		-- note[5],

		poolIndexChosen,
		1,
		overtime,
		0,
	}
end


function DualArrowAct(notary)
	local currentState = notary[7]

	if currentState > 5 then
		Trace("### Active arrow "..notary[1]..":"..notary[2].." reached impossible state!!")
		return true
	end


	local stateRule = dualStateRules[currentState]
	local t = (stateRule[1] == 0) and 1 or (overtime - notary[8]) / stateRule[1]
	local iWantToDie = false


	-- Take state action
	if currentState == 1 then
		stateRule[2](notary, t)
		if t >= 1 then
			dualPool[ notary[6] ]:visible(true)
								 :texturetranslate( texArrows[notary[4]], 0 )
								 :baserotationz( baserotationzByLane[notary[2]] )
		end

	elseif currentState == 2 then
		stateRule[2](notary, t)

	elseif currentState == 3 then
		stateRule[2](notary, t)

	elseif currentState == 4 then
		stateRule[2](notary, t)

	elseif currentState == 5 then
		stateRule[2](notary, t)
		if t >= 1 then
			dualPool[ notary[6] ]:visible(false)
			dualPoolActive[ notary[6] ] = 0
			iWantToDie = true
		end

	else
		Trace("### Active arrow "..notary[1]..":"..notary[2].." reached impossible state!!")
		iWantToDie = true
	end


	if t >= 1 then
		-- Advance state
		notary[8] = notary[8] + stateRule[1]
		notary[7] = notary[7] + 1
	end

	return notary, iWantToDie
end


function DualUpdate()
	local dualActiveReplace = {}

--	Trace("### >>> #dualActive = "..#dualActive)
	-- Update all the notes that are currently active.
	for i,notary in ipairs(dualActive) do
--		Trace("### >>> Act on "..i.."...")
		local notaryNew, killOffNote = DualArrowAct(notary)
		if not killOffNote then
			dualActiveReplace[#dualActiveReplace + 1] = notaryNew
		end
	end

	dualActive = dualActiveReplace

	-- Decide whether to activate any new notes.
	while dualNextNote <= #dualSource do
--		Trace("### Checking note "..dualNextNote.."...")
		-- TODO: handling for activation at another time
		if DualActivateWhen(dualSource[dualNextNote][1]) <= overtime then
--		if dualSource[dualNextNote][1] + dualAdvanceNotice <= overtime then
--			Trace("### !!! Activate "..dualNextNote.."!")
			DualArrowActivate( dualSource[dualNextNote] )
			dualNextNote = dualNextNote + 1
		else
			break
		end
	end
end


for poop = 1,dualPoolSize do
	_FG_[#_FG_ + 1] = NOTESKIN:LoadActorForNoteSkin("Down", "Tap Note", "cyber") .. {
		Name = "DualPool_"..poop,
		InitCommand = function(self)
			dualPool[poop] = self
			self:visible(false)
				:aux(poop)
				:z(5)
				:zoom(0.75)
		end,
	}
	dualPoolActive[#dualPoolActive + 1] = 0
end


_FG_[#_FG_ + 1] = Def.Actor {
	InitCommand = function(self)
		dualMoveStrengthAuxActor = self
		self:aux(0)
	end,


	DualEngageMessageCommand = function(self, args)
		local duration 	= (#args >= 1) and args[1] or 8

		self:finishtweening()
			:accelerate(duration / BPS)
			:aux(1)
	end,

	DualDisengageMessageCommand = function(self, args)	
		local duration 	= (#args >= 1) and args[1] or 8
		
		self:finishtweening()
			:decelerate(duration / BPS)
			:aux(0)
	end,
}

--
--
--	Don't Mess With My Emotions !!
--
--
-------------------------------------------------------------------------------




-------------------------------------------------------------------------------
--
-- 		Proxies (as usual)
--

--
--	Player proxies (one apiece)
--
for pn = 1,2 do
	i = 1
	_FG_[#_FG_ + 1] = Def.ActorFrame {	
		Name = "ProxyP"..pn.."Outer",
		Def.ActorFrame {	
			Name = "ProxyP"..pn.."Inner",
			Def.ActorProxy {					
				Name = "ProxyP"..pn,
				InitCommand = function(self)
					self:aux( Whomst(self) )
				end,
				BeginCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then self:SetTarget(McCoy) else self:hibernate(1573) end
				end,
				OnCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end,
				RecenterProxyMessageCommand=function(self)					
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end
			},
			InitCommand = function(self)
--				self:aux( Whichst(self) )
				playerProxies[pn] = self

				self:SetDrawByZPosition(true)
					:fov(75)
			end,
			OnCommand = function(self)
			end,
		},
		InitCommand = function(self)
--			self:aux( Whichst(self) )
		end,
		OnCommand = function(self)
			self:xy(0, 0)
				:z(1)
		end,
	}
end


--
--	Judgment proxies
--
for pn = 1,2 do
	_FG_[#_FG_ + 1] = Def.ActorProxy {
		Name = "JudgeP"..pn.."Proxy",
		InitCommand = function(self)
			self:aux( Whomst(self) )
			playerJudgeProxies[pn] = self
		end,
		BeginCommand = function(self)
			local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
			if McCoy then 
				local McJudge = McCoy:GetChild('Judgment')
				self:SetTarget(McJudge)
				McJudge:visible(false)
				playerJudgeDudes[Whomst(self)] = McJudge
			else 
				self:hibernate(1573)
			end
		end,
		OnCommand = function(self)
			local p = self:GetParent()
						  :GetChild('ProxyP'..self:getaux().."Outer")
						  :GetChild('ProxyP'..self:getaux().."Inner")
			
			self:xy(p:GetX(), sh/2)
			dualJudgeOrigin[Whomst(self)][1] = p:GetX()
			dualJudgeOrigin[Whomst(self)][2] = sh/2
		end,
	}
end

--
-- 		Proxies (as usual)
--
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
--
-- 		This is where the shit will be happening.
--

local messageList = {
	{  4.00, "RecenterProxy"},

	{194.000, "EngageCorner",			{0}},
	{195.000, "SwitchCorner",			{1, 1, 1}},
	{195.000, "RotateWholeField",		{  1, 1,  -45}},
	{196.000, "RotateWholeField",		{0.5, 1,  -30}},
	{196.500, "RotateWholeField",		{0.5, 1,  -60}},
	{197.000, "RotateWholeField",		{  1, 1,  -45}},
	{198.000, "RotateWholeField",		{0.5, 1,  -60}},
	{198.500, "RotateWholeField",		{0.5, 1,  -30}},
	{199.000, "SwitchCorner",			{1, 2, 2}},
	{199.000, "RotateWholeField",		{  1, 2,   45}},
	{200.000, "RotateWholeField",		{0.5, 2,   30}},
	{200.500, "RotateWholeField",		{0.5, 2,   60}},
	{201.000, "RotateWholeField",		{  1, 2,   45}},
	{202.000, "RotateWholeField",		{0.5, 2,   60}},
	{202.500, "RotateWholeField",		{0.5, 2,   30}},
	{203.000, "SwitchCorner",			{1, 1, 4}},
	{203.000, "RotateWholeField",		{  1, 1,  135}},
	{204.000, "RotateWholeField",		{0.5, 1,  150}},
	{204.500, "RotateWholeField",		{0.5, 1,  120}},
	{205.000, "RotateWholeField",		{  1, 1,  135}},
	{206.000, "RotateWholeField",		{0.5, 1,  120}},
	{206.500, "RotateWholeField",		{0.5, 1,  150}},
	{207.000, "SwitchCorner",			{1, 2, 3}},
	{207.000, "RotateWholeField",		{  1, 2, -135}},
	{208.000, "RotateWholeField",		{0.5, 2, -150}},
	{208.500, "RotateWholeField",		{0.5, 2, -120}},
	{209.000, "RotateWholeField",		{  1, 2, -135}},
	{210.000, "RotateWholeField",		{0.5, 2, -120}},
	{210.500, "RotateWholeField",		{0.5, 2, -150}},
	{211.000, "SwitchCorner",			{1, 1, 2}},
	{211.000, "RotateWholeField",		{  1, 1,   45}},
	{212.000, "RotateWholeField",		{0.5, 1,   30}},
	{212.500, "RotateWholeField",		{0.5, 1,   60}},
	{213.000, "RotateWholeField",		{  1, 1,   45}},
	{214.000, "RotateWholeField",		{0.5, 1,   60}},
	{214.500, "RotateWholeField",		{0.5, 1,   30}},
	{215.000, "SwitchCorner",			{1, 2, 1}},
	{215.000, "RotateWholeField",		{  1, 2,  -45}},
	{216.000, "RotateWholeField",		{0.5, 2,  -30}},
	{216.500, "RotateWholeField",		{0.5, 2,  -60}},
	{217.000, "RotateWholeField",		{  1, 2,  -45}},
	{218.000, "RotateWholeField",		{0.5, 2,  -60}},
	{218.500, "RotateWholeField",		{0.5, 2,  -30}},
	{219.000, "SwitchCorner",			{1, 1, 3}},
	{219.000, "RotateWholeField",		{  1, 1, -135}},
	{220.000, "RotateWholeField",		{0.5, 1, -150}},
	{220.500, "RotateWholeField",		{0.5, 1, -120}},
	{221.000, "RotateWholeField",		{  1, 1, -135}},
	{222.000, "RotateWholeField",		{0.5, 1, -120}},
	{222.500, "RotateWholeField",		{0.5, 1, -150}},
	{223.000, "SwitchCorner",			{1, 2, 4}},
	{223.000, "RotateWholeField",		{  1, 2,  135}},
	{224.000, "RotateWholeField",		{0.5, 2,  150}},
	{224.500, "RotateWholeField",		{0.5, 2,  120}},
	{225.000, "RotateWholeField",		{  1, 2,  135}},
	{226.000, "RotateWholeField",		{0.5, 2,  120}},
	{226.500, "RotateWholeField",		{0.5, 2,  150}},
	{227.000, "SwitchCorner",			{1, 1, 1}},
	{227.000, "RotateWholeField",		{  1, 1,  -45}},
	{228.000, "RotateWholeField",		{0.5, 1,  -30}},
	{228.500, "RotateWholeField",		{0.5, 1,  -60}},
	{229.000, "RotateWholeField",		{  1, 1,  -45}},
	{230.000, "RotateWholeField",		{0.5, 1,  -60}},
	{230.500, "RotateWholeField",		{0.5, 1,  -30}},
	{231.000, "SwitchCorner",			{1, 2, 2}},
	{231.000, "RotateWholeField",		{  1, 2,   45}},
	{232.000, "RotateWholeField",		{0.5, 2,   30}},
	{232.500, "RotateWholeField",		{0.5, 2,   60}},
	{233.000, "RotateWholeField",		{  1, 2,   45}},
	{234.000, "RotateWholeField",		{0.5, 2,   60}},
	{234.500, "RotateWholeField",		{0.5, 2,   30}},
	{235.000, "SwitchCorner",			{1, 1, 4}},
	{235.000, "RotateWholeField",		{  1, 1,  135}},
	{236.000, "RotateWholeField",		{0.5, 1,  150}},
	{236.500, "RotateWholeField",		{0.5, 1,  120}},
	{237.000, "RotateWholeField",		{  1, 1,  135}},
	{238.000, "RotateWholeField",		{0.5, 1,  120}},
	{238.500, "RotateWholeField",		{0.5, 1,  150}},
	{239.000, "SwitchCorner",			{1, 2, 3}},
	{239.000, "RotateWholeField",		{  1, 2, -135}},
	{240.000, "RotateWholeField",		{0.5, 2, -150}},
	{240.500, "RotateWholeField",		{0.5, 2, -120}},
	{241.000, "RotateWholeField",		{  1, 2, -135}},
	{242.000, "RotateWholeField",		{0.5, 2, -120}},
	{242.500, "RotateWholeField",		{0.5, 2, -150}},
	{243.000, "SwitchCorner",			{1, 1, 2}},
	{243.000, "RotateWholeField",		{  1, 1,   45}},
	{244.000, "RotateWholeField",		{0.5, 1,   30}},
	{244.500, "RotateWholeField",		{0.5, 1,   60}},
	{245.000, "RotateWholeField",		{  1, 1,   45}},
	{246.000, "RotateWholeField",		{0.5, 1,   60}},
	{246.500, "RotateWholeField",		{0.5, 1,   30}},
	{247.000, "SwitchCorner",			{1, 2, 1}},
	{247.000, "RotateWholeField",		{  1, 2,  -45}},
	{248.000, "RotateWholeField",		{0.5, 2,  -30}},
	{248.500, "RotateWholeField",		{0.5, 2,  -60}},
	{249.000, "RotateWholeField",		{  1, 2,  -45}},
	{250.000, "RotateWholeField",		{0.5, 2,  -60}},
	{250.500, "RotateWholeField",		{0.5, 2,  -30}},
	{251.000, "SwitchCorner",			{1, 1, 0}},
	{251.000, "RotateWholeField",		{1, 1, 0}},
	{251.000, "RotateWholeField",		{1, 2, 0}},
	{252.000, "DisengageCorner",		{0}},


	{256.000, "EngageMidscreen",		{0}},
	{260.000, "BeginMidscreen",			{4}},
	{320.000, "EngageMidscreen",		{4}},
	{324.000, "DisengageMidscreen",		{0}},

	{ 80.000, "DualSetup1",				{}},

	{196.000, "DualSetup2",				{}},
};


for dti,dtv in ipairs(dualEngageTimes) do
	local dtb = dtv[1] - dtv[2]
	messageList[#messageList + 1] = {   dtb,	"DualEngage",	  {dtv[2]} }
end

for dti,dtv in ipairs(dualDisengageTimes) do
	messageList[#messageList + 1] = {   dtv[1],	"DualDisengage",  {dtv[2]} }
end


messageList = SortModsTable(messageList)

gfxUpdateFunction = function()
	-- Most things are determined by beat, believe it or not.		
	overtime = GAMESTATE:GetSongBeat() - visualOffset
	
	-- TODO: this assumes the effect applies over a constant BPM section!!
	BPS = GAMESTATE:GetSongBPS()
	
	-- Initializations
	if overtime >=   0.0 and not checked then
		for i,v in ipairs(plr) do
			if v then
				v:visible(false):decelerate(4.0 / BPS)
				 :x(sw/2)
--				 :y(sh/2 - 30)
				 :z(0)
			end
		end

		checked = true
	end
			
	-- Broadcast messages on their own terms.
	while true do
		if fgmsg < #messageList then
			messageBeat, messageName, messageArgs = unpack(messageList[fgmsg+1])
			if overtime >= messageBeat then			
				if messageArgs then
					MESSAGEMAN:Broadcast( messageName, messageArgs )
				else
					MESSAGEMAN:Broadcast( messageName )
				end
				
				fgmsg = fgmsg + 1
			else
				break
			end
		else
			break
		end
	end


	-- Emotional feeling
	DualUpdate()
	dualTargetAligner(overtime)


--	Trace('Update @ ' .. GAMESTATE:GetSongBeat() .. " (" .. GAMESTATE:GetCurMusicSeconds() .. " sec.)")
end


-------------------------------------------------------------------------------
--
-- Messaging controller
--

local mmmDirections = {
	{
		{-48,   0},
		{  0,  48},
		{  0, -48},
		{ 48,   0},
	},
	{
		{-sw*0.4,       0},
		{      0,  sw*0.4},
		{      0, -sw*0.4},
		{ sw*0.4,       0},
	},
	{
		{-sw*0.6,       0},
		{      0,  sw*0.6},
		{      0, -sw*0.6},
		{ sw*0.6,       0},
	},
}
_FG_[#_FG_ + 1] = Def.ActorFrame {
	EngageMidscreenMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4

		for pn = 1,2 do
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:smooth(tweenTime / BPS)
				cv:GetPosHandler():SetSplineMode('NoteColumnSplineMode_Position')
				cv:GetPosHandler():SetBeatsPerT(2)
				local splr = cv:GetPosHandler():GetSpline()
				splr:SetSize(3)
				splr:SetPoint(1, {0, 0, 0})
				splr:SetPoint(2, {0, sh/2, 0})
				splr:SetPoint(3, {0, sh, 0})
				splr:Solve()
			end
		end
	end,
	BeginMidscreenMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4

		for pn = 1,2 do
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:smooth(tweenTime / BPS)
				cv:GetPosHandler():SetSplineMode('NoteColumnSplineMode_Position')
				cv:GetPosHandler():SetBeatsPerT(2)
				local splr = cv:GetPosHandler():GetSpline()
				splr:SetSize(3)
				splr:SetPoint(1, {mmmDirections[1][i][1], mmmDirections[1][i][2],    0})
				splr:SetPoint(2, {mmmDirections[2][i][1], mmmDirections[2][i][2], -100})
				splr:SetPoint(3, {mmmDirections[3][i][1], mmmDirections[3][i][2],    0})
				splr:Solve()
			end
		end
	end,
	DisengageMidscreenMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4

		for pn = 1,2 do
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:GetPosHandler():SetSplineMode('NoteColumnSplineMode_Disabled')
				cv:GetPosHandler():SetBeatsPerT(2)
				local splr = cv:GetPosHandler():GetSpline()
				splr:SetSize(3)
				splr:SetPoint(1, {0, 0, 0})
				splr:SetPoint(2, {0, sh/2, 0})
				splr:SetPoint(3, {0, sh, 0})
				splr:Solve()
			end
		end
	end,



	EngageCornerMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4

		for pn = 1,2 do			
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:smooth(tweenTime / BPS)
				cv:GetRotHandler():SetSplineMode('NoteColumnSplineMode_Position')
				cv:GetRotHandler():SetBeatsPerT(4)
				local splr = cv:GetRotHandler():GetSpline()
				splr:SetSize(2)
				splr:SetPoint(1, {0, 0, 0})
				splr:SetPoint(2, {0, 0, 0})
				splr:Solve()
			end

			dualPlayerOrigin[pn][1] = playerProxies[pn]:GetX()
			dualPlayerOrigin[pn][2] = playerProxies[pn]:GetY()
		end
	end,
	SwitchCornerMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4
		local pnSwitchTo 	= (#args >= 2) and args[2] or 1
		local cornerChoice 	= (#args >= 3) and args[3] or 4		-- UL, UR, DL, DR

		local ccLR = (cornerChoice == 1 or cornerChoice == 3) and -1 or 1
		local ccUD = (cornerChoice == 1 or cornerChoice == 2) and -1 or 1
		ccLR = (cornerChoice == 0) and 0 or ccLR
		ccUD = (cornerChoice == 0) and 0 or ccUD

		playerProxies[    pnSwitchTo]			
			:xy(sw * 0.5 + sh * 0.4 * ccLR, sh * 0.5 + sh * 0.4 * ccUD)
			:decelerate(tweenTime / BPS)
			:diffusealpha(1.0)
		playerProxies[3 - pnSwitchTo]
			:accelerate(tweenTime / BPS)
			:diffusealpha(0.0)
	end,
	DisengageCornerMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4

		for pn = 1,2 do
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:GetRotHandler():SetSplineMode('NoteColumnSplineMode_Disabled')
			end

			playerProxies[pn]:finishtweening()
							 :xy(dualPlayerOrigin[pn][1], dualPlayerOrigin[pn][2])
							 :diffusealpha(1.0)
		end
	end,

	-- Control the rotation splines
	RotateWholeFieldMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4
		local pn 			= (#args >= 2) and args[2] or 1
		local endingAngle 	= (#args >= 3) and args[3] or 0

		local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
		local nf = pp:GetChild('NoteField')

		for i,cv in ipairs(nf:GetColumnActors()) do
			cv:smooth(tweenTime / BPS)
			cv:GetRotHandler():SetSplineMode('NoteColumnSplineMode_Offset')
			cv:GetRotHandler():SetBeatsPerT(1.3 - i * 0.2)
			local splr = cv:GetRotHandler():GetSpline()
			splr:SetSize(2)
			splr:SetPoint(1, {0, 0, -endingAngle * DEG_TO_RAD})
			splr:SetPoint(2, {0, 0, -endingAngle * DEG_TO_RAD})
			splr:Solve()
		end

		if playerProxies[pn] then
			playerProxies[pn]:decelerate(tweenTime/BPS)
							 :rotationz(endingAngle)
		end
	end,



	DualSetup1MessageCommand = function(self, args)
		dualTargetAligner 	= DualAlignTargets_1

		dualWhichPhase		= 1
		dualPhaseBegin		= 132
		dualPhaseEnd		= 196
		dualPhasingPeriod	= 4

		dualStateRules = {
			-- Functions that determine how long the arrow state is and what it should be doing.
			-- [1]: state length
			-- [2]: state function, operating on [0, 1) time basis

			{0, DualAlignArrow_1},	-- setup
			{2, DualShowArrow_1},	-- appearing
			{4, DualKeepArrow_1},	-- active/approaching
			{2, DualHideArrow_1},	-- disappearing
			{0, DualStateNull}		-- takedown	
		}

		dualAdvanceNotice = 
			dualStateRules[1][1] + 
			dualStateRules[2][1]
	end,

	DualSetup2MessageCommand = function(self, args)
		dualTargetAligner 	= DualAlignTargets_2
		
		dualWhichPhase		= 2
		dualPhaseBegin		= 460
		dualPhaseEnd		= 588
		dualPhasingPeriod	= 8

		dualStateRules = {
			-- Functions that determine how long the arrow state is and what it should be doing.
			-- [1]: state length
			-- [2]: state function, operating on [0, 1) time basis

			{0, DualAlignArrow_2},	-- setup
			{2, DualShowArrow_2},	-- appearing
			{8, DualKeepArrow_2},	-- active/approaching
			{2, DualHideArrow_2},	-- disappearing
			{0, DualStateNull}		-- takedown	
		}

		dualAdvanceNotice = 
			dualStateRules[1][1] + 
			dualStateRules[2][1]
	end,

}


-- Perframe controller
_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		self:SetUpdateFunction(gfxUpdateFunction)
	end,

	Def.ActorFrame {
		InitCommand = function(self)
			self:sleep(69420)
		end
	}
}


-- Load the mods table parser into this script.
modsTable = {
	-- [1]: beat start
	-- [2]: mod type
	-- [3]: mod strength (out of unity),
	-- [4]: mod approach (in beats to complete)
	-- [5]: player application (1 = P1, 2 = P2, 3 = both, 0 = neither)
		
		{   0.0,	"ScrollSpeed",	niceSpeed,    0.0,	3}, 
		{   0.0,	"Dark",				  0.5,    4.0,	3}, 
--		{  16.0,	"Drunk",			  2.0,   16.0,	1},
--		{  16.0,	"Expand",			  1.0,   16.0,	1},
--		{   3.5,	"Beat",				  0.5,    0.0,	3}, 
--		{   4.0,	"Beat",				  0.0,   64.0,	3}, 
--		{  68.0,	"Beat",				  0.7,   56.0,	3}, 
--		{ 123.5,	"Beat",				  0.0,    0.0,	3}, 

		{  64.0,	"Flip",				  0.9,    4.0,	3}, 
		{  64.0,	"Tornado",			  1.0,    4.0,	3}, 
		{  64.0,	"Stealth",			  0.7,    4.0,	3}, 
		{  68.0,	"Flip",				  0.0,   32.0,	3}, 
		{  68.0,	"Tornado",			  0.0,   32.0,	3}, 
		{  68.0,	"Stealth",			  0.0,   32.0,	3}, 

		{ 116.0,	"Mini",				  1.0,   11.0,  3},
		{ 124.0,	"Centered",		niceSpeed,    3.0,  3},		-- theoretically speed * 1.2 but that goes way offscreen
		{ 127.0,	"Centered",			  0.0,    1.0,  3},
		{ 127.0,	"Mini",				  0.5,    1.0,  3},


		{ 195.0,	"ScrollSpeed",	slowSpeed,    1.0,	3}, 
		{ 195.0,	"Centered",			  0.01,   1.0,  3},
		{ 252.0,	"Flip",				  0.5,    8.0,  3},

		{ 320.0,	"ScrollSpeed",	niceSpeed,    4.0,	3}, 
		{ 320.0,	"Flip",				  0.0,    4.0,  3},
		{ 320.0,	"Centered",			  0.0,    4.0,  3},


		{ 324.0,	"Beat",				 -1.5,   64.0,  1},
		{ 324.0,	"Beat",				  1.5,   64.0,  2},
		{ 384.0,	"Beat",				  0.0,    4.0,  3},


		{ 451.9,	"Stealth",			  0.9,    0.2,  3},
		{ 451.9,	"Dark",				  1.0,    0.2,  3},
		{ 452.9,	"Stealth",			  0.8,    0.2,  3},
		{ 452.9,	"Dark",				  0.7,    0.2,  3},
		{ 453.9,	"Stealth",			  0.7,    0.2,  3},
		{ 453.9,	"Dark",				  0.4,    0.2,  3},
		{ 454.9,	"Stealth",			  0.5,    0.2,  3},
		{ 454.9,	"Dark",				  0.2,    0.2,  3},
		{ 455.9,	"Stealth",			  0.0,    0.2,  3},

		{ 587.5,	"Beat",				  1.5,    0.0,  1},
		{ 587.5,	"Beat",				 -1.5,    0.0,  2},
		{ 588.0,	"Beat",				  0.0,  128.0,  3},

		{ 652.0,	"Tornado",			  0.5,   64.0,  3},
		{ 716.0,	"Tornado",			 -0.5,    8.0,  3},

}


function AddURShift(playerNumber, beatIndex, duration, shiftU, shiftR)
	local i =  0.75 * shiftU - 0.25 * shiftR
	local f = -0.25 * shiftU - 0.25 * shiftR

	modsTable[#modsTable + 1] = {beatIndex,	"Flip",     f,	duration,	playerNumber}
	modsTable[#modsTable + 1] = {beatIndex,	"Invert",   i,	duration,	playerNumber}
end

function AddURWiggle(startBeat, shiftU, shiftR)
	AddURShift(3, startBeat + 0.0, 1.0, shiftU, shiftR)
	AddURShift(3, startBeat + 1.0, 0.5,      0,      0)
	AddURShift(3, startBeat + 1.5, 0.5, shiftU, shiftR)
	AddURShift(3, startBeat + 2.0, 0.5,      0,      0)
	AddURShift(3, startBeat + 2.5, 0.5, shiftU, shiftR)
	AddURShift(3, startBeat + 4.0, 4.0,      0,      0)
end

AddURWiggle(324,  1.0, -1.0)
AddURWiggle(332, -2.0, -2.0)
AddURWiggle(340,  1.0, -1.0)
AddURWiggle(348, -2.0, -2.0)
AddURWiggle(356,  1.0, -1.0)
AddURWiggle(364, -2.0, -2.0)
AddURWiggle(372,  1.0, -1.0)
AddURWiggle(380, -2.0, -2.0)

AddURWiggle(588, -2.5, -2.5)
AddURWiggle(596,  1.5, -1.5)
AddURWiggle(604, -2.5, -2.5)
AddURWiggle(612,  1.5, -1.5)
AddURWiggle(620, -2.5, -2.5)
AddURWiggle(628,  1.5, -1.5)
AddURWiggle(636, -2.5, -2.5)
AddURWiggle(644,  1.5, -1.5)

AddURWiggle(652,  1.0, -1.0)
AddURWiggle(660,  1.0, -1.0)
AddURWiggle(668,  1.0, -1.0)
AddURWiggle(676,  1.0, -1.0)
AddURWiggle(684,  0.8, -0.8)
AddURWiggle(692,  0.6, -0.6)
AddURWiggle(700,  0.4, -0.4)
AddURWiggle(708,  0.2, -0.2)



for beatIndex = 4,62,2 do	
	local modStrength = RangeScale(beatIndex, 4, 62, 0, 1)
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Cross",		  0.2 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Cross",		 -0.2 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Reverse",		 -0.4 * modStrength,    0.0,	2} 
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Cross",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Reverse",		  0.0, 				    1.0,	3} 
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Cross",		  0.2 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Cross",		 -0.2 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Reverse",		 -0.4 * modStrength,    0.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 1.05,	"Cross",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 1.05,	"Reverse",		  0.0, 				    1.0,	3} 
end
for beatIndex = 100,114,2 do	
	local modStrength = RangeScale(beatIndex, 100, 124, 0, 1)
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Cross",		  0.2 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Cross",		 -0.2 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Reverse",		 -0.4 * modStrength,    0.0,	2} 
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Cross",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Reverse",		  0.0, 				    1.0,	3} 
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Cross",		  0.2 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Cross",		 -0.2 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Reverse",		 -0.4 * modStrength,    0.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 1.05,	"Cross",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 1.05,	"Reverse",		  0.0, 				    1.0,	3} 
end
for beatIndex = 116,123   do	
	local modStrength = RangeScale(beatIndex, 100, 124, 0, 1)
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Cross",		  0.2 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Cross",		 -0.2 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Reverse",		 -0.4 * modStrength,    0.0,	2} 
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Cross",		  0.0,				    0.4,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Reverse",		  0.0, 				    0.4,	3} 
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Cross",		  0.2 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Cross",		 -0.2 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Reverse",		 -0.4 * modStrength,    0.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 0.55,	"Cross",		  0.0,				    0.4,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.55,	"Reverse",		  0.0, 				    0.4,	3} 
end


for beatIndex = 195,243,8 do	
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Stealth",		  1.0,    1.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Dark",			  1.0,    1.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Stealth",		  0.0,    1.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Dark",			  0.0,	  1.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 4.00,	"Stealth",		  1.0,    1.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 4.00,	"Dark",			  1.0,    1.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 4.00,	"Stealth",		  0.0,    1.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 4.00,	"Dark",			  0.0, 	  1.0,	2} 
end
modsTable[#modsTable + 1] = {251,	"Stealth",		  0.0,    1.0,	3} 
modsTable[#modsTable + 1] = {251,	"Dark",			  0.0,	  1.0,	3}



for beatIndex = 388,434,2 do	
	local modStrength = RangeScale(beatIndex, 388, 436, 0, 1)
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Drunk",		  2.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Drunk",		 -2.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Tipsy",		  1.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Tipsy",		 -1.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Bumpy",		  0.4 * modStrength,    0.0,	2} 
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Drunk",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Tipsy",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Bumpy",		  0.0, 				    1.0,	3} 
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Drunk",		  2.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Drunk",		 -2.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Tipsy",		  1.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Tipsy",		 -1.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Bumpy",		  0.4 * modStrength,    0.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 1.05,	"Drunk",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 1.05,	"Tipsy",		  0.0,				    1.0,	3}
	modsTable[#modsTable + 1] = {beatIndex + 1.05,	"Bumpy",		  0.0, 				    1.0,	3} 
end
for beatIndex = 436,447   do	
	local modStrength = RangeScale(beatIndex, 436, 447, 1, 1.5)
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Drunk",		  2.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Drunk",		 -2.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Tipsy",		  1.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Tipsy",		 -1.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Bumpy",		  0.4 * modStrength,    0.0,	2} 
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Drunk",		  0.0,				    0.5,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Tipsy",		  0.0,				    0.5,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.05,	"Bumpy",		  0.0, 				    0.5,	3} 
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Drunk",		  2.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Drunk",		 -2.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Tipsy",		  1.0 * modStrength,    0.0,	1}
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Tipsy",		 -1.0 * modStrength,    0.0,	2}
	modsTable[#modsTable + 1] = {beatIndex + 0.50,	"Bumpy",		  0.4 * modStrength,    0.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 0.55,	"Drunk",		  0.0,				    0.5,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.55,	"Tipsy",		  0.0,				    0.5,	3}
	modsTable[#modsTable + 1] = {beatIndex + 0.55,	"Bumpy",		  0.0, 				    0.5,	3} 
end

for beatIndex = 588,650,2 do
	modStrength = RangeScale(beatIndex, 588, 652, 0.0, 0.1)
	modsTable[#modsTable + 1] = { beatIndex - 0.10,	"Cross",	  modStrength*2,  0.2,	3 }
	modsTable[#modsTable + 1] = { beatIndex - 0.10,	"Reverse",	 -modStrength,    0.2,	3 } 
	modsTable[#modsTable + 1] = { beatIndex + 0.90,	"Cross",	 -modStrength*2,  0.2,  3 } 
	modsTable[#modsTable + 1] = { beatIndex + 0.90,	"Reverse",	  modStrength,    0.2,	3 } 
end
for beatIndex = 652,700,2 do
	modStrength = RangeScale(beatIndex, 652, 700, 0.1, 0.0)
	modsTable[#modsTable + 1] = { beatIndex - 0.10,	"Cross",	  modStrength*2,  0.2,	3 }
	modsTable[#modsTable + 1] = { beatIndex - 0.10,	"Reverse",	 -modStrength,    0.2,	3 } 
	modsTable[#modsTable + 1] = { beatIndex + 0.90,	"Cross",	 -modStrength*2,  0.2,  3 } 
	modsTable[#modsTable + 1] = { beatIndex + 0.90,	"Reverse",	  modStrength,    0.2,	3 } 
end


for dti,dtv in ipairs(dualEngageTimes) do
	local dtb = dtv[1] - dtv[2]
	modsTable[#modsTable + 1] = {   dtb,	"Stealth",		  1.0,    dtv[2],	3}
	modsTable[#modsTable + 1] = {   dtb,	"Flip",			  0.5,    dtv[2],	3} 
	modsTable[#modsTable + 1] = {   dtb,	"Centered",		  1.0,    dtv[2],	3} 
	modsTable[#modsTable + 1] = {   dtb,	"Mini",			  0.5,    dtv[2],	3} 
end

for dti,dtv in ipairs(dualDisengageTimes) do
	modsTable[#modsTable + 1] = {   dtv[1],	"Stealth",		  0.0,    dtv[2],	3} 
	modsTable[#modsTable + 1] = {   dtv[1],	"Flip",			  0.0,    dtv[2],	3} 
	modsTable[#modsTable + 1] = {   dtv[1],	"Centered",		  0.0,    dtv[2],	3} 
	modsTable[#modsTable + 1] = {   dtv[1],	"Mini",			  0.0,    dtv[2],	3} 
end



modsTable = SortModsTable(modsTable)
_FG_[#_FG_ + 1] = LoadActor("./modsHQ.lua", {modsTable, 0})



return _FG_
