-------------------------------------------------------------------------------
--
--		DJ TECHNORCH vs. ARM(IOSYS) - "解熱鎮痛一撃必殺" (Fever and Pain Relief OHKO)
--		Bubble Tea Invitational 2.5
--		
--		Author: 	Telperion
--		Artist:		togotekiko
--		Date: 		2017-06-10
--		Target:		SM5.0.12+
--
-------------------------------------------------------------------------------
--
--		Ugh...
--		What an absolutely splitting, pounding headache.
--		Everything is spinning and...
--		...I think I'm hallucinating.
--
--		God, where's the Advil?
--		Somebody get me a Bloody Mary.
--
-------------------------------------------------------------------------------

local circumvention = false
if circumvention then
	return Def.ActorFrame {}
end

niceSpeed = (420) / 162			-- This song is 162 BPM.
distSpeed = 0.8 * niceSpeed
painSpeed = 0.7 * niceSpeed
low1Speed = 0.5 * niceSpeed
low2Speed = 0.25 * niceSpeed
local sw = SCREEN_WIDTH
local sh = SCREEN_HEIGHT
local BPS = GAMESTATE:GetSongBPS()
local ofs = 0.009
local overtime = 0
local visualOffset = -0.01
local fgmsg = 0
local checked = false
local plr = {nil, nil}

local PI = math.pi
local LOG2 = math.log(2.0)
local SQRT2 = math.sqrt(2.0)
local DEG_TO_RAD = math.pi / 180.0


local PlayerProxyActors 	= {nil, nil}
local PlayerProxyTextures 	= {nil, nil}
local PlayerProxySprites 	= {nil, nil}

local nGhostSubjects = 5
	-- Can't count arrays full of nil
	-- Even though I explicitly set five nils
	-- ...bitch. 
	--
	-- my nils are on flique

local ghostSubjects = {
	nil,				-- Player 1 active sprite
	nil,				-- Player 2 active sprite
	nil,				-- Crowdsource / Eleison high
	nil,				-- Eleison low
	nil,				-- Who knows?
}

local aftMemoryActor = nil
local aftOutputActor = nil
local aftOutSprActor = nil
local ghostDudeActor = nil
local ghostSubjActors = {}



--
--	Texture constants
--
local ttw = math.pow(2, math.ceil(math.log(sw) / LOG2))
local tth = math.pow(2, math.ceil(math.log(sh) / LOG2))
local twscale = sw / ttw
local thscale = sh / tth

--
-- 	some funktion !
--
function SideSign(i) return (i ~= 1) and 1 or -1 end

function RangeScale(t, inLower, inUpper, outLower, outUpper)
	local ti = (t - inLower) / (inUpper - inLower)
	return outLower + ti * (outUpper - outLower)
end

function RangeClamp(t, outLower, outUpper)
	local ti = t
	ti = (ti < outLower) and outLower or ti
	ti = (ti > outUpper) and outUpper or ti
	return ti
end

function Whomst(act)
	return tonumber(string.match(act:GetName(), "P([0-9]+)"))
end

function Whichst(act)
	return tonumber(string.match(act:GetName(), "_([0-9]+)"))
end


function GentleFunction(t, p)
	-- Quintic tweening function for smooth behavior
	-- p = control parameter determining slope in center
	-- p el [  0, 15/8] for monotonic movement
	-- p el [5/4,  3/2] for non-inflective movement
    local tt = 2*t - 1
    local z = (  p - 1.5) * tt^5
    		+ (2.5 - 2*p) * tt^3
    		+ 		   p  * tt
    return 0.5*z + 0.5
end

function CuteFunction(t)
	-- Smoothest way to get from point A to B on a quintic
	-- Specific case of GentleFunction with minimal inflection (p = 5/4)
    local tt = 2*t - 1
    local z = -0.25 * tt^5
    		+  1.25 * tt
    return 0.5*z + 0.5
end

function StrongFunction(t, p)
	-- Cubic tweening function for smooth behavior
	-- p = control parameter determining slope at ends
	-- p el [0, 3] for monotonic movement
    local tt = 2*t - 1
    local z = (p - 2) * tt^3 
    		+ (3 - p) * tt
    return 0.5*z + 0.5
end

function BiasFunction(t, p, q)
	-- Cubic tweening function for smooth behavior with off-center middle
	-- p = control parameter determining slope at middle
	-- q = control parameter determining y-intercept (and interest point)
    local tt = 2*t - 1
    local z = (((1 - p)  * tt
    		+   (0 - q)) * tt
    		+        p ) * tt
    		+        q
    return 0.5*z + 0.5
end


function SortModsTable(mt)
	-- Insertion sort into the butt
	-- because wow I'm mostly lazy
	-- and can assume it's mostly sorted

	mtNew = {}

	for _,mr in pairs(mt) do
		local insertLocation = 1
		for i = #mtNew,1,-1 do
--			Trace("### SortModsTable: "..mtNew[i][1].." vs. "..mr[1])
			if mtNew[i][1] <= mr[1] then
				insertLocation = i+1
				break
			end
		end
--		Trace("### SortModsTable: "..mr[1].." ("..mr[2]..") -> "..insertLocation)
		table.insert(mtNew, insertLocation, mr)
	end

	return mtNew
end



local _DZ_ = Def.ActorFrame {}
local _FG_ = Def.ActorFrame {
	InitCommand = function(self)
	end,
	OnCommand = function(self)
		self:fov(1)
			:vanishpoint(sw/2, sh/4)			
			:SetDrawByZPosition(true)

		plr[1] = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
		plr[2] = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
		SCREENMAN:GetTopScreen():SetDrawByZPosition(true)


		local hamburger = SCREENMAN:GetTopScreen()
		if hamburger:GetScreenType() == "ScreenType_Gameplay" then
			hamburger:GetChild("Overlay" ):decelerate(4.0 / BPS):diffusealpha(0.0)
			hamburger:GetChild("Underlay"):decelerate(4.0 / BPS):diffusealpha(0.0)
		end
				
		local playersFound = 0
		for pn = 1,2 do
			pv = plr[pn]
			if pv then
				pv:GetChild("Combo"):hibernate(1573)
			end
			
			pops = GAMESTATE:GetPlayerState("PlayerNumber_P"..pn):GetPlayerOptions("ModsLevel_Song")
			pops:FailSetting('FailType_Off')
		end

		self:sleep(1573)
	end
};





-------------------------------------------------------------------------------
--
--	The ancient discotheque
--

--
--		Instead of projecting the ghost to a rectangular Sprite, we're gonna
--		try slapping it on a distorted ActorMultiVertex instead.
--		Setting up the vertex coordinates for that takes a little bit of work.
--
--		This is a physical vertex shifter.
--		For the textural vertex shifter (gradient), used in Spectrum's ghosting,
--		go consult that file's FG change! 
--
local stretchyRows = 35					-- assuming 16:9
local stretchyCols = 63					-- assuming 16:9
local stretchyDX = sw/stretchyCols
local stretchyDY = sh/stretchyRows
local texturalDX = twscale/stretchyCols
local texturalDY = thscale/stretchyRows
local qq = math.sqrt(sw * sh) * 0.05	-- I don't think we'll use this but w/e

local nDiscoProxies 	= 4
local Discothextures 	= {}
local DiscoProxies 	 	= {{}, {}}

-- Enforce adjacent playfields.
local discoYNativeScale	= 1.0			-- The playfields are a little smaller than normal.
local discoYCurve		= 0.3			-- The AMV curves down at the edges.
local discoXNativeScale = 1.1			-- The playfield is stretched so the curve edge is not visible.
local discoCentralScale = 2 / (discoXNativeScale * PI)
	-- Internal playfield true scale at center.
local discoTinify 		= math.log( ((2 * nDiscoProxies - 1) * discoCentralScale * 256) / sw ) / LOG2
	-- One unit of Tiny/Mini shrinks by 50%, so the whole thing is multiplied by 2 for full-scale
local discoScreenCrop	= (2 * nDiscoProxies) / (2 * nDiscoProxies - 1)

local discoCrowd		= false
local discoStartTime	= 1573			-- in beats
local discoTweenTime	= 0				-- in beats
local discoProxyPeriod 	= 16			-- in beats
local discoScrAuxActor	= nil			-- controls scrolling of wall
local discoScrFunction	= Scroller_NullShift	-- controls scrolling of wall (domain and range [0, 1])

function CalculateRowBaseVertices(rowIndex)
	local verts = {}
	
	--
	-- 1--3--5--7-...
	-- |  |  |  |
	-- 2--4--6--8-...
	--
	for tateIndex = 0, stretchyCols do
		verts[#verts+1] = {
			{tateIndex * stretchyDX - sw/2, (rowIndex-1) * stretchyDY - sh/2, 0},
			{1, 1, 1, 1},
			{tateIndex * texturalDX, (rowIndex-1) * texturalDY}
		}
		verts[#verts+1] = {
			{tateIndex * stretchyDX - sw/2,  rowIndex    * stretchyDY - sh/2, 0},
			{1, 1, 1, 1},
			{tateIndex * texturalDX,  rowIndex    * texturalDY}
		}
	end
	
	return verts
end

-- For pixel AMV only!
local pixelRows = 25					-- assuming 16:9
local pixelCols = 45					-- assuming 16:9
local pixelDX = sw/pixelCols
local pixelDY = sh/pixelRows
local texelDX = twscale/pixelCols
local texelDY = thscale/pixelRows
function CalculateQuadsBaseVertices()
	local verts = {}
	
	--
	-- 1--4  5--8  ...
	-- |  |  |  |
	-- 2--3  6--7  ...
	--
	for yokoIndex = 1, pixelRows do
		for tateIndex = 1, pixelCols do
			verts[#verts+1] = {
				{(tateIndex-1) * pixelDX - sw/2, (yokoIndex-1) * pixelDY - sh/2, 0},
				{1, 1, 1, 1},
				{(tateIndex-1) * texelDX, 		 (yokoIndex-1) * texelDY}
			}
			verts[#verts+1] = {
				{(tateIndex-1) * pixelDX - sw/2,  yokoIndex    * pixelDY - sh/2, 0},
				{1, 1, 1, 1},
				{(tateIndex-1) * texelDX,  		  yokoIndex    * texelDY}
			}
			verts[#verts+1] = {
				{ tateIndex    * pixelDX - sw/2,  yokoIndex    * pixelDY - sh/2, 0},
				{1, 1, 1, 1},
				{ tateIndex    * texelDX,  		  yokoIndex    * texelDY}
			}
			verts[#verts+1] = {
				{ tateIndex    * pixelDX - sw/2, (yokoIndex-1) * pixelDY - sh/2, 0},
				{1, 1, 1, 1},
				{ tateIndex    * texelDX, 		 (yokoIndex-1) * texelDY}
			}
		end
	end
	
	return verts
end

function Stretcher_NullShift(x, y, z, a)
	return x, y, z
end
function Alphabeter_NullShift(x, y, z, a)
	return 1
end
function Scroller_NullShift(t)
	return 0
end
discoScrFunction = Scroller_NullShift

function CalculateStretchedTextures(verts, stretcher, soul, alphabeter)
	stretcher = stretcher or Stretcher_NullShift
	soul = soul or 0
	alphabeter = alphabeter or Alphabeter_NullShift
	
	-- Coordinate the texture all at once.
	for vertIndex = 1,#verts do
		local x = verts[vertIndex][1][1] / sw
		local y = verts[vertIndex][1][2] / sh
		local z = verts[vertIndex][1][3] / qq
		
		-- The stretching function operates on [-1, 1] × [-1, 1].
		-- The magnitude of the stretcher is expected to be scaled to that same space.
		-- The last parameter is used to parameterize the shape of the stretcher.
		xn, yn, zn = stretcher(2*x, 2*y, 2*z, soul)
		
		-- Apply the stretcher onto the vertices after scaling to texture space.
		-- Note that this is a replacement operation, so don't compound this function.
		verts[vertIndex][1][1] = xn * 0.5 * sw
		verts[vertIndex][1][2] = yn * 0.5 * sh
		verts[vertIndex][1][3] = zn * 0.5 * qq

		-- Huh! Whoa! This is edgy.
		verts[vertIndex][2][4] = alphabeter(2*x, 2*y, 2*z, soul)
	end

	return verts	
end

function CalculatePixelCenteredTextures(verts)	
	-- Coordinate the texture all at once.
	for quadIndex = 1,#verts / 4 do
		local vertIndex = (quadIndex-1) * 4
		local xn = 0
		local yn = 0

		-- Pull all quad texture from the center of the quad.
		for vt = 1,4 do
			xn = xn + 0.25 * verts[vertIndex + vt][1][1]
			yn = yn + 0.25 * verts[vertIndex + vt][1][2]
		end

		local xt = RangeClamp(xn/sw + 0.5, 0, sw-1) * twscale
		local yt = RangeClamp(yn/sh + 0.5, 0, sh-1) * thscale

--		Trace("### ### "..xt..","..yt)
				
		-- Apply the gradient onto the vertices after scaling to texture space.
		for vt = 1,4 do
--			verts[vertIndex + vt][3][1] = 2 * verts[vertIndex + vt][3][1] - xt
--			verts[vertIndex + vt][3][2] = 2 * verts[vertIndex + vt][3][2] - yt
			verts[vertIndex + vt][3][1] = xt
			verts[vertIndex + vt][3][2] = yt
		end
	end

	return verts	
end


function Scroller_Crowd(t)
	if t <= 0.5 then
		return CuteFunction(    2*t)
	else
		return CuteFunction(2 - 2*t)
	end
end

function Stretcher_Crowd(x, y, z, a)
	return x / discoCentralScale, y, z
end



function Scroller_Eleison(t)
	local tt = 4*PI*t*t*t
	local ss = math.sin(tt)
	return ss*ss
end

function Stretcher_DiscoWall(x, y, z, a)
	local xn = x * (1 + a - a*y*y)
	local yn = y * (1 +     a*x*x)
	local zn =      		a*x*x*y*y
	return xn, yn, zn
end


function Stretcher_Eleison(x, y, z, direction)
	local xPhase = PI/2 * x
	local xn = discoXNativeScale * math.sin(xPhase)
	local yn = discoYNativeScale * y + direction * discoYCurve * math.cos(xPhase)
	local zn = discoXNativeScale * math.sin(xPhase)
	return xn, yn, zn
end

function Alphabeter_Eleison(x, y, z, itdontmattermuch)
	return RangeClamp( RangeScale(y, -0.95, -1, 1, 0), 0, 1 )
	
end


DiscoWallsAMV = {nil, nil}
DiscoWallsProto = {nil, nil}
DiscoWallsPrefetch = {nil, nil}		-- Eleison
DiscoWallsReset = {nil}				-- Crowd
GhostWallsPrefetch = {nil, nil}

function substrateAMV(stratagem)
	local stretchyAMV = 
		Def.ActorFrame {
			Name = stratagem
		}

	for rowIndex = 1,stretchyRows do
		stretchyAMV[#stretchyAMV + 1] =	Def.ActorMultiVertex {
				Name = "StretchyAMVStrip_"..rowIndex,
				InitCommand = function(self)
					local verts = CalculateRowBaseVertices(rowIndex)
					self:aux(rowIndex)
					self:xy(0, 0)
						:SetVertices(verts)
						:SetDrawState{First = 1,
									  Num = (stretchyCols + 1) * 2,
									  Mode = "DrawMode_QuadStrip"}
				end,
			}
	end

	return stretchyAMV
end


DiscoWallsReset = {}
for rowIndex = 1,stretchyRows do
	local verts = CalculateRowBaseVertices(rowIndex)
	verts = CalculateStretchedTextures(verts, Stretcher_Crowd, 0, Alphabeter_NullShift)
	DiscoWallsReset[rowIndex] = verts
end

GhostWallsPrefetch = {{}, {}}
for rowIndex = 1,stretchyRows do
	local verts = CalculateRowBaseVertices(rowIndex)
	for vi = 1,#verts do
		verts[vi][2][1] = verts[vi][1][1] / sw * 0.04 + 0.96
		verts[vi][2][3] = verts[vi][1][2] / sh * 0.04 + 0.96
--		Trace("### verts[vi][1] = "..verts[vi][1][1]..", "..verts[vi][1][2]..";   verts[vi][2] = "..verts[vi][2][1]..", "..verts[vi][2][2]..", "..verts[vi][2][3])
	end
	verts = CalculateStretchedTextures(verts, Stretcher_DiscoWall, 0.02, Alphabeter_NullShift)

	GhostWallsPrefetch[1][rowIndex] = verts
end
for rowIndex = 1,stretchyRows do
	local verts = CalculateRowBaseVertices(rowIndex)
	GhostWallsPrefetch[2][rowIndex] = verts
end



for dwi = 1,2 do
	DiscoWallsProto[dwi] = substrateAMV("DiscoWallAMV_"..dwi)
	DiscoWallsProto[dwi]["InitCommand"] = function(self)
		self:xy(sw/2, sh/2)
			:visible(false)
			:diffusealpha(0.0)
		DiscoWallsAMV[dwi] = self
		ghostSubjects[2 + dwi] = self
	end
	_FG_[#_FG_ + 1] = DiscoWallsProto[dwi]


	DiscoWallsPrefetch[dwi] = {}
	for rowIndex = 1,stretchyRows do
		local verts = CalculateRowBaseVertices(rowIndex)
		verts = CalculateStretchedTextures(verts, Stretcher_Eleison, SideSign(dwi), Alphabeter_Eleison)
		DiscoWallsPrefetch[dwi][rowIndex] = verts
	end

	-- Textures of interest
	local DiscoProjection = Def.ActorFrameTexture {
		Name = "Discothexture_" .. dwi,
		InitCommand = function(self)
			Discothextures[dwi] = self

			self:SetTextureName( self:GetName() )
				:SetWidth( sw )
				:SetHeight( sh )
				:EnableAlphaBuffer( true )
				:Create()

			DiscoScreen = DiscoWallsAMV[dwi]

			for rowIndex=1,stretchyRows do
				DiscoScreen:GetChild("StretchyAMVStrip_"..rowIndex)
						   :SetTexture( self:GetTexture() )
			end
		end,

		-- Underlay the arrow fields
		Def.Quad {
			InitCommand = function(self)
				self:xy(sw/2, sh/2 + 8)
					:z(-1)
					:SetWidth(sw)
					:SetHeight(384)
					:diffuse(0, 0, 0, dwi - 1)
			end,
		},
	}

	for pn = 1,2 do
		for proxyIndex = 1,nDiscoProxies do
			DiscoProjection[#DiscoProjection + 1] = Def.ActorFrame {
				Name = "ProxyP"..pn.."Outer_"..proxyIndex,
				Def.ActorFrame {	
					Name = "ProxyP"..pn.."Inner_"..proxyIndex,
					Def.ActorProxy {					
						Name = "ProxyP"..pn,
						InitCommand = function(self)
							self:aux( Whomst(self) )
						end,
						BeginCommand=function(self)
							local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
							if McCoy then self:SetTarget(McCoy) else self:hibernate(1573) end
						end,
						OnCommand=function(self)
							local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
							if McCoy then 
								self:xy(-McCoy:GetX(), -McCoy:GetY())
								self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
							end
						end,
						RecenterProxyMessageCommand=function(self)					
							local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
							if McCoy then 
								self:xy(-McCoy:GetX(), -McCoy:GetY())
								self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
							end
						end
					},
					InitCommand = function(self)
		--				self:aux( Whichst(self) )
						DiscoProxies[dwi][(Whichst(self) - 1) * 2 + Whomst(self)] = self
					end,
					OnCommand = function(self)
						self:zoomx(discoCentralScale)
					end,
				},
				InitCommand = function(self)
		--			self:aux( Whichst(self) )
				end,
				OnCommand = function(self)
					self:xy(0, 0)
						:z(2)
				end,
			}
		end
	end


	_FG_[#_FG_ + 1] = DiscoProjection
end


_FG_[#_FG_ + 1] = Def.Actor {
	InitCommand = function(self)
		discoScrAuxActor = self
		self:aux(0)
	end,

	CrowdTimeMessageCommand = function(self, args)
--		Trace("CrowdTime @ discoScrAuxActor: "..overtime)
		local duration 	= (#args >= 1) and args[1] or 8

		self:linear(duration / BPS)
			:aux(1)
	end,

	CrowdResetMessageCommand = function(self, args)	
		self:linear(1.0 / BPS)
			:aux(0)
	end,

	DiscoTimeMessageCommand = function(self, args)
--		Trace("DiscoTime @ discoScrAuxActor: "..overtime)
		local duration 	= (#args >= 1) and args[1] or 8

		self:linear(duration / BPS)
			:aux(1)
	end,

	DiscoResetMessageCommand = function(self, args)	
		self:linear(1.0 / BPS)
			:aux(0)
	end,
}

--
--	The ancient discotheque
--
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
--
--	Distress chromatics
--

local distressAuxActors = {nil, nil}
local distressControllerAuxActor = nil

local distressXScale 	=  0.5	-- proportion of sw
local distressYDisplace = -0.2	-- proportion of sh
local distressRotZMax   =   30	-- degrees
local distressRotXMax	=  -30	-- degrees

for pn = 1,2 do
	_FG_[#_FG_ + 1] = Def.Actor {
		InitCommand = function(self)
			distressAuxActors[pn] = self
			self:aux(2 - pn)
		end,
	}
end

_FG_[#_FG_ + 1] = Def.Actor {
	InitCommand = function(self)
		distressControllerAuxActor = self
		self:aux(0)
	end,

	DistressStartMessageCommand = function(self, args)
		local tweenTime = args[1] and args[1] or 4

		aftOutSprActor:diffusealpha(0.999)
		ghostDudeActor:diffuse(1.0, 1.0, 1.0, 1.0)

		self:decelerate(tweenTime / BPS)
			:aux(1)
	end,
	DistressEndMessageCommand = function(self, args)
		local tweenTime = args[1] and args[1] or 4
		
		aftOutSprActor:diffusealpha(0.99)
		ghostDudeActor:accelerate(tweenTime / BPS)
					  :diffusealpha(0.2)

		self:accelerate(tweenTime / BPS)
			:aux(0)
	end,
}

--
--	Distress chromatics
--
-------------------------------------------------------------------------------



-------------------------------------------------------------------------------
--
--	Glitch out, man
--

local GlitchActors = {nil, nil, nil, nil, nil, nil, nil}
local GlitchBaseTexture = nil


--
-- Glitch base texture
--
_FG_[#_FG_ + 1] = Def.ActorFrameTexture {
	Name = "GlitchBaseTexture",
	InitCommand = function(self)
		GlitchBaseTexture = self

		self:SetTextureName( self:GetName() )
			:SetWidth( sw )
			:SetHeight( sh )
--			:EnableAlphaBuffer( true )
			:Create()
	end,
	OnCommand = function(self)
	end,

	Def.Sprite {
		Name = "GlitchProxyP1",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:z(0.1)
				:diffuse(1.0, 1.0, 1.0, 1.0)
		end,

		BeginCommand = function(self)
			if PlayerProxyTextures[1] then
				self:SetTexture( PlayerProxyTextures[1]:GetTexture() )
			end
		end,
	},
	Def.Sprite {
		Name = "GlitchProxyP2",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:z(0.1)
				:diffuse(1.0, 1.0, 1.0, 1.0)
		end,

		BeginCommand = function(self)
			if PlayerProxyTextures[2] then
				self:SetTexture( PlayerProxyTextures[2]:GetTexture() )
			end
		end,
	},
}


--
-- Glitch 1
--
_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		GlitchActors[1] = self

		self:visible(false)
			:z(10)
	end,
	OnCommand = function(self)
	end,

	Glitch1MessageCommand = function(self, args)
		local glitchState = args[1]

		self:visible(glitchState)
	end,

	Def.Sprite {
		Name = "Static1",
		Texture = "static-1.png",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:SetWidth(sw * 2.0)
				:SetHeight(sh)
				:z(0)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end,

		Glitch1MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("Glitch1Enter")
			end
		end,
		Glitch1EnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(0, sh/2)
				:queuecommand("Glitch1Frick")
		end,
		Glitch1FrickCommand = function(self)
			self:accelerate(2.0 / BPS)
				:x(sw * 0.25)
				:queuecommand("Glitch1Leave")
		end,
		Glitch1LeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},	
	Def.Sprite {
		Name = "Static2",
		Texture = "static-2.png",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:SetWidth(sw * 2.0)
				:SetHeight(sh)
				:z(0.1)
				:diffuse(1.0, 1.0, 1.0, 0.0)
				:blend("BlendMode_InvertDest")
		end,

		Glitch1MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("Glitch1Enter")
			end
		end,
		Glitch1EnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(sw, sh/2)
				:queuecommand("Glitch1Frick")
		end,
		Glitch1FrickCommand = function(self)
			self:accelerate(2.0 / BPS)
				:x(sw * 0.75)
				:queuecommand("Glitch1Leave")
		end,
		Glitch1LeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},
}


-- 
-- Glitch 2
--
local Glitch2Prefetch = {}
local Glitch2Prime = 239
local Glitch2Generator = 60
local Glitch2RowOffset = 1
for glitchRowDispl = 1,stretchyRows do
	Glitch2RowOffset = (Glitch2RowOffset * Glitch2Generator) % Glitch2Prime
	Glitch2Prefetch[glitchRowDispl] = Glitch2RowOffset * SideSign(glitchRowDispl % 2)
end

local Glitch2Proto = Def.ActorFrame {
	InitCommand = function(self)
		GlitchActors[2] = self

		self:visible(false)
			:z(10)
	end,
	OnCommand = function(self)
	end,

	Glitch2MessageCommand = function(self, args)
		local glitchState = args[1]

		self:visible(glitchState)
	end,

	Def.Quad {
		Name = "RowDecomposeQuad",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:SetWidth(sw)
				:SetHeight(sh)
				:z(-0.1)
				:diffuse(0.05, 0.05, 0.05, 0.0)
		end,

		Glitch2MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(0.0)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:smooth(0.5 / BPS)
				:diffusealpha(1.0)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:sleep(1.5 / BPS)
				:diffusealpha(0.0)
		end,
	},	
}

local Glitch2AMV = substrateAMV("Glitch2AMV")
Glitch2AMV["InitCommand"] = function(self)
	self:xy(sw/2, sh/2)
		:diffusealpha(0.0)
end
Glitch2AMV["OnCommand"] = function(self)
	for rowIndex = 1,stretchyRows do
		self:GetChild("StretchyAMVStrip_"..rowIndex)
				:SetTexture( GlitchBaseTexture:GetTexture() )
	end
end
Glitch2AMV["Glitch2MessageCommand"] = function(self, args)
	local glitchState = args[1]

	if glitchState then
		self:queuecommand("GlitchEnter")
	end
end
Glitch2AMV["GlitchEnterCommand"] = function(self)
	for rowIndex = 1,stretchyRows do
		self:GetChild("StretchyAMVStrip_"..rowIndex)
				:x(0)
	end
	self:diffusealpha(1.0)
		:queuecommand("GlitchFrick")
end
Glitch2AMV["GlitchFrickCommand"] = function(self)
	for rowIndex = 1,stretchyRows do
		self:GetChild("StretchyAMVStrip_"..rowIndex)
				:accelerate(2.0 / BPS)
				:addx(Glitch2Prefetch[rowIndex])		
	end
	self:queuecommand("GlitchLeave")
	
end
Glitch2AMV["GlitchLeaveCommand"] = function(self)
	self:sleep(2.0 / BPS)
		:diffusealpha(0.0)
end

Glitch2Proto[#Glitch2Proto + 1] = Glitch2AMV

_FG_[#_FG_ + 1] = Glitch2Proto


--
-- Glitch 3
--
_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		GlitchActors[3] = self

		self:visible(false)
			:z(10)
	end,
	OnCommand = function(self)
	end,

	Glitch3MessageCommand = function(self, args)
		local glitchState = args[1]

		self:visible(glitchState)
	end,

	Def.Sprite {
		Name = "TestCard1",
		Texture = "testcard-2.png",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:z(0)
				:diffuse(0.0, 1.0, 1.0, 0.0)
		end,

		Glitch3MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(sw/2, sh/2)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:accelerate(2.0 / BPS)
				:addx( 4)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},	
	Def.Sprite {
		Name = "TestCard2",
		Texture = "testcard-2.png",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:z(0.1)
				:diffuse(1.0, 0.0, 0.0, 0.0)
				:blend("BlendMode_Add")
		end,

		Glitch3MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(sw/2, sh/2)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:accelerate(2.0 / BPS)
				:addx(-4)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},
}

-- 
-- Glitch 4
--
local Glitch4PrefetchNull 	= CalculateQuadsBaseVertices()
local Glitch4PrefetchPixel 	= CalculatePixelCenteredTextures(Glitch4PrefetchNull)

_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		GlitchActors[4] = self

		self:visible(false)
			:z(10)
	end,
	OnCommand = function(self)
	end,

	Glitch4MessageCommand = function(self, args)
		local glitchState = args[1]

		self:visible(glitchState)
	end,


	Def.ActorMultiVertex {
		Name = "PixelAMV",
		InitCommand = function(self)
			self:xy(sw/2, sh/2)
				:SetVertices(Glitch4PrefetchNull)
				:SetDrawState{First = 1,
							  Num = (pixelCols) * (pixelRows) * 4,
							  Mode = "DrawMode_Quads"}
				:diffusealpha(0.0)
		end,

		OnCommand = function(self)
			self:SetTexture( GlitchBaseTexture:GetTexture() )
		end,
		Glitch4MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:SetVertices(Glitch4PrefetchNull)
				:diffusealpha(0.0)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:accelerate(1.0 / BPS)
				:SetVertices(Glitch4PrefetchPixel)
				:diffusealpha(1.0)
				:queuecommand("GlitchLeave")			
		end,
		GlitchLeaveCommand = function(self)
			self:sleep(1.0 / BPS)
				:diffusealpha(0.0)
		end,
	}
}



--
-- Glitch 5
--
_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		GlitchActors[5] = self

		self:visible(false)
			:z(10)
	end,
	OnCommand = function(self)
	end,

	Glitch5MessageCommand = function(self, args)
		local glitchState = args[1]

		self:visible(glitchState)
	end,

	Def.Quad {
		Name = "UhhwawaQuad",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:SetWidth(sw)
				:SetHeight(sh)
				:z(0)
				:diffuse(0.05, 0.05, 0.05, 0.0)
		end,

		Glitch5MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(0.0)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:smooth(0.5 / BPS)
				:diffusealpha(1.0)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:sleep(1.5 / BPS)
				:diffusealpha(0.0)
		end,
	},	
	Def.Sprite {
		Name = "UhhwawaDude",
		Texture = "uhhwawa.png",
		InitCommand = function(self)
			self:xy(sw * 0.5, sh * 0.8)
				:zoom(0.5)
				:z(0.1)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end,

		Glitch5MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(sw * 0.5, sh * 0.8)
				:zoom(0.5)
				:queuecommand("GlitchFrick1")
		end,
		GlitchFrick1Command = function(self)
			self:accelerate(0.5 / BPS)
				:addx(sw * 0.05)
				:addy(-sh * 0.2)
				:zoom(0.6)
				:queuecommand("GlitchFrick2")
		end,
		GlitchFrick2Command = function(self)
			self:accelerate(0.5 / BPS)
				:addx(-sw * 0.07)
				:addy(-sh * 0.2)
				:zoom(0.8)
				:queuecommand("GlitchFrick3")
		end,
		GlitchFrick3Command = function(self)
			self:accelerate(1.0 / BPS)
				:addx(sw * 0.02)
				:addy(-sh * 0.4)
				:zoom(1.0)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},
}


--
-- Glitch 6
--
_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		GlitchActors[6] = self

		self:visible(false)
			:z(10)
	end,
	OnCommand = function(self)
	end,

	Glitch6MessageCommand = function(self, args)
		local glitchState = args[1]

		self:visible(glitchState)
	end,

	Def.Quad {
		Name = "GrhaaaaaQuad",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:SetWidth(sw)
				:SetHeight(sh)
				:z(0)
				:diffuse(0.05, 0.05, 0.05, 0.0)
		end,

		Glitch6MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(0.0)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:smooth(0.5 / BPS)
				:diffusealpha(1.0)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:sleep(1.5 / BPS)
				:diffusealpha(0.0)
		end,
	},	
	Def.Sprite {
		Name = "GrhaaaaaDude",
		Texture = "grhaaaaa.png",
		InitCommand = function(self)
			self:xy(sw * 0.5, sh * 0.5)
				:zoom(0.5)
				:z(0.1)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end,

		Glitch6MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(sw * 0.5, sh * 0.4)
				:rotationz(-60)
				:zoom(0.5)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:decelerate(2.0 / BPS)
				:addy(0.2 * sh)
				:rotationz(15)
				:zoom(1.0)
				:diffusealpha(0.9)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},
}


--
-- Glitch 7
--
local Glitch7Texture = nil
_FG_[#_FG_ + 1] = Def.ActorFrameTexture {
	Name = "KorosunokaTexture",
	InitCommand = function(self)
		Glitch7Texture = self

		self:SetTextureName( self:GetName() )
			:SetWidth( sw )
			:SetHeight( sh )
			:EnableAlphaBuffer( true )
			:Create()
	end,
	OnCommand = function(self)
	end,


	Def.Sprite {
		Name = "KorosunoHand",
		Texture = "korosunokahand.png",
		InitCommand = function(self)
			self:xy(sw * 0.15, sh * 0.85)
				:z(0.1)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end,

		Glitch7MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(sw * 0.13, sh * 0.85)
				:queuecommand("GlitchFrick1")
		end,
		GlitchFrick1Command = function(self)
			self:decelerate(1.5 / BPS)
				:addx(sw * 0.2)
				:queuecommand("GlitchFrick2")
		end,
		GlitchFrick2Command = function(self)
			self:accelerate(0.5 / BPS)
				:addx(sw * 0.2)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},

	Def.Sprite {
		Name = "KorosunoDude",
		Texture = "korosunoka.png",
		InitCommand = function(self)
			self:xy(sw * 0.25, sh * 0.5)
				:z(0.2)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end,

		Glitch7MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(1.0)
				:xy(sw * 0.25, sh * 0.5)
				:queuecommand("GlitchFrick1")
		end,
		GlitchFrick1Command = function(self)
			self:decelerate(1.5 / BPS)
				:addx(sw * 0.1)
				:queuecommand("GlitchFrick2")
		end,
		GlitchFrick2Command = function(self)
			self:accelerate(0.5 / BPS)
				:addx(sw * 0.1)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:diffusealpha(0.0)
		end,
	},
}

_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		GlitchActors[7] = self

		self:visible(false)
			:z(10)
	end,
	OnCommand = function(self)
	end,


	Glitch7MessageCommand = function(self, args)
		local glitchState = args[1]

		self:visible(glitchState)
	end,

	Def.Quad {
		Name = "Korosunoquad",
		InitCommand = function(self)
			self:xy(sw / 2, sh / 2)
				:SetWidth(sw)
				:SetHeight(sh)
				:z(0)
				:diffuse(0.05, 0.05, 0.05, 0.0)
		end,

		Glitch7MessageCommand = function(self, args)
			local glitchState = args[1]

			if glitchState then
				self:queuecommand("GlitchEnter")
			end
		end,
		GlitchEnterCommand = function(self)
			self:diffusealpha(0.0)
				:queuecommand("GlitchFrick")
		end,
		GlitchFrickCommand = function(self)
			self:smooth(0.5 / BPS)
				:diffusealpha(1.0)
				:queuecommand("GlitchLeave")
		end,
		GlitchLeaveCommand = function(self)
			self:sleep(1.5 / BPS)
				:diffusealpha(0.0)
		end,
	},	

	Def.Sprite {
		Name = "BGkorosunoka",
		InitCommand = function(self)
			self:xy(sw * 1.0, sh * 0.3)
				:zoom(1.6)
				:z(0.1)
				:diffusealpha(0.15)
		end,
		OnCommand = function(self)
			self:SetTexture( Glitch7Texture:GetTexture() )
		end,
	},

	Def.Sprite {
		Name = "FGkorosunoka",
		InitCommand = function(self)
			self:xy(sw * 0.5, sh * 0.5)
				:zoom(1.0)
				:z(0.2)
		end,
		OnCommand = function(self)
			self:SetTexture( Glitch7Texture:GetTexture() )
		end,
	},
}

--
--	Glitch out, man
--
-------------------------------------------------------------------------------



-------------------------------------------------------------------------------
--
--
--	Don't Mess With My Emotions !!
--
--

local baserotationzByLane = {
	90,		-- Left
	0,		-- Down
	180,	-- Up
	270		-- Right
}
local texArrows = {}		-- Texture coordinate shifts
texArrows[4] 	= 0.000		-- 4th
texArrows[8] 	= 0.125		-- 8th
texArrows[16] 	= 0.375		-- 16th
texArrows[12] 	= 0.250		-- 12th
texArrows[24] 	= 0.500		-- 24th
texArrows[32] 	= 0.625		-- 32nd
texArrows[48] 	= 0.750		-- 48th
texArrows[64] 	= 0.875		-- 64th

local dualPoolSize		= 60		-- Analytically derived.
local dualPhaseBegin	= 0
local dualPhaseEnd		= 200
local dualPhasingPeriod	= 4
local dualNextNote		= 1

local dualPool = {}
local dualPoolActive = {}

-- loadfile("chartData.lua")
dualSource = {
	-- Generated using Chart2Lua.py
	-- Only one copy is needed because the arrows are charted such that
	-- P1 reads them one direction and P2 reads them the other.


	-- [1]: beat number, zero at start
	-- [2]: lane number, one-indexed
	-- [3]: note type: Tap, Hold, Roll, End, or Mine
	-- [4]: quantization reciprocal

	{ 452.000, 3, "T",  12},
	{ 452.333, 3, "T",  12},
	{ 452.667, 3, "T",  12},
	{ 453.000, 3, "T",  12},
	{ 453.333, 3, "T",  12},
	{ 453.667, 3, "T",  12},
	{ 454.000, 3, "T",  12},
	{ 454.000, 3, "T",  12},
	{ 454.333, 3, "T",  12},
	{ 454.333, 3, "T",  12},
	{ 454.667, 3, "T",  12},
	{ 454.667, 3, "T",  12},
	{ 455.000, 3, "T",  12},
	{ 455.000, 3, "T",  12},
	{ 455.333, 3, "T",  12},
	{ 455.333, 3, "T",  12},
	{ 455.667, 3, "T",  12},
	{ 455.667, 3, "T",  12},
	{ 456.000, 3, "T",  12},
	{ 456.000, 3, "T",  12},
	{ 456.000, 3, "T",  12},
	{ 456.333, 3, "T",  12},
	{ 456.333, 3, "T",  12},
	{ 456.333, 3, "T",  12},
	{ 456.667, 3, "T",  12},
	{ 456.667, 3, "T",  12},
	{ 456.667, 3, "T",  12},
	{ 457.000, 3, "T",  12},
	{ 457.000, 3, "T",  12},
	{ 457.000, 3, "T",  12},
	{ 457.333, 3, "T",  12},
	{ 457.333, 3, "T",  12},
	{ 457.333, 3, "T",  12},
	{ 457.667, 3, "T",  12},
	{ 457.667, 3, "T",  12},
	{ 457.667, 3, "T",  12},
	{ 458.000, 3, "T",  12},
	{ 458.000, 3, "T",  12},
	{ 458.000, 3, "T",  12},
	{ 458.333, 3, "T",  12},
	{ 458.333, 3, "T",  12},
	{ 458.333, 3, "T",  12},
	{ 458.667, 3, "T",  12},
	{ 458.667, 3, "T",  12},
	{ 458.667, 3, "T",  12},
	{ 459.000, 3, "T",  12},
	{ 459.000, 3, "T",  12},
	{ 459.000, 3, "T",  12},
	{ 459.333, 3, "T",  12},
	{ 459.333, 3, "T",  12},
	{ 459.333, 3, "T",  12},
	{ 459.333, 3, "T",  12},
	{ 459.667, 3, "T",  12},
	{ 459.667, 3, "T",  12},
	{ 459.667, 3, "T",  12},
	{ 459.667, 3, "T",  12},
	{ 460.000, 3, "T",  12},
	{ 460.000, 3, "T",  12},
	{ 460.000, 3, "T",  12},
	{ 460.000, 3, "T",  12},
}

local dualActive = {}


local DualStateNull = function(notary, t) end

local DualAlignArrow = function(notary, t)
	dualPool[notary[6]]:xy(sw * (0.5 + 4 * (math.random() - 0.5) * (math.random() - 0.5)),
						   sh * (0.5 + 4 * (math.random() - 0.5) * (math.random() - 0.5)))
end

local DualShowArrow = function(notary, t)
	dualPool[notary[6]]:diffusealpha(t)
					   :zoom(1.0 + 0.5 * (1.0 - t)*(1.0 - t))
end
local DualKeepArrow = function(notary, t)
	-- Do nothing.
	dualPool[notary[6]]:zoom(1.5 + 0.5 * t)
end
local DualHideArrow = function(notary, t)
	dualPool[notary[6]]:diffusealpha(1 - t)
					   :zoom(2.0 - 2.0 * t * t)
end


local dualStateRules = {
	-- Functions that determine how long the arrow state is and what it should be doing.
	-- [1]: state length
	-- [2]: state function, operating on [0, 1) time basis

	{0,   DualAlignArrow},		-- setup
	{0.1, DualShowArrow},		-- appearing
	{4,   DualKeepArrow},		-- active/approaching
	{4,   DualHideArrow},		-- disappearing
	{0,   DualStateNull}		-- takedown	
}

local dualAdvanceNotice = 
	dualStateRules[1][1] + 
	dualStateRules[2][1]


-- YOU MAY NOT ACTIVATE NOTES OUT OF ORDER.
-- WHY BOTHER, YOU ASS
--
-- DO NOT BOTHER MY ASS
-- GO BOTHER YOUR OWN ASS

function DualActivateWhen(t)
	-- What time should I actually activate this note?
	if t >= dualPhaseBegin and t <= dualPhaseEnd then
		return dualPhaseBegin + math.floor((t - dualPhaseBegin) / dualPhasingPeriod) * dualPhasingPeriod - dualAdvanceNotice
	else
		return t - dualAdvanceNotice
	end
end

function DualArrowActivate(note)
	local poolIndexChosen = 0
	for poolIndex = 1,#dualPool do
		if dualPoolActive[poolIndex] == 0 then
			dualPoolActive[poolIndex] = #dualActive + 1
			poolIndexChosen = poolIndex
			break
		end
	end

	if poolIndexChosen == 0 then
		Trace("### No pool arrows available to activate!!")
		return
	end

	dualActive[#dualActive+1] = {
		-- copied over from source list:
		-- [1]: beat number, zero at start
		-- [2]: lane number, one-indexed
		-- [3]: note type (Tap, Hold, End, Roll, or Mine)
		-- [4]: quantization reciprocal
		-- [5]: extra data, e.g. in this file the value determines
		--		[1]:	whether the note is part of an emotion row (true)
		--				or acts on its own (false)
		--		[2]:	the beat offset of the note in its row
		-- 
		-- added parameters on activation:
		-- [6]:	pool actor index
		-- [7]: arrow state
		--		1:	setup
		--		2:	appearing
		--		3:	active/moving
		--		4:	disappearing
		--		5:	takedown
		-- [8]:	state start beat
		note[1],
		note[2],
		note[3],
		note[4],
		{true, 0},		-- note[5],

		poolIndexChosen,
		1,
		overtime,
	}
end


function DualArrowAct(notary)
	local currentState = notary[7]

	if currentState > 5 then
		Trace("### Active arrow "..notary[1]..":"..notary[2].." reached impossible state!!")
		return true
	end


	local stateRule = dualStateRules[currentState]
	local t = (stateRule[1] == 0) and 1 or (overtime - notary[8]) / stateRule[1]
	local iWantToDie = false


	-- Take state action
	if currentState == 1 then
		stateRule[2](notary, t)
		if t >= 1 then
			dualPool[ notary[6] ]:visible(true)
								 :texturetranslate( texArrows[notary[4]], 0 )
								 :baserotationz( baserotationzByLane[notary[2]] )
		end

	elseif currentState == 2 then
		stateRule[2](notary, t)

	elseif currentState == 3 then
		stateRule[2](notary, t)

	elseif currentState == 4 then
		stateRule[2](notary, t)

	elseif currentState == 5 then
		stateRule[2](notary, t)
		if t >= 1 then
			dualPool[ notary[6] ]:visible(false)
			dualPoolActive[ notary[6] ] = 0
			iWantToDie = true
		end

	else
		Trace("### Active arrow "..notary[1]..":"..notary[2].." reached impossible state!!")
		iWantToDie = true
	end


	if t >= 1 then
		-- Advance state
		notary[8] = notary[8] + stateRule[1]
		notary[7] = notary[7] + 1
	end

	return notary, iWantToDie
end


function DualUpdate()
	local dualActiveReplace = {}

--	Trace("### >>> #dualActive = "..#dualActive)
	-- Update all the notes that are currently active.
	for i,notary in ipairs(dualActive) do
--		Trace("### >>> Act on "..i.."...")
		local notaryNew, killOffNote = DualArrowAct(notary)
		if not killOffNote then
			dualActiveReplace[#dualActiveReplace + 1] = notaryNew
		end
	end

	dualActive = dualActiveReplace

	-- Decide whether to activate any new notes.
	while dualNextNote <= #dualSource do
--		Trace("### Checking note "..dualNextNote.."...")
		-- TODO: handling for activation at another time
		if DualActivateWhen(dualSource[dualNextNote][1]) <= overtime then
--		if dualSource[dualNextNote][1] + dualAdvanceNotice <= overtime then
--			Trace("### !!! Activate "..dualNextNote.."!")
			DualArrowActivate( dualSource[dualNextNote] )
			dualNextNote = dualNextNote + 1
		else
			break
		end
	end
end


for poop = 1,dualPoolSize do
	_FG_[#_FG_ + 1] = NOTESKIN:LoadActorForNoteSkin("Down", "Tap Note", "cyber") .. {
		Name = "DualPool_"..poop,
		InitCommand = function(self)
			dualPool[poop] = self
			self:visible(false)
				:aux(poop)
				:z(3)
		end,
	}
	dualPoolActive[#dualPoolActive + 1] = 0
end


--
--
--	Don't Mess With My Emotions !!
--
--
-------------------------------------------------------------------------------




-------------------------------------------------------------------------------
--
-- 		Proxies (as usual)
--

--
--	Player proxies (one apiece)
--
for pn = 1,2 do
	i = 1
	_FG_[#_FG_ + 1] = Def.ActorFrameTexture {	
		Name = "ProxyP"..pn.."Tex",
		Def.ActorFrame {	
			Name = "ProxyP"..pn.."Inner",
			Def.ActorProxy {					
				Name = "ProxyP"..pn,
				InitCommand = function(self)
					self:aux( Whomst(self) )
				end,
				BeginCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then self:SetTarget(McCoy) else self:hibernate(1573) end
				end,
				OnCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end,
				RecenterProxyMessageCommand=function(self)					
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end,
			},
			InitCommand = function(self)
--				self:aux( Whichst(self) )
				self:fov(75)
				PlayerProxyActors[pn] = self
			end,
			OnCommand = function(self)
			end,

			BeginMidscreenMessageCommand = function(self, args)				
				self:finishtweening()
					:smooth(args[1] / BPS)
					:xy(sw * 0.5, -- + sw * 0.2 * SideSign(Whomst(self)),
						sh * 0.5) -- + sh * 0.1 * SideSign(Whomst(self)))
			end,
			ResetMidscreenMessageCommand = function(self, args)				
				self:finishtweening()
					:smooth(args[1] / BPS)
					:xy(sw * 0.5 + sw * 0.25 * SideSign(Whomst(self)),
						sh * 0.5)
			end,
			RotateWholeFieldMessageCommand = function(self, args)
				if args[2] == Whomst(self) or args[2] == 3 then	
					self:finishtweening()
						:smooth(args[1] / BPS)
						:rotationz(args[3])
				end
			end,
			SidewisePlayerProxiesMessageCommand = function(self, args)				
				local tweenType = args[2] and args[2] or "accelerate"
				self:finishtweening()
				self[tweenType](self, args[1] / BPS)
				self:x(sw * 0.5 + sw * 0.25 * SideSign(Whomst(self)))
					:diffusealpha(1.0)
			end,
			CenterPlayerProxiesMessageCommand = function(self, args)				
				local tweenType = args[2] and args[2] or "accelerate"
				self:finishtweening()
				self[tweenType](self, args[1] / BPS)
				self:x(sw * 0.5)
					:diffusealpha(1.0)
			end,
		},
		InitCommand = function(self)
--			self:aux( Whichst(self) )
			PlayerProxyTextures[pn] = self
			self:SetTextureName( self:GetName() )
				:SetWidth( sw )
				:SetHeight( sh )
				:EnableAlphaBuffer( true )
				:Create()
		end,
		OnCommand = function(self)
			self:xy(0, 0)
				:z(1)
		end,
	}

	_FG_[#_FG_ + 1] = Def.Sprite {
		Name = "ProxyP"..pn.."Outer",
		InitCommand = function(self)
			PlayerProxySprites[pn] = self
			ghostSubjects[pn] = self

			self:xy(sw / 2, sh / 2)
				:z(0.1)
				:diffuse(1.0, 1.0, 1.0, 1.0)
		end,

		BeginCommand = function(self)
			if PlayerProxyTextures[pn] then
				self:SetTexture( PlayerProxyTextures[pn]:GetTexture() )
			end
		end,


		CrowdEngageMessageCommand = function(self, args)
			local tweenTime = args[1] and args[1] or 0
			self:decelerate(tweenTime / BPS)
				:diffusealpha(0.0)
		end,
		CrowdTimeMessageCommand = function(self, args)
			self:visible(false)
		end,
		CrowdDisengageMessageCommand = function(self, args)
			local tweenTime = args[1] and args[1] or 0
			self:visible(true)
				:accelerate(tweenTime / BPS)
				:diffusealpha(1.0)
		end,
		DiscoEngageMessageCommand = function(self, args)
			local tweenTime = args[1] and args[1] or 0
			self:decelerate(tweenTime / BPS)
				:diffusealpha(0.0)
		end,
		DiscoTimeMessageCommand = function(self, args)
			self:visible(false)
		end,
		DiscoDisengageMessageCommand = function(self, args)
			local tweenTime = args[1] and args[1] or 0
			self:visible(true)
				:accelerate(tweenTime / BPS)
				:diffusealpha(1.0)
		end,

		BouncePlayerProxiesMessageCommand = function(self, args)
			local bouncePeriod  = args[1] and args[1] or 1.0
			local bounceDispl	= args[2] and args[2] or 64 * bouncePeriod

			if bouncePeriod == 0 then
				self:stopeffect()
			else
				self:bounce()
					:effectclock('beat')
					:effectperiod(bouncePeriod)
					:effectmagnitude(0, -bounceDispl, 0)
			end

		end,

		VibratePlayerProxiesMessageCommand = function(self, args)
			local vibrateMagn 	= args[1] and args[1] or 0

			if vibrateMagn == 0 then
				self:stopeffect()
			else
				self:vibrate()
					:effectmagnitude(vibrateMagn, vibrateMagn, 0)
			end

		end,
	}
end


--
--	Judgment proxies
--
for pn = 1,2 do
	_FG_[#_FG_ + 1] = Def.ActorProxy {
		Name = "JudgeP"..pn.."Proxy",
		InitCommand = function(self)
			self:aux( Whomst(self) )
		end,
		BeginCommand = function(self)
			local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
			if McCoy then 
				local McJudge = McCoy:GetChild('Judgment')
				self:SetTarget(McJudge)
				McJudge:visible(false)
			else 
				self:hibernate(1573)
			end
		end,
		OnCommand = function(self)			
			self:xy(sw * (0.5 + 0.25 * SideSign(Whomst(self))), sh/2)
		end,
	}
end

--
-- 		Proxies (as usual)
--
-------------------------------------------------------------------------------




-------------------------------------------------------------------------------
--
--		Some ghosting!
--

local aftMemory = 
	Def.ActorFrameTexture{
		Name = "GhostMemory",
		InitCommand=function(self)
			aftMemoryActor = self
			self:SetTextureName( self:GetName() )
				:SetWidth( sw )
				:SetHeight( sh )
				:EnableAlphaBuffer( true )
				:Create()
		end,
	}

local aftMemorySubstrateProto = substrateAMV("GhostMemorySubstrate")
aftMemorySubstrateProto["InitCommand"] = function(self)
	aftMemorySubstrate = self
	self:xy(sw/2, sh/2)
		:diffusealpha(1.0)
end
aftMemory[#aftMemory + 1] = aftMemorySubstrateProto



local aftOutput = 
	Def.ActorFrameTexture{
		Name = "GhostOutput",
		InitCommand=function(self)
			aftOutputActor = self
			self:SetTextureName( self:GetName() )
				:SetWidth( sw )
				:SetHeight( sh )
				:EnableAlphaBuffer( true )
				:Create()
				
			for rowIndex=1,stretchyRows do
				Trace("### Setting ghost AMV textures...")
				aftMemorySubstrate
					:GetChild("StretchyAMVStrip_"..rowIndex)
					:SetTexture( self:GetTexture() )
			end
		end,

		Def.Sprite{	
			Name = "GhostSprite",
			InitCommand=function(self)
				aftOutSprActor = self
				self:Center()
					:diffusealpha(0.99)
			end,
			BeginCommand=function(self)
				if aftMemoryActor then
					self:SetTexture(aftMemoryActor:GetTexture())
					Trace("### Set ghost sprite to memory texture!!")
				else
					Trace("### No ghost memory texture!!")
				end
			end,
			StopTrailMessageCommand=function(self)
				self:diffusealpha(0.0)
			end,
			StartTrailMessageCommand=function(self)
				self:diffusealpha(0.99)
					:blend("BlendMode_Add")
			end,
			HighTrailMessageCommand=function(self)
				self:diffusealpha(1.0)
					:blend("BlendMode_Normal")
			end,
		},

		GhostProxiesPulseMessageCommand=function(self, args)
			for _,gsi in ipairs(args) do
				ghostSubjActors[gsi]:visible(true)
			end
			self:GetParent():Draw()
			for _,gsi in ipairs(args) do
				ghostSubjActors[gsi]:visible(false)
			end
		end,
	}


-- TODO: who gets the proxies?
for ghostSubjIndex = 1,nGhostSubjects do
	aftOutput[#aftOutput + 1] = 
		Def.ActorProxy {
			Name = "GhostSubject_"..ghostSubjIndex,
			InitCommand = function(self)
				ghostSubjActors[ghostSubjIndex] = self
				self:aux( Whichst(self) )
			end,
			BeginCommand = function(self)
				Trace("### Looking for ghost subject #"..ghostSubjIndex.."!")
				local McCoy = ghostSubjects[ghostSubjIndex]
				if McCoy then 
					self:SetTarget(McCoy)
					Trace("### Got ghost subject #"..ghostSubjIndex.."!")
				else 
					self:hibernate(1573)
				end
			end,
			OnCommand = function(self)
			end,

			GhostProxiesOffMessageCommand=function(self, args)
				if args[1] == Whichst(self) then
					self:visible(false)
				end
			end,
			GhostProxiesOnMessageCommand=function(self, args)
				if args[1] == Whichst(self) then
					self:visible(true)
				end
			end,
		}
end
	
local ghostDude = 
	Def.Sprite{
		Name = "GhostDude",
		InitCommand=function(self)
			ghostDudeActor = self
			self:Center()
		end,
		BeginCommand=function(self)
			if aftOutputActor then
				self:SetTexture(aftOutputActor:GetTexture())
			else
				Trace("### No ghost output texture!!")
			end
		end,
		OnCommand=function(self)
			self:z(0.5)
				:blend("BlendMode_Add")
				:diffuse({1,1,1,0.3})
				:visible(true)
		end,
		GhostDiffuseMessageCommand=function(self, args)
			if args[1] then
				self:finishtweening()
					:decelerate(args[1] / BPS)
			else
				self:finishtweening()
			end

			if args[2] then
				if #args[2] == 3 then
					local alpha = self:GetDiffuseAlpha()
					self:diffuse(args[2][1], args[2][2], args[2][3], alpha)
				elseif #args[2] == 4 then
					self:diffuse(args[2][1], args[2][2], args[2][3], args[2][4])
				elseif type(args[2]) == "number" then
					self:diffusealpha(args[2])
				else
					self:diffusealpha(args[2][1])
				end
			else
			end
		end,
	}
	
_FG_[#_FG_ + 1] = aftMemory
_FG_[#_FG_ + 1] = aftOutput
_FG_[#_FG_ + 1] = ghostDude

--
--		Some ghosting!
--
-------------------------------------------------------------------------------



-------------------------------------------------------------------------------
--
-- 		This is where the shit will be happening.
--

local messageList = {
	{  4.000, "RecenterProxy"},

	{ 80.000, "CrowdEngage", 			{4}},
	{ 84.000, "CrowdTime", 				{64}},

	{146.000, "CrowdDisengage", 		{2}},
	{148.000, "CrowdReset", 			{}},

	{146.000, "SidewisePlayerProxies",	{2}},
	{146.000, "RotateWholeField",		{0, 1, 360}},
	{146.000, "RotateWholeField",		{0, 2, 360}},
	-- Begin discarded midscreen
--	{147.450, "ResetMidscreen",			{0}},
--	{147.500, "BeginMidscreen",			{0.5}},
--	{150.000, "RotateWholeField",		{4, 1, 0}},
--	{150.000, "RotateWholeField",		{4, 2, 0}},
--	{164.000, "RotateWholeField",		{12, 1, 360}},
--	{164.000, "RotateWholeField",		{12, 2, 360}},
--	{176.000, "ResetMidscreen",			{4}},
--	{180.000, "DisengagePosSplines"},
	--  End  discarded midscreen

	{180.000, "BouncePlayerProxies",	{1.0}},
	{184.000, "BouncePlayerProxies",	{0.5}},
	{185.000, "BouncePlayerProxies",	{1.0}},
	{187.000, "BouncePlayerProxies",	{0.5}},
	{188.000, "BouncePlayerProxies",	{1.0}},
	{193.000, "BouncePlayerProxies",	{0.5}},
	{196.000, "BouncePlayerProxies",	{1.0}},
	{201.000, "BouncePlayerProxies",	{0.5}},
	{204.000, "BouncePlayerProxies",	{1.0}},
	{208.000, "BouncePlayerProxies",	{0.5}},
	{212.000, "BouncePlayerProxies",	{0.0}},

	{208.000, "CenterPlayerProxies",	{4}},

	{248.000, "GhostProxiesOff",		{1}},
	{248.000, "GhostProxiesOff",		{2}},
	{248.000, "RotateWholeField",		{3, 1, 0}},
	{248.000, "RotateWholeField",		{3, 2, 0}},


	{251.000, "DistressBounce",			{0,    2}},
	{251.000, "DistressStart",			{1}},

	{256.000, "DistressIssue",			{2.50, 1}},
	{258.750, "DistressBounce",			{1.25, 1}},
	{264.000, "DistressIssue",			{2.50, 2}},
	{266.750, "DistressBounce",			{1.25, 2}},
	{272.000, "DistressIssue",			{2.50, 1}},
	{274.750, "DistressBounce",			{1.25, 1}},
	{280.000, "DistressIssue",			{3.00, 2}},
	{283.000, "DistressBounce",			{1.00, 2}},

	{288.000, "DistressIssue",			{2.25, 1}},
	{290.750, "DistressBounce",			{1.25, 1}},
	{296.000, "DistressIssue",			{2.25, 2}},
	{298.750, "DistressBounce",			{1.25, 2}},
	{304.000, "DistressIssue",			{2.25, 1}},
	{306.750, "DistressBounce",			{1.25, 1}},
	{312.000, "DistressIssue",			{2.25, 2}},
	{314.750, "DistressBounce",			{1.25, 2}},

	{315.000, "DistressEnd",			{1}},
	{316.000, "CenterPlayerProxies",	{4}},
	{316.000, "GhostProxiesOn",			{1}},
	{316.000, "GhostProxiesOn",			{2}},



	{331.800, "DiscoEngage", 			{0}},
--	{331.900, "RotateWholeField",		{0, 1, 0}},
--	{331.900, "RotateWholeField",		{0, 2, 0}},
	{332.000, "DiscoTime", 				{64}},

	{388.000, "DiscoDisengage", 		{8}},
	{396.000, "DiscoReset", 			{}},


	{398.000, "Glitch1", 				{true}},
	{400.000, "Glitch1", 				{false}},
	{402.000, "Glitch2", 				{true}},
	{404.000, "Glitch2", 				{false}},
	{406.000, "Glitch3", 				{true}},
	{408.000, "Glitch3", 				{false}},
	{410.000, "Glitch4", 				{true}},
	{412.000, "Glitch4", 				{false}},
	{414.000, "Glitch5", 				{true}},
	{416.000, "Glitch5", 				{false}},
	{418.000, "Glitch6", 				{true}},
	{420.000, "Glitch6", 				{false}},
	{422.000, "Glitch7", 				{true}},
	{424.000, "Glitch7", 				{false}},


	{452.000, "RotateWholeField",		{8, 1, 0}},
	{452.000, "RotateWholeField",		{8, 2, 0}},
	{452.000, "VibratePlayerProxies",	{5}},
	{454.000, "VibratePlayerProxies",	{10}},
	{456.000, "VibratePlayerProxies",	{15}},
	{458.000, "VibratePlayerProxies",	{20}},
	{460.000, "VibratePlayerProxies",	{0}},


	{464.000, "CrowdEngage", 			{4}},
	{468.000, "CrowdTime", 				{64}},

	{530.000, "CrowdDisengage", 		{2}},
	{532.000, "CrowdReset", 			{}},


	{530.000, "SidewisePlayerProxies",	{2}},
	-- Begin discarded midscreen
--	{531.450, "ResetMidscreen",			{0}},
--	{531.500, "BeginMidscreen",			{0.5}},
--	{534.000, "RotateWholeField",		{4, 1, 0}},
--	{534.000, "RotateWholeField",		{4, 2, 0}},
--	{548.000, "RotateWholeField",		{12, 1, -360}},
--	{548.000, "RotateWholeField",		{12, 2, -360}},
--	{560.000, "ResetMidscreen",			{4}},
--	{564.000, "DisengagePosSplines"},
	--  End  discarded midscreen


	{564.000, "BouncePlayerProxies",	{1.0}},
	{568.000, "BouncePlayerProxies",	{0.5}},
	{569.000, "BouncePlayerProxies",	{1.0}},
	{571.000, "BouncePlayerProxies",	{0.5}},
	{572.000, "BouncePlayerProxies",	{1.0}},
	{577.000, "BouncePlayerProxies",	{0.5}},
	{580.000, "BouncePlayerProxies",	{1.0}},
	{585.000, "BouncePlayerProxies",	{0.5}},
	{588.000, "BouncePlayerProxies",	{1.0}},
	{592.000, "BouncePlayerProxies",	{0.5}},
	{596.000, "BouncePlayerProxies",	{0.0}},

	{592.000, "CenterPlayerProxies",	{4}},
};

for beatIndex = 256,312,8 do
	messageList[#messageList + 1] = {beatIndex - 0.05, "HighTrail"}
	for subBeatIndex = 0,2.50,0.5 do
		messageList[#messageList + 1] = {beatIndex + subBeatIndex, "GhostProxiesPulse",		{1, 2}}
	end
	messageList[#messageList + 1] = {beatIndex + 3.00, "StartTrail"}
end


for beatIndex = 428,448,4 do
	local rotateStrength = RangeScale(beatIndex, 424, 448, 0, 30)
	messageList[#messageList + 1] = {beatIndex + 0.00, "RotateWholeField",		{1, 1, rotateStrength *  0.8}}
	messageList[#messageList + 1] = {beatIndex + 0.00, "RotateWholeField",		{1, 2, rotateStrength *  1.2}}
	messageList[#messageList + 1] = {beatIndex + 2.00, "RotateWholeField",		{1, 1, rotateStrength * -1.2}}
	messageList[#messageList + 1] = {beatIndex + 2.00, "RotateWholeField",		{1, 2, rotateStrength * -0.8}}
end

messageList = SortModsTable(messageList)

gfxUpdateFunction = function()
	-- Most things are determined by beat, believe it or not.		
	overtime = GAMESTATE:GetSongBeat() - visualOffset
	
	-- TODO: this assumes the effect applies over a constant BPM section!!
	BPS = GAMESTATE:GetSongBPS()
	
	-- Initializations
	if overtime >=   0.0 and not checked then
		for i,v in ipairs(plr) do
			if v then
				v:visible(false)
				 :x(sw/2)
--				 :y(sh/2 - 30)
				 :z(0)
			end
		end

		checked = true
	end
			
	-- Broadcast messages on their own terms.
	while true do
		if fgmsg < #messageList then
			messageBeat, messageName, messageArgs = unpack(messageList[fgmsg+1])
			if overtime >= messageBeat then			
				if messageArgs then
					MESSAGEMAN:Broadcast( messageName, messageArgs )
				else
					MESSAGEMAN:Broadcast( messageName )
				end
				
				fgmsg = fgmsg + 1
			else
				break
			end
		else
			break
		end
	end



	-- Disco feeling
	local discoController = discoScrAuxActor:getaux()

--	if discoScrAuxActor:getaux() > 0.1 then
--		Trace("$$$ discoScrAuxActor = "..discoScrAuxActor:getaux()..", discoParameter = "..discoParameter)
--	end

	if discoController > 0.0001 then 
		discoParameter = discoScrFunction(discoController)
		for i = 1,2 do
			for proxyIndex = 1,#DiscoProxies[i] do
				local theirTime = math.fmod(discoParameter + (proxyIndex + 0.5) / #DiscoProxies[i], 1)
				DiscoProxies[i][proxyIndex]:x(sw * (SideSign(i) * discoScreenCrop * (theirTime - 0.5) + 0.5))
			end
		end

		if discoCrowd then
			aftOutSprActor:x(sw*(0.5 + 0.003 * math.sin(2*PI*(discoController+0.01))))
		end
	else
		aftOutSprActor:x(sw*0.5)
	end


	-- Distress feeling
	local distressController = distressControllerAuxActor:getaux()
	if distressController > 0.0001 then
		for pn = 1,2 do
			local distressParameter = distressAuxActors[pn]:getaux()
			local distressingSin = math.sin(PI * distressParameter)
			local distressingAbs = math.abs(distressingSin)
			local distressingAlpha = RangeClamp(4 - 8*distressParameter, 0, 1)
			local ss = SideSign(pn)


			PlayerProxyActors[pn]
				:xy( sw * (0.5 + distressingSin * distressXScale * ss), sh * (0.5 + distressingAbs * distressYDisplace) )
				:zoom( 1 - distressingAbs * 0.7 )
				:rotationz( distressingSin * distressRotZMax * ss )
				:rotationx( distressingAbs * distressRotXMax )
			PlayerProxySprites[pn]
				:diffusealpha( distressingAlpha )				

		end
	end


	-- Emotional feeling
	DualUpdate()


--	Trace('Update @ ' .. GAMESTATE:GetSongBeat() .. " (" .. GAMESTATE:GetCurMusicSeconds() .. " sec.)")
end


-------------------------------------------------------------------------------
--
-- Messaging controller
--

local mmmDirections = {
	{
		{-48,   0},
		{  0,  48},
		{  0, -48},
		{ 48,   0},
	},
	{
		{-sw*0.9,       0},
		{      0,  sw*0.9},
		{      0, -sw*0.9},
		{ sw*0.9,       0},
	},
	{
		{-sw*1.0,       0},
		{      0,  sw*1.0},
		{      0, -sw*1.0},
		{ sw*1.0,       0},
	},
}

_FG_[#_FG_ + 1] = Def.ActorFrame {
	CrowdEngageMessageCommand = function(self, args)
		local engageTime	= (#args >= 1) and args[1] or 1
		for dwi = 1,2 do
			if DiscoWallsAMV[dwi] then
				for rowIndex = 1,stretchyRows do
					rowActor = DiscoWallsAMV[dwi]:GetChild("StretchyAMVStrip_" .. rowIndex)
					if rowActor then
						rowActor:finishtweening()
								:decelerate(engageTime / BPS)
								:SetVertices(DiscoWallsReset[rowIndex])
					end
				end

				if dwi == 1 then
					DiscoWallsAMV[dwi]:visible(true)
									  :decelerate(engageTime / BPS)
									  :diffuse(1.0, 1.0, 1.0, 1.0)
									  :y(sh * 0.5)
				else
					DiscoWallsAMV[dwi]:decelerate(engageTime / BPS)
									  :diffusealpha(0.0)
									  :y(sh * 0.5)
				end
			end
		end

		discoScrFunction = Scroller_Crowd
		discoCrowd = true
	end,

	CrowdTimeMessageCommand = function(self, args)
		discoStartTime 		= overtime
		discoTweenTime 		= (#args >= 1) and args[1] or 1
		discoProxyPeriod 	= (#args >= 2) and args[2] or 16

		if DiscoWallsAMV[2] then
			DiscoWallsAMV[2]:visible(false)
		end

		aftMemorySubstrate:zoom(1.003)
		aftOutSprActor:diffusealpha(0.995)
		ghostDudeActor:diffuse(1.0, 0.5, 0.5, 0.6)

	end,

	CrowdDisengageMessageCommand = function(self, args)
		local disengageTime	= (#args >= 1) and args[1] or 1
		for dwi = 1,2 do
			if DiscoWallsAMV[dwi] then
				DiscoWallsAMV[dwi]:finishtweening()
								  :accelerate(disengageTime / BPS)
								  :diffusealpha(0.0)
			end
		end

		aftMemorySubstrate:zoom(1.000)
		aftOutSprActor:diffusealpha(0.99)
		ghostDudeActor:finishtweening()
					  :decelerate(args[1] / BPS)
					  :diffusealpha(0.30)

		discoCrowd = false
	end,


	DiscoEngageMessageCommand = function(self, args)
		local engageTime	= (#args >= 1) and args[1] or 1
		for dwi = 1,2 do
			if DiscoWallsAMV[dwi] then
				for rowIndex = 1,stretchyRows do
					local rowActor = DiscoWallsAMV[dwi]:GetChild("StretchyAMVStrip_" .. rowIndex)
					if rowActor then
						rowActor:finishtweening()
								:decelerate(args[1] / BPS)
								:SetVertices(DiscoWallsPrefetch[dwi][rowIndex])
					end
				end

				if dwi == 1 then
					DiscoWallsAMV[dwi]:visible(true)
									  :decelerate(engageTime / BPS)
									  :diffuse(0.7, 0.7, 0.7, 1.0)
									  :y(sh * 0.6)
				else
					DiscoWallsAMV[dwi]:visible(true)
									  :decelerate(engageTime / BPS)
									  :diffuse(1.0, 1.0, 1.0, 1.0)
									  :y(sh * 1.0)
				end
			end
		end

		for rowIndex = 1,stretchyRows do
			local rowActor = aftMemorySubstrate:GetChild("StretchyAMVStrip_" .. rowIndex)
			if rowActor then
				rowActor:finishtweening()
						:decelerate(args[1] / BPS)
						:SetVertices(GhostWallsPrefetch[1][rowIndex])
			end
		end


		discoScrFunction = Scroller_Eleison
	end,

	DiscoTimeMessageCommand = function(self, args)
		discoStartTime 		= overtime
		discoTweenTime 		= (#args >= 1) and args[1] or 1
		discoProxyPeriod 	= (#args >= 2) and args[2] or 16

		if DiscoWallsAMV[2] then
			DiscoWallsAMV[2]:visible(true)
		end

		aftOutSprActor:diffusealpha(0.99)
		ghostDudeActor:diffuse(1.0, 1.0, 1.0, 0.5)
	end,

	DiscoDisengageMessageCommand = function(self, args)
		local disengageTime	= (#args >= 1) and args[1] or 1
		for dwi = 1,2 do
			if DiscoWallsAMV[dwi] then
				DiscoWallsAMV[dwi]:finishtweening()
								  :accelerate(disengageTime / BPS)
								  :diffusealpha(0.0)
			end
		end

		for rowIndex = 1,stretchyRows do
			local rowActor = aftMemorySubstrate:GetChild("StretchyAMVStrip_" .. rowIndex)
			if rowActor then
				rowActor:finishtweening()
						:decelerate(args[1] / BPS)
						:SetVertices(GhostWallsPrefetch[2][rowIndex])
			end
		end

		aftOutSprActor:diffusealpha(0.99)
		ghostDudeActor:finishtweening()
					  :decelerate(args[1] / BPS)
					  :diffusealpha(0.30)
	end,

--	KnifeKillMessageCommand = function(self, args)
--		pn = args[1]
--
--		knifeAllowInput[pn] = false 		-- I mean, obvs.
--
--		knifeRingActors[pn]
--			:finishtweening()
--			:queuecommand("GameKill")
--		knifeScoreContainers[pn]
--			:finishtweening()
--			:queuecommand("GameKill")
--	end,


	ResetMidscreenMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4

		for pn = 1,2 do
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:smooth(tweenTime / BPS)
				cv:GetPosHandler():SetSplineMode('NoteColumnSplineMode_Offset')
				cv:GetPosHandler():SetBeatsPerT(6)
				local splr = cv:GetPosHandler():GetSpline()
--				if splr:empty() then
--					Trace("### pos spline "..i.." is empty")
--				end
--				for sppi = 1,splr:GetSize() do
--					local b, c, d = splr:GetCoefficients(sppi)
--					Trace("### pos spline "..i.."."..sppi..": {"..b[1]..","..b[2]..","..b[3].."}, {"..c[1]..","..c[2]..","..c[3].."}, {"..d[1]..","..d[2]..","..d[3].."}")
--				end
				splr:SetSize(3)
				splr:SetPoint(1, {0, 0, 0})
				splr:SetPoint(2, {0, 0, 0})
				splr:SetPoint(3, {0, 0, 0})
				splr:Solve()
			end

--			if PlayerProxyActors[pn] then
--				PlayerProxyActors[pn]:smooth(tweenTime / BPS)
--									 :x(sw * 0.5 + sw * 0.25 * SideSign(pn))
--			end
		end
	end,
	BeginMidscreenMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4

		for pn = 1,2 do
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:smooth(tweenTime / BPS)
				cv:GetPosHandler():SetSplineMode('NoteColumnSplineMode_Offset')
				cv:GetPosHandler():SetBeatsPerT(6)
				local splr = cv:GetPosHandler():GetSpline()
				splr:SetSize(3)
				-- Requires 50% flip, ~50% reverse
				-- (not full 50% reverse or HOLDS JUST FUCKIN DISAPPEAR)
				-- (LIKE THEY AIN'T MEANT FOR THIS GREEN EARTH OR SOME SHIT)
				-- ($15 MINIMUM WAGE: NOT EVEN ONCE FOR YOU PIECES OF WORK)
				splr:SetPoint(1, {mmmDirections[1][i][1], mmmDirections[1][i][2],    0})
				splr:SetPoint(2, {mmmDirections[2][i][1], mmmDirections[2][i][2], -100})
				splr:SetPoint(3, {mmmDirections[3][i][1], mmmDirections[3][i][2],    0})
				splr:Solve()
			end

--			if PlayerProxyActors[pn] then
--				PlayerProxyActors[pn]:smooth(tweenTime / BPS)
--									 :x(sw * 0.5)
--			end
		end
	end,
	DisengagePosSplinesMessageCommand = function(self)
		for pn = 1,2 do
			local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
			local nf = pp:GetChild('NoteField')

			for i,cv in ipairs(nf:GetColumnActors()) do
				cv:GetPosHandler():SetSplineMode('NoteColumnSplineMode_Disabled')
			end
		end
	end,


	-- Control the rotation splines
	RotateWholeFieldMessageCommand = function(self, args)
		local tweenTime 	= (#args >= 1) and args[1] or 4
		local pn 			= (#args >= 2) and args[2] or 1
		local endingAngle 	= (#args >= 3) and args[3] or 0

		local pp = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
		local nf = pp:GetChild('NoteField')

		for i,cv in ipairs(nf:GetColumnActors()) do
			cv:smooth(tweenTime / BPS)
			cv:GetRotHandler():SetSplineMode('NoteColumnSplineMode_Offset')
			cv:GetRotHandler():SetBeatsPerT(1.3 - i * 0.2)
			local splr = cv:GetRotHandler():GetSpline()
			splr:SetSize(2)
			splr:SetPoint(1, {0, 0, -endingAngle * DEG_TO_RAD})
			splr:SetPoint(2, {0, 0, -endingAngle * DEG_TO_RAD})
			splr:Solve()
		end

--		if PlayerProxyActors[pn] then
--			PlayerProxyActors[pn]:smooth(tweenTime/BPS)
--								 :rotationz(endingAngle)
--		end
	end,


	DistressIssueMessageCommand = function(self, args)
		local duration 		= (#args >= 1) and args[1] or 8
		local playerToFront = (#args >= 2) and args[2] or 1

		distressAuxActors[    playerToFront]:decelerate(duration / BPS)
											:aux(0.5)
		distressAuxActors[3 - playerToFront]:decelerate(duration / BPS)
											:aux(0.5)
	end,

	DistressBounceMessageCommand = function(self, args)	
		local duration 		= (#args >= 1) and args[1] or 8
		local playerToFront = (#args >= 2) and args[2] or 1

		distressAuxActors[    playerToFront]:decelerate(duration / BPS)
											:aux(0)
		distressAuxActors[3 - playerToFront]:decelerate(duration / BPS)
											:aux(1)
	end,
}


-- Perframe controller
_FG_[#_FG_ + 1] = Def.ActorFrame {
	InitCommand = function(self)
		self:SetUpdateFunction(gfxUpdateFunction)
	end,

	Def.ActorFrame {
		InitCommand = function(self)
			self:sleep(69420)
		end
	}
}

modsTable_PUTMEBACK = {
}


-- Load the mods table parser into this script.
modsTable = {
	-- [1]: beat start
	-- [2]: mod type
	-- [3]: mod strength (out of unity),
	-- [4]: mod approach (in beats to complete)
	-- [5]: player application (1 = P1, 2 = P2, 3 = both, 0 = neither)
		
		{   0.0,	"ScrollSpeed",		niceSpeed,    8.0,	3}, 
		{   0.0,	"Dark",					  0.2,    8.0,	3}, 

		{   0.0,	"Dark",					  1.0,    0.0,	3}, 
		{   0.0,	"Mini",					 -3.0,    0.0,	3},
		{   0.0,	"Split",				 -0.4,    0.0,	3},
		{   0.0,	"Alternate",			  0.4,    0.0,	3},
		{   0.0,	"Reverse",				  0.5,    0.0,	3},

		{   0.0,	"Drunk",				 -2.0,    0.0,	1},
		{   0.0,	"Drunk",				  2.0,    0.0,	2},
		{   0.0,	"Tipsy",				  1.0,   16.0,	3},
		{   0.0,	"Confusion",			  2.0,    0.0,	1},
		{   0.0,	"Confusion",			 -2.0,    0.0,	2},
		{   4.0,	"Mini",					  0.0,   32.0,	3}, 
		{   4.0,	"Dark",					  0.0,   32.0,	3}, 
--		{   4.0,	"Drunk",				  0.0,   32.0,	3},
		{   4.0,	"Drunk",				  1.0,   32.0,	3},
		{   4.0,	"Confusion",			  0.0,   32.0,	3},
		{  32.0,	"Tipsy",				  0.2,    4.0,	3},
		{  32.0,	"Split",				  0.0,    4.0,	3},
		{  32.0,	"Alternate",			  0.0,    4.0,	3},
		{  32.0,	"Reverse",				  0.0,    4.0,	3},
		{  32.0,	"Wave",					  0.5,    4.0,	3},


		{  36.0,	"Wave",					  1.5,   32.0,	3},


		{  35.8,	"Tilt",					  1.5,    0.2,	3},
		{  39.8,	"Stealth",				  0.5,    0.2,	3},
		{  39.8,	"Tiny",					 -1.0,    0.2,	3},
		{  40.0,	"Tilt",					  0.0,    2.0,	3},
		{  40.0,	"Stealth",				  0.0,    2.0,	3},
		{  40.0,	"Tiny",					  0.0,    2.0,	3},
		{  43.8,	"Tilt",					 -1.5,    0.2,	3},
		{  47.8,	"Stealth",				  0.5,    0.2,	3},
		{  47.8,	"Tiny",					 -1.0,    0.2,	3},
		{  48.0,	"Tilt",					  0.0,    2.0,	3},
		{  48.0,	"Stealth",				  0.0,    2.0,	3},
		{  48.0,	"Tiny",					  0.0,    2.0,	3},
		{  51.8,	"Tilt",					  1.5,    0.2,	3},
		{  55.8,	"Stealth",				  0.5,    0.2,	3},
		{  55.8,	"Tiny",					 -1.0,    0.2,	3},
		{  56.0,	"Tilt",					  0.0,    2.0,	3},
		{  56.0,	"Stealth",				  0.0,    2.0,	3},
		{  56.0,	"Tiny",					  0.0,    2.0,	3},
		{  59.8,	"Tilt",					 -1.5,    0.2,	3},
		{  63.8,	"Stealth",				  0.5,    0.2,	3},
		{  63.8,	"Tiny",					 -1.0,    0.2,	3},
		{  64.0,	"Tilt",					  0.0,    2.0,	3},
		{  64.0,	"Stealth",				  0.0,    2.0,	3},
		{  64.0,	"Tiny",					  0.0,    2.0,	3},




	-- Precrowd prep
		{  64.0,	"Wave",					 -0.5,    4.0,	1},		
		{  64.0,	"Wave",					  0.5,    4.0,	2},
		{  64.0,	"ScrollSpeed",		painSpeed,    4.0,	3}, 
		{  64.0,	"Drunk",				  0.0,    4.0,	3},
		{  64.0,	"Beat",					  2.0,    4.0,	3},
		{  64.0,	"Centered",				 -0.5,    4.0,	3},

		{  68.0,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},
		{  71.5,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},
		{  72.0,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},
		{  75.5,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},
		{  76.0,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},
		{  77.0,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},
		{  78.0,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},
		{  79.0,	"Centered",	1.6*painSpeed-0.5,    4.0,	3},

		{  71.45,	"Centered",				 -0.5,    0.0,	3},
		{  71.95,	"Centered",				 -0.5,    0.0,	3},
		{  75.45,	"Centered",				 -0.5,    0.0,	3},
		{  75.95,	"Centered",				 -0.5,    0.0,	3},
		{  76.95,	"Centered",				 -0.5,    0.0,	3},
		{  77.95,	"Centered",				 -0.5,    0.0,	3},
		{  78.95,	"Centered",				  0.0,    0.0,	3},


		{  80.0,	"ScrollSpeed",		niceSpeed,    4.0,	3}, 
		{  80.0,	"Beat",					  0.0,    4.0,	3},
		{  80.0,	"Wave",					  0.0,    4.0,	3},
		{  80.0,	"Tipsy",				  0.0,    4.0,	3},


	-- Crowdsourcing
		{  80.0,	"Tiny",			  discoTinify,    4.0,	3}, 
		{  80.0,	"Centered",				 -0.4,    4.0,	3}, 
		{  80.0,	"Reverse",				  1.0,    4.0,	0},

		{ 146.0,	"Tiny",			  	 	  0.0,    2.0,	3}, 
--		{ 146.0,	"Centered",				  0.0,    2.0,	3}, 
		{ 146.0,	"Reverse",				  0.0,    2.0,	2}, 


	-- Midscreen work
		{ 146.0,	"ScrollSpeed",		painSpeed,    2.0,	3}, 
		{ 146.0,	"Expand",				  0.7,    2.0,	3},

		{ 146.0,	"Cross",				  1.0,    2.0,	3}, 
		{ 146.0,	"Centered",				  1.0,    2.0,	3}, 
--		{ 146.0,	"Bumpy",				  0.05,   2.0,	3}, 

		{ 163.0,	"Cross",				 -1.0,    1.0,	3}, 
		{ 163.0,	"Reverse",				  1.0,    1.0,	3}, 
		{ 163.0,	"Centered",				  1.0,    1.0,	3}, 

		{ 179.0,	"Cross",				  0.0,    1.0,	3}, 
		{ 179.0,	"Reverse",				  0.0,    1.0,	3}, 
		{ 179.0,	"Centered",				  0.0,    1.0,	3}, 
		{ 179.0,	"ScrollSpeed",		niceSpeed,    1.0,	3}, 

		{ 176.0,	"Expand",				  0.0,    4.0,	3},
	--	{ 176.0,	"Bumpy",				  0.0,    4.0,	3}, 

	-- ``Hardstyle``	
		{ 176.0,	"Wave",					  1.0,    4.0,	3},
		{ 179.0,	"Bumpy",				  1.0,    1.0,	3}, 
		{ 211.0,	"Bumpy",				  0.0,    1.0,	3}, 
		{ 211.0,	"Wave",					  0.0,    1.0,	3},

	-- ``Breakbeat``
		{ 211.0,	"Centered",				 -0.5,    1.0,	3}, 


		{ 211.0,	"Drunk",				  0.5,    4.0,	3}, 
		{ 211.0,	"Drunk",				 -0.5,    4.0,	3}, 
		{ 211.0,	"Tipsy",				  0.5,    4.0,	3}, 
		{ 211.0,	"Tipsy",				 -0.5,    4.0,	3}, 

		{ 211.0,	"Dark",					  1.0,    1.0,	1}, 
		{ 211.0,	"Stealth",				  1.0,    1.0,	1}, 
		{ 211.0,	"Sudden",				  1.0,    1.0,	1}, 
		{ 211.0,	"SuddenOffset",			 -1.0,    1.0,	1}, 
		{ 212.0,	"Reverse",				  1.0,    1.0,	1},
		{ 216.0,	"SuddenOffset",			  1.0,    4.0,	2}, 

		{ 239.0,	"Reverse",				  0.0,    1.0,	3},
		{ 243.0,	"Dark",					  0.0,    1.0,	3}, 
		{ 243.0,	"Stealth",				  0.0,    1.0,	3}, 
		{ 243.0,	"Centered",				  0.5,    1.0,	3}, 
		{ 244.0,	"Sudden",				  0.0,    0.0,	3},
		{ 244.0,	"SuddenOffset",			  0.0,    0.0,	3}, 

		{ 244.0,	"Drunk",				  0.0,    0.0,	3}, 
		{ 244.0,	"Tipsy",				  0.0,    0.0,	3}, 

	-- yeet	
		{ 245.50,	"Centered",				  0.2,    0.5,	1},
		{ 245.50,	"Tiny",					 -3.0,    0.5,	2},
		{ 245.50,	"Stealth",				  1.0,    0.5,	2},
		{ 245.50,	"Centered",				 -1.0,    0.5,	2},
		{ 246.00,	"Centered",				  0.2,    0.0,	1},
		{ 246.00,	"Tiny",					  0.0,    0.0,	2},
		{ 246.00,	"Stealth",				  0.0,    0.5,	2},
		{ 246.10,	"Centered",				  0.0,    1.0,	3},

		{ 247.00,	"Centered",				  0.2,    0.5,	2},
		{ 247.00,	"Tiny",					 -3.0,    0.5,	1},
		{ 247.00,	"Stealth",				  1.0,    0.5,	1},
		{ 247.00,	"Centered",				 -1.0,    0.5,	1},
		{ 247.50,	"Centered",				  0.2,    0.0,	2},
--		{ 247.50,	"Tiny",					  0.0,    0.0,	1},
		{ 247.50,	"Stealth",				  0.0,    0.5,	1},
--		{ 247.60,	"Centered",				  0.0,    1.0,	3},
		{ 247.60,	"Centered",				 -0.3,    1.0,	3},

		{ 247.50,	"Flip",					  0.5,    0.5,	3},
		{ 247.50,	"Mini",					  0.3,    0.5,	3},
		{ 247.50,	"Tiny",					  0.3,    0.5,	3},
		{ 251.00,	"Flip",					  0.0,    1.0,	3},
		{ 251.00,	"Mini",					  0.5,    1.0,	3},
		{ 251.00,	"Tiny",					  0.0,    1.0,	3},

	-- Distress chromatics 
		{ 251.00,	"ScrollSpeed",		distSpeed,    1.0,	3}, 
		{ 251.00,	"Twirl",				  0.8,    1.0,	1},	
		{ 251.00,	"Twirl",				 -0.8,    1.0,	2},	
		{ 251.00,	"Roll",					  0.8,    1.0,	3},	

		{ 315.00,	"Twirl",				  0.0,    1.0,	3},	
		{ 315.00,	"Roll",					  0.0,    1.0,	3},	



	-- "We get down. Low."
		{ 315.00,	"Mini",					  0.0,    1.0,	3},
		{ 315.00,	"ScrollSpeed",		low1Speed,    1.0,	3}, 
		{ 315.00,	"Centered",				  0.0,    1.0,	3},
		{ 315.00,	"Reverse",				  0.0,    1.0,	3},

		{ 323.80,	"Centered",				  1.6,    1.0,	3},
		{ 323.80,	"Reverse",				  0.1,    1.0,	3},
		{ 327.80,	"Centered",				  2.4,    1.0,	3},
		{ 327.80,	"Reverse",				  0.15,   1.0,	3},
		{ 330.00,	"Centered",				  3.6,    1.0,	3},
		{ 330.00,	"Reverse",				  0.2,    1.0,	3},


		{ 330.00,	"ScrollSpeed",		painSpeed,    1.0,	3}, 

	-- Eleison disco
		{ 331.0,	"Stealth",				  1.0,	  0.75, 3},
		{ 331.0,	"Dark",					  1.0,	  0.75, 3},
		{ 331.9,	"Tiny",			  discoTinify,    0.0,	3}, 
		{ 331.9,	"Centered",				 -0.4,    0.0,	3}, 
		{ 331.9,	"Reverse",				  0.0,    0.0,	3},
		{ 331.95,	"Stealth",				  0.5,	  0.0,  3},
		{ 331.95,	"Dark",					  0.0,	  0.0,  3},
		{ 332.0,	"Stealth",				  0.0,	 32.0,  3},
		{ 332.0,	"Dark",					  0.2,	 32.0,  3},
		{ 364.0,	"Stealth",				  0.5,	 24.0,  3},
		{ 364.0,	"Dark",					  0.0,	 24.0,  3},

		{ 388.0,	"Tiny",			  	 	  0.0,    8.0,	3}, 
		{ 388.0,	"Centered",				  0.0,    8.0,	3}, 
--		{ 388.0,	"Reverse",				  0.0,    8.0,	2},
		{ 388.0,	"Stealth",				  0.0,	  8.0,  3},
		{ 388.0,	"Dark",					  0.2,	  8.0,  3}, 

	-- Some glitches happen here

	-- ...

	-- Return to crowdsourcing		
		{ 425.9,	"ScrollSpeed",		low2Speed,    0.0,	3}, 
		{ 426.0,	"ScrollSpeed",		niceSpeed,    4.0,	3}, 

		{ 428.0,	"ScrollSpeed",		painSpeed,   24.0,	3}, 
		{ 428.0,	"Beat",					  1.0,   24.0,	3},
		{ 428.0,	"Expand",				 -0.7,   24.0,	2},		
		{ 428.0,	"Expand",				  0.7,   24.0,	1},
	
		{ 452.0,	"Tiny",					 -2.0,    8.0,	3},
		{ 452.0,	"Flip",					 -1.0,    8.0,	3},
		{ 456.0,	"Stealth",				  1.0,    4.0,	3},
		{ 456.0,	"Dark",					  1.0,    4.0,	3},
		{ 460.0,	"Stealth",				  0.0,    4.0,	3},
		{ 464.0,	"Dark",					  0.0,    4.0,	3},
		{ 460.0,	"Beat",					  0.0,    4.0,	3},

		{ 464.0,	"ScrollSpeed",		niceSpeed,    4.0,	3}, 
		{ 464.0,	"Expand",				  0.0,    4.0,	3},
		{ 464.0,	"Flip",					  0.0,    4.0,	3},


	-- Crowdsourcing again
		{ 464.0,	"Tiny",			  discoTinify,    4.0,	3}, 
		{ 464.0,	"Centered",				 -0.4,    4.0,	3}, 
		{ 464.0,	"Reverse",				  1.0,    4.0,	0},

		{ 530.0,	"Tiny",			  	 	  0.0,    2.0,	3}, 
		{ 530.0,	"Centered",				  0.0,    2.0,	3}, 
		{ 530.0,	"Reverse",				  0.0,    2.0,	2}, 


	-- Midscreen work again
		{ 530.0,	"ScrollSpeed",		painSpeed,    2.0,	3}, 
		{ 530.0,	"Expand",				  0.7,    2.0,	3},

		{ 530.0,	"Cross",				  1.0,    2.0,	3}, 
		{ 530.0,	"Centered",				  1.0,    2.0,	3}, 
--		{ 530.0,	"Bumpy",				  0.05,   2.0,	3}, 

		{ 547.0,	"Cross",				 -1.0,    1.0,	3}, 
		{ 547.0,	"Reverse",				  1.0,    1.0,	3}, 
		{ 547.0,	"Centered",				  1.0,    1.0,	3}, 

		{ 563.0,	"Cross",				  0.0,    1.0,	3}, 
		{ 563.0,	"Reverse",				  0.0,    1.0,	3}, 
		{ 563.0,	"Centered",				  0.0,    1.0,	3}, 
		{ 563.0,	"ScrollSpeed",		niceSpeed,    1.0,	3}, 

		{ 560.0,	"Expand",				  0.0,    4.0,	3},
	--	{ 176.0,	"Bumpy",				  0.0,    4.0,	3}, 

	-- ``Hardstyle`` again
		{ 560.0,	"Wave",					  1.0,    4.0,	3},
		{ 563.0,	"Bumpy",				  1.0,    1.0,	3}, 
		{ 564.0,	"Mini",					 -1.0,   32.0,	3}, 
		{ 564.0,	"ScrollSpeed",		low1Speed,   32.0,	3}, 
		{ 595.0,	"Bumpy",				  0.0,    1.0,	3}, 
		{ 595.0,	"Wave",					  0.0,    1.0,	3},


	-- End
		{ 596.0,	"Dark",					  1.0,   12.0,	3}, 
		{ 596.0,	"Mini",					 -3.0,   12.0,	3},
		{ 596.0,	"Split",				 -0.4,   12.0,	3},
		{ 596.0,	"Alternate",			  0.4,   12.0,	3},
		{ 596.0,	"Reverse",				  0.5,   12.0,	3},

		{ 596.0,	"Drunk",				 -2.0,   12.0,	1},
		{ 596.0,	"Drunk",				  2.0,   12.0,	2},
		{ 596.0,	"Tipsy",				  1.0,   12.0,	3},
		{ 596.0,	"Confusion",			  0.2,    0.0,	1},
		{ 596.0,	"Confusion",			 -0.2,    0.0,	2},
		{ 597.0,	"Confusion",			  0.0,   12.0,	3},
}


function AddURShift(playerNumber, beatIndex, duration, shiftU, shiftR)
	local i =  0.75 * shiftU - 0.25 * shiftR
	local f = -0.25 * shiftU - 0.25 * shiftR

	modsTable[#modsTable + 1] = {beatIndex,	"Flip",     f,	duration,	playerNumber}
	modsTable[#modsTable + 1] = {beatIndex,	"Invert",   i,	duration,	playerNumber}
end

-- Opening
AddURShift(1,   0.00,   0.00, -0.5, -0.5)
AddURShift(2,   0.00,   0.00, -0.5, -0.5)
AddURShift(1,  32.00,   4.00,  0  ,  0  )
AddURShift(2,  32.00,   4.00,  0  ,  0  )

-- Thump thump
AddURShift(1,  37.00,   1.00,  0  ,  1  )
AddURShift(2,  37.00,   1.00,  1  ,  2  )
AddURShift(3,  42.00,   2.00,  0  ,  0  )
AddURShift(1,  45.00,   1.00,  2  ,  2  )
AddURShift(3,  50.00,   2.00,  0  ,  0  )

AddURShift(1,  53.00,   1.00,  2  , -1  )
AddURShift(2,  53.00,   1.00,  1  ,  2  )
AddURShift(3,  58.00,   2.00,  0  ,  0  )
AddURShift(1,  59.00,   1.00,  2  ,  2  )
AddURShift(2,  59.00,   1.00,  0  , -3  )
AddURShift(3,  66.00,   2.00,  0  ,  0  )

-- ``Hardstyle``
for beatIndex = 180,204,8 do
	AddURShift(3, beatIndex +  0.00,  1.00, -1  ,  0  )		-- L U D R
	AddURShift(3, beatIndex +  1.00,  1.00, -2  , -1  )		-- U L R D
	AddURShift(3, beatIndex +  2.00,  1.00, -2  , -2  )		-- U R L D
	AddURShift(3, beatIndex +  3.00,  1.00, -1  , -3  )		-- R U D L
	AddURShift(3, beatIndex +  4.00,  1.00,  0  , -3  )		-- R D U L
	AddURShift(3, beatIndex +  5.00,  1.00,  1  , -2  )		-- D R L U
	AddURShift(3, beatIndex +  6.00,  1.00,  1  , -1  )		-- D L R U
	AddURShift(3, beatIndex +  7.00,  1.00,  0  ,  0  )		-- L D U R
end

-- ``Breakbeat``
function AddSuddenSlide(beatIndex, newVisiblePlayer)
	modsTable[#modsTable + 1] = { beatIndex + 0.00,	"Sudden",		  1.0,    1.0,	3 - newVisiblePlayer}
	modsTable[#modsTable + 1] = { beatIndex + 0.00,	"Stealth",		  0.0,    1.0,	    newVisiblePlayer}
	modsTable[#modsTable + 1] = { beatIndex + 0.00,	"Dark",			  0.0,    4.0,	    newVisiblePlayer}
	modsTable[#modsTable + 1] = { beatIndex + 0.00,	"SuddenOffset",	  1.0,    4.0,	    newVisiblePlayer}
	modsTable[#modsTable + 1] = { beatIndex + 1.00,	"SuddenOffset",	 -1.0,    3.0,	3 - newVisiblePlayer}
	modsTable[#modsTable + 1] = { beatIndex + 1.00,	"Dark",			  1.0,    3.0,	3 - newVisiblePlayer}
	modsTable[#modsTable + 1] = { beatIndex + 1.00,	"Stealth",		  1.0,    3.0,	3 - newVisiblePlayer}
	modsTable[#modsTable + 1] = { beatIndex + 3.00,	"Sudden",		  0.0,    1.0,	    newVisiblePlayer}
end
AddSuddenSlide(216, 1)
AddSuddenSlide(224, 2)
AddSuddenSlide(232, 1)
AddSuddenSlide(240, 2)


-- Distress chromatics
for beatIndex = 252,308,8 do
	local modStrength 	= RangeScale(beatIndex, 252, 316, 0.5, 1.5)

	for subBeatIndex = 0,3 do
		local modDirection 	= SideSign(subBeatIndex % 2)

		modsTable[#modsTable + 1] = { beatIndex + subBeatIndex - 0.05,	"Tipsy",		  modStrength*modDirection,    0.0,	3}
		modsTable[#modsTable + 1] = { beatIndex + subBeatIndex - 0.05,	"Drunk",	  0.5*modStrength*modDirection,    0.0,	3}

		modsTable[#modsTable + 1] = { beatIndex + subBeatIndex + 0.00,	"Tipsy",		  0.0,    1.0,	3}
		modsTable[#modsTable + 1] = { beatIndex + subBeatIndex + 0.00,	"Drunk",		  0.0,    1.0,	3}
	end
end


-- Crowdsourcing 
for beatIndex = 84,140,8 do
	local shiftU = (beatIndex >= 116) and 2 or 0
	local shiftR = (beatIndex >= 116) and 2 or 1

	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Reverse",  1.0,    1.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Reverse",  0.0,    1.0,	2}
	AddURShift(3, beatIndex + 2.00, 0.50, shiftU, shiftR)
	AddURShift(3, beatIndex + 2.50, 0.50,      0,      0)
	AddURShift(3, beatIndex + 3.00, 0.50, shiftU, shiftR)
	AddURShift(3, beatIndex + 3.50, 0.50,      0,      0)
	modsTable[#modsTable + 1] = {beatIndex + 4.00,	"Reverse",  1.0,    1.0,	2} 
	modsTable[#modsTable + 1] = {beatIndex + 5.00,	"Reverse",  0.0,    1.0,	1}
	if beatIndex + 6.00 < 146.00 then
		AddURShift(3, beatIndex + 6.00, 0.50, shiftU, shiftR)
		AddURShift(3, beatIndex + 6.50, 0.50,      0,      0)
		AddURShift(3, beatIndex + 7.00, 0.50, shiftU, shiftR)
		AddURShift(3, beatIndex + 7.50, 0.50,      0,      0)
	end
end


-- Eleison

-- edit: haha FUCK no this is so dumb
-- AddURShift(3, 348.00,   0.00,  0  ,  1  )
-- AddURShift(3, 364.00,   0.00,  1  ,  2  )
-- AddURShift(3, 380.00,   0.00,  2  ,  2  )
-- AddURShift(3, 388.00,   8.00,  0  ,  0  )


-- Crowdsourcing, again
for beatIndex = 468,524,8 do
	local shiftU = (beatIndex >= 500) and 2 or 0
	local shiftR = (beatIndex >= 500) and 2 or 1

	modsTable[#modsTable + 1] = {beatIndex + 0.00,	"Reverse",  1.0,    1.0,	1} 
	modsTable[#modsTable + 1] = {beatIndex + 1.00,	"Reverse",  0.0,    1.0,	2}
	AddURShift(3, beatIndex + 2.00, 0.50, shiftU, shiftR)
	AddURShift(3, beatIndex + 2.50, 0.50,      0,      0)
	AddURShift(3, beatIndex + 3.00, 0.50, shiftU, shiftR)
	AddURShift(3, beatIndex + 3.50, 0.50,      0,      0)
	modsTable[#modsTable + 1] = {beatIndex + 4.00,	"Reverse",  1.0,    1.0,	2} 
	modsTable[#modsTable + 1] = {beatIndex + 5.00,	"Reverse",  0.0,    1.0,	1}
	if beatIndex + 6.00 < 530.00 then
		AddURShift(3, beatIndex + 6.00, 0.50, shiftU, shiftR)
		AddURShift(3, beatIndex + 6.50, 0.50,      0,      0)
		AddURShift(3, beatIndex + 7.00, 0.50, shiftU, shiftR)
		AddURShift(3, beatIndex + 7.50, 0.50,      0,      0)
	end
end

-- ``Hardstyle``, again
for beatIndex = 564,588,8 do
	AddURShift(3, beatIndex +  0.00,  1.00, -1  ,  0  )		-- L U D R
	AddURShift(3, beatIndex +  1.00,  1.00,  0  ,  0  )		-- L D U R
	AddURShift(3, beatIndex +  2.00,  1.00,  1  , -1  )		-- D L R U
	AddURShift(3, beatIndex +  3.00,  1.00,  1  , -2  )		-- D R L U
	AddURShift(3, beatIndex +  4.00,  1.00,  0  , -3  )		-- R D U L
	AddURShift(3, beatIndex +  5.00,  1.00, -1  , -3  )		-- R U D L
	AddURShift(3, beatIndex +  6.00,  1.00, -2  , -2  )		-- U R L D
	AddURShift(3, beatIndex +  7.00,  1.00, -2  , -1  )		-- U L R D
end

-- Closing
AddURShift(3, 596.00,  12.00, -0.5, -0.5)

modsTable = SortModsTable(modsTable)
_FG_[#_FG_ + 1] = LoadActor("./modsHQ.lua", {modsTable, 0})



return _FG_
